/* valaccodeenum.c generated by valac, the Vala compiler
 * generated from valaccodeenum.vala, do not modify */

/* valaccodeenum.vala
 *
 * Copyright (C) 2006-2008  Jürg Billeter
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Jürg Billeter <j@bitron.ch>
 */


#include <glib.h>
#include <glib-object.h>
#include "valaccode.h"
#include <stdlib.h>
#include <string.h>
#include <valagee.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_iterable_unref0(var) ((var == NULL) ? NULL : (var = (vala_iterable_unref (var), NULL)))
#define _vala_ccode_node_unref0(var) ((var == NULL) ? NULL : (var = (vala_ccode_node_unref (var), NULL)))

struct _ValaCCodeEnumPrivate {
	gchar* _name;
	ValaList* values;
};


static gpointer vala_ccode_enum_parent_class = NULL;

#define VALA_CCODE_ENUM_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALA_TYPE_CCODE_ENUM, ValaCCodeEnumPrivate))
static void vala_ccode_enum_real_write (ValaCCodeNode* base,
                                 ValaCCodeWriter* writer);
static void vala_ccode_enum_finalize (ValaCCodeNode * obj);


ValaCCodeEnum*
vala_ccode_enum_construct (GType object_type,
                           const gchar* name)
{
	ValaCCodeEnum* self = NULL;
	self = (ValaCCodeEnum*) vala_ccode_node_construct (object_type);
	vala_ccode_enum_set_name (self, name);
	return self;
}


ValaCCodeEnum*
vala_ccode_enum_new (const gchar* name)
{
	return vala_ccode_enum_construct (VALA_TYPE_CCODE_ENUM, name);
}


/**
 * Adds the specified value to this enum.
 *
 * @param value optional numerical value
 */
void
vala_ccode_enum_add_value (ValaCCodeEnum* self,
                           ValaCCodeEnumValue* value)
{
	ValaList* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (value != NULL);
	_tmp0_ = self->priv->values;
	vala_collection_add ((ValaCollection*) _tmp0_, value);
}


static gpointer
_vala_iterable_ref0 (gpointer self)
{
	return self ? vala_iterable_ref (self) : NULL;
}


static void
vala_ccode_enum_real_write (ValaCCodeNode* base,
                            ValaCCodeWriter* writer)
{
	ValaCCodeEnum * self;
	const gchar* _tmp0_;
	gboolean first = FALSE;
	gboolean _tmp14_;
	const gchar* _tmp15_;
	ValaCCodeModifiers _tmp17_;
	ValaCCodeModifiers _tmp18_;
	self = (ValaCCodeEnum*) base;
	g_return_if_fail (writer != NULL);
	_tmp0_ = self->priv->_name;
	if (_tmp0_ != NULL) {
		vala_ccode_writer_write_string (writer, "typedef ");
	}
	vala_ccode_writer_write_string (writer, "enum ");
	vala_ccode_writer_write_begin_block (writer);
	first = TRUE;
	{
		ValaList* _value_list = NULL;
		ValaList* _tmp1_;
		ValaList* _tmp2_;
		gint _value_size = 0;
		ValaList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _value_index = 0;
		_tmp1_ = self->priv->values;
		_tmp2_ = _vala_iterable_ref0 (_tmp1_);
		_value_list = _tmp2_;
		_tmp3_ = _value_list;
		_tmp4_ = vala_collection_get_size ((ValaCollection*) _tmp3_);
		_tmp5_ = _tmp4_;
		_value_size = _tmp5_;
		_value_index = -1;
		while (TRUE) {
			gint _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			ValaCCodeEnumValue* value = NULL;
			ValaList* _tmp9_;
			gint _tmp10_;
			gpointer _tmp11_;
			gboolean _tmp12_;
			ValaCCodeEnumValue* _tmp13_;
			_tmp6_ = _value_index;
			_value_index = _tmp6_ + 1;
			_tmp7_ = _value_index;
			_tmp8_ = _value_size;
			if (!(_tmp7_ < _tmp8_)) {
				break;
			}
			_tmp9_ = _value_list;
			_tmp10_ = _value_index;
			_tmp11_ = vala_list_get (_tmp9_, _tmp10_);
			value = (ValaCCodeEnumValue*) _tmp11_;
			_tmp12_ = first;
			if (!_tmp12_) {
				vala_ccode_writer_write_string (writer, ",");
				vala_ccode_writer_write_newline (writer);
			}
			vala_ccode_writer_write_indent (writer, NULL);
			_tmp13_ = value;
			vala_ccode_node_write ((ValaCCodeNode*) _tmp13_, writer);
			first = FALSE;
			_vala_ccode_node_unref0 (value);
		}
		_vala_iterable_unref0 (_value_list);
	}
	_tmp14_ = first;
	if (!_tmp14_) {
		vala_ccode_writer_write_newline (writer);
	}
	vala_ccode_writer_write_end_block (writer);
	_tmp15_ = self->priv->_name;
	if (_tmp15_ != NULL) {
		const gchar* _tmp16_;
		vala_ccode_writer_write_string (writer, " ");
		_tmp16_ = self->priv->_name;
		vala_ccode_writer_write_string (writer, _tmp16_);
	}
	_tmp17_ = vala_ccode_node_get_modifiers ((ValaCCodeNode*) self);
	_tmp18_ = _tmp17_;
	if ((_tmp18_ & VALA_CCODE_MODIFIERS_DEPRECATED) == VALA_CCODE_MODIFIERS_DEPRECATED) {
		vala_ccode_writer_write_string (writer, " G_GNUC_DEPRECATED");
	}
	vala_ccode_writer_write_string (writer, ";");
	vala_ccode_writer_write_newline (writer);
}


const gchar*
vala_ccode_enum_get_name (ValaCCodeEnum* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_name;
	result = _tmp0_;
	return result;
}


void
vala_ccode_enum_set_name (ValaCCodeEnum* self,
                          const gchar* value)
{
	gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->_name);
	self->priv->_name = _tmp0_;
}


static void
vala_ccode_enum_class_init (ValaCCodeEnumClass * klass)
{
	vala_ccode_enum_parent_class = g_type_class_peek_parent (klass);
	((ValaCCodeNodeClass *) klass)->finalize = vala_ccode_enum_finalize;
	g_type_class_add_private (klass, sizeof (ValaCCodeEnumPrivate));
	((ValaCCodeNodeClass *) klass)->write = (void (*) (ValaCCodeNode *, ValaCCodeWriter*)) vala_ccode_enum_real_write;
}


static void
vala_ccode_enum_instance_init (ValaCCodeEnum * self)
{
	GEqualFunc _tmp0_;
	ValaArrayList* _tmp1_;
	self->priv = VALA_CCODE_ENUM_GET_PRIVATE (self);
	_tmp0_ = g_direct_equal;
	_tmp1_ = vala_array_list_new (VALA_TYPE_CCODE_ENUM_VALUE, (GBoxedCopyFunc) vala_ccode_node_ref, (GDestroyNotify) vala_ccode_node_unref, _tmp0_);
	self->priv->values = (ValaList*) _tmp1_;
}


static void
vala_ccode_enum_finalize (ValaCCodeNode * obj)
{
	ValaCCodeEnum * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALA_TYPE_CCODE_ENUM, ValaCCodeEnum);
	_g_free0 (self->priv->_name);
	_vala_iterable_unref0 (self->priv->values);
	VALA_CCODE_NODE_CLASS (vala_ccode_enum_parent_class)->finalize (obj);
}


/**
 * Represents an enum in the C code.
 */
GType
vala_ccode_enum_get_type (void)
{
	static volatile gsize vala_ccode_enum_type_id__volatile = 0;
	if (g_once_init_enter (&vala_ccode_enum_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ValaCCodeEnumClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_ccode_enum_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaCCodeEnum), 0, (GInstanceInitFunc) vala_ccode_enum_instance_init, NULL };
		GType vala_ccode_enum_type_id;
		vala_ccode_enum_type_id = g_type_register_static (VALA_TYPE_CCODE_NODE, "ValaCCodeEnum", &g_define_type_info, 0);
		g_once_init_leave (&vala_ccode_enum_type_id__volatile, vala_ccode_enum_type_id);
	}
	return vala_ccode_enum_type_id__volatile;
}



