/* valaccodemacroreplacement.c generated by valac, the Vala compiler
 * generated from valaccodemacroreplacement.vala, do not modify */

/* valaccodemacroreplacement.vala
 *
 * Copyright (C) 2006-2009  Jürg Billeter
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Jürg Billeter <j@bitron.ch>
 */


#include <glib.h>
#include <glib-object.h>
#include "valaccode.h"
#include <stdlib.h>
#include <string.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_ccode_node_unref0(var) ((var == NULL) ? NULL : (var = (vala_ccode_node_unref (var), NULL)))

struct _ValaCCodeMacroReplacementPrivate {
	gchar* _name;
	gchar* _replacement;
	ValaCCodeExpression* _replacement_expression;
};


static gpointer vala_ccode_macro_replacement_parent_class = NULL;

#define VALA_CCODE_MACRO_REPLACEMENT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALA_TYPE_CCODE_MACRO_REPLACEMENT, ValaCCodeMacroReplacementPrivate))
static void vala_ccode_macro_replacement_real_write (ValaCCodeNode* base,
                                              ValaCCodeWriter* writer);
static void vala_ccode_macro_replacement_finalize (ValaCCodeNode * obj);


ValaCCodeMacroReplacement*
vala_ccode_macro_replacement_construct (GType object_type,
                                        const gchar* name,
                                        const gchar* replacement)
{
	ValaCCodeMacroReplacement* self = NULL;
	g_return_val_if_fail (name != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	self = (ValaCCodeMacroReplacement*) vala_ccode_node_construct (object_type);
	vala_ccode_macro_replacement_set_replacement (self, replacement);
	vala_ccode_macro_replacement_set_name (self, name);
	return self;
}


ValaCCodeMacroReplacement*
vala_ccode_macro_replacement_new (const gchar* name,
                                  const gchar* replacement)
{
	return vala_ccode_macro_replacement_construct (VALA_TYPE_CCODE_MACRO_REPLACEMENT, name, replacement);
}


ValaCCodeMacroReplacement*
vala_ccode_macro_replacement_construct_with_expression (GType object_type,
                                                        const gchar* name,
                                                        ValaCCodeExpression* replacement_expression)
{
	ValaCCodeMacroReplacement* self = NULL;
	g_return_val_if_fail (name != NULL, NULL);
	g_return_val_if_fail (replacement_expression != NULL, NULL);
	self = (ValaCCodeMacroReplacement*) vala_ccode_node_construct (object_type);
	vala_ccode_macro_replacement_set_name (self, name);
	vala_ccode_macro_replacement_set_replacement_expression (self, replacement_expression);
	return self;
}


ValaCCodeMacroReplacement*
vala_ccode_macro_replacement_new_with_expression (const gchar* name,
                                                  ValaCCodeExpression* replacement_expression)
{
	return vala_ccode_macro_replacement_construct_with_expression (VALA_TYPE_CCODE_MACRO_REPLACEMENT, name, replacement_expression);
}


static void
vala_ccode_macro_replacement_real_write (ValaCCodeNode* base,
                                         ValaCCodeWriter* writer)
{
	ValaCCodeMacroReplacement * self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	self = (ValaCCodeMacroReplacement*) base;
	g_return_if_fail (writer != NULL);
	vala_ccode_writer_write_indent (writer, NULL);
	vala_ccode_writer_write_string (writer, "#define ");
	_tmp0_ = self->priv->_name;
	vala_ccode_writer_write_string (writer, _tmp0_);
	vala_ccode_writer_write_string (writer, " ");
	_tmp1_ = self->priv->_replacement;
	if (_tmp1_ != NULL) {
		const gchar* _tmp2_;
		_tmp2_ = self->priv->_replacement;
		vala_ccode_writer_write_string (writer, _tmp2_);
	} else {
		ValaCCodeExpression* _tmp3_;
		_tmp3_ = self->priv->_replacement_expression;
		vala_ccode_expression_write_inner (_tmp3_, writer);
	}
	vala_ccode_writer_write_newline (writer);
}


const gchar*
vala_ccode_macro_replacement_get_name (ValaCCodeMacroReplacement* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_name;
	result = _tmp0_;
	return result;
}


void
vala_ccode_macro_replacement_set_name (ValaCCodeMacroReplacement* self,
                                       const gchar* value)
{
	gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->_name);
	self->priv->_name = _tmp0_;
}


const gchar*
vala_ccode_macro_replacement_get_replacement (ValaCCodeMacroReplacement* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_replacement;
	result = _tmp0_;
	return result;
}


void
vala_ccode_macro_replacement_set_replacement (ValaCCodeMacroReplacement* self,
                                              const gchar* value)
{
	gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->_replacement);
	self->priv->_replacement = _tmp0_;
}


ValaCCodeExpression*
vala_ccode_macro_replacement_get_replacement_expression (ValaCCodeMacroReplacement* self)
{
	ValaCCodeExpression* result;
	ValaCCodeExpression* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_replacement_expression;
	result = _tmp0_;
	return result;
}


static gpointer
_vala_ccode_node_ref0 (gpointer self)
{
	return self ? vala_ccode_node_ref (self) : NULL;
}


void
vala_ccode_macro_replacement_set_replacement_expression (ValaCCodeMacroReplacement* self,
                                                         ValaCCodeExpression* value)
{
	ValaCCodeExpression* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _vala_ccode_node_ref0 (value);
	_vala_ccode_node_unref0 (self->priv->_replacement_expression);
	self->priv->_replacement_expression = _tmp0_;
}


static void
vala_ccode_macro_replacement_class_init (ValaCCodeMacroReplacementClass * klass)
{
	vala_ccode_macro_replacement_parent_class = g_type_class_peek_parent (klass);
	((ValaCCodeNodeClass *) klass)->finalize = vala_ccode_macro_replacement_finalize;
	g_type_class_add_private (klass, sizeof (ValaCCodeMacroReplacementPrivate));
	((ValaCCodeNodeClass *) klass)->write = (void (*) (ValaCCodeNode *, ValaCCodeWriter*)) vala_ccode_macro_replacement_real_write;
}


static void
vala_ccode_macro_replacement_instance_init (ValaCCodeMacroReplacement * self)
{
	self->priv = VALA_CCODE_MACRO_REPLACEMENT_GET_PRIVATE (self);
}


static void
vala_ccode_macro_replacement_finalize (ValaCCodeNode * obj)
{
	ValaCCodeMacroReplacement * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALA_TYPE_CCODE_MACRO_REPLACEMENT, ValaCCodeMacroReplacement);
	_g_free0 (self->priv->_name);
	_g_free0 (self->priv->_replacement);
	_vala_ccode_node_unref0 (self->priv->_replacement_expression);
	VALA_CCODE_NODE_CLASS (vala_ccode_macro_replacement_parent_class)->finalize (obj);
}


/**
 * Represents a preprocessor macro replacement definition in the C code.
 */
GType
vala_ccode_macro_replacement_get_type (void)
{
	static volatile gsize vala_ccode_macro_replacement_type_id__volatile = 0;
	if (g_once_init_enter (&vala_ccode_macro_replacement_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ValaCCodeMacroReplacementClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_ccode_macro_replacement_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaCCodeMacroReplacement), 0, (GInstanceInitFunc) vala_ccode_macro_replacement_instance_init, NULL };
		GType vala_ccode_macro_replacement_type_id;
		vala_ccode_macro_replacement_type_id = g_type_register_static (VALA_TYPE_CCODE_NODE, "ValaCCodeMacroReplacement", &g_define_type_info, 0);
		g_once_init_leave (&vala_ccode_macro_replacement_type_id__volatile, vala_ccode_macro_replacement_type_id);
	}
	return vala_ccode_macro_replacement_type_id__volatile;
}



