/* field.c generated by valac, the Vala compiler
 * generated from field.vala, do not modify */

/* field.vala
 *
 * Copyright (C) 2008-2011  Florian Brosch
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Florian Brosch <flo.brosch@gmail.com>
 */


#include <glib.h>
#include <glib-object.h>
#include "valadoc.h"
#include <stdlib.h>
#include <string.h>

enum  {
	VALADOC_API_FIELD_0_PROPERTY,
	VALADOC_API_FIELD_FIELD_TYPE_PROPERTY,
	VALADOC_API_FIELD_IS_STATIC_PROPERTY,
	VALADOC_API_FIELD_IS_VOLATILE_PROPERTY,
	VALADOC_API_FIELD_NODE_TYPE_PROPERTY,
	VALADOC_API_FIELD_NUM_PROPERTIES
};
static GParamSpec* valadoc_api_field_properties[VALADOC_API_FIELD_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _valadoc_api_signature_builder_unref0(var) ((var == NULL) ? NULL : (var = (valadoc_api_signature_builder_unref (var), NULL)))

struct _ValadocApiFieldPrivate {
	gchar* cname;
	ValadocApiTypeReference* _field_type;
	gboolean _is_static;
	gboolean _is_volatile;
};


static gpointer valadoc_api_field_parent_class = NULL;

#define VALADOC_API_FIELD_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALADOC_API_TYPE_FIELD, ValadocApiFieldPrivate))
static void valadoc_api_field_set_is_static (ValadocApiField* self,
                                      gboolean value);
static void valadoc_api_field_set_is_volatile (ValadocApiField* self,
                                        gboolean value);
static ValadocContentInline* valadoc_api_field_real_build_signature (ValadocApiItem* base);
static void valadoc_api_field_real_accept (ValadocApiNode* base,
                                    ValadocApiVisitor* visitor);
static void valadoc_api_field_finalize (GObject * obj);
static void _vala_valadoc_api_field_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_valadoc_api_field_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);


ValadocApiField*
valadoc_api_field_construct (GType object_type,
                             ValadocApiNode* parent,
                             ValadocApiSourceFile* file,
                             const gchar* name,
                             ValadocApiSymbolAccessibility accessibility,
                             ValadocApiSourceComment* comment,
                             const gchar* cname,
                             gboolean is_static,
                             gboolean is_volatile,
                             void* data)
{
	ValadocApiField * self = NULL;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp1_;
	g_return_val_if_fail (parent != NULL, NULL);
	g_return_val_if_fail (file != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	self = (ValadocApiField*) valadoc_api_member_construct (object_type, parent, file, name, accessibility, comment, data);
	if (!G_TYPE_CHECK_INSTANCE_TYPE (parent, VALADOC_API_TYPE_NAMESPACE)) {
		_tmp0_ = is_static;
	} else {
		_tmp0_ = FALSE;
	}
	valadoc_api_field_set_is_static (self, _tmp0_);
	valadoc_api_field_set_is_volatile (self, is_volatile);
	_tmp1_ = g_strdup (cname);
	_g_free0 (self->priv->cname);
	self->priv->cname = _tmp1_;
	return self;
}


ValadocApiField*
valadoc_api_field_new (ValadocApiNode* parent,
                       ValadocApiSourceFile* file,
                       const gchar* name,
                       ValadocApiSymbolAccessibility accessibility,
                       ValadocApiSourceComment* comment,
                       const gchar* cname,
                       gboolean is_static,
                       gboolean is_volatile,
                       void* data)
{
	return valadoc_api_field_construct (VALADOC_API_TYPE_FIELD, parent, file, name, accessibility, comment, cname, is_static, is_volatile, data);
}


/**
 * Returns the name of this field as it is used in C.
 */
gchar*
valadoc_api_field_get_cname (ValadocApiField* self)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->cname;
	_tmp1_ = g_strdup (_tmp0_);
	result = _tmp1_;
	return result;
}


/**
 * {@inheritDoc}
 */
static ValadocContentInline*
valadoc_api_field_real_build_signature (ValadocApiItem* base)
{
	ValadocApiField * self;
	ValadocContentInline* result = NULL;
	ValadocApiSignatureBuilder* signature = NULL;
	ValadocApiSignatureBuilder* _tmp0_;
	ValadocApiSignatureBuilder* _tmp1_;
	ValadocApiSymbolAccessibility _tmp2_;
	ValadocApiSymbolAccessibility _tmp3_;
	const gchar* _tmp4_;
	ValadocApiSignatureBuilder* _tmp5_;
	ValadocApiSignatureBuilder* _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp11_;
	ValadocApiSignatureBuilder* _tmp15_;
	ValadocApiTypeReference* _tmp16_;
	ValadocContentInline* _tmp17_;
	ValadocContentInline* _tmp18_;
	ValadocApiSignatureBuilder* _tmp19_;
	ValadocApiSignatureBuilder* _tmp20_;
	ValadocApiSignatureBuilder* _tmp21_;
	ValadocApiSignatureBuilder* _tmp22_;
	ValadocApiSignatureBuilder* _tmp23_;
	ValadocApiSignatureBuilder* _tmp24_;
	ValadocContentRun* _tmp25_;
	self = (ValadocApiField*) base;
	_tmp0_ = valadoc_api_signature_builder_new ();
	signature = _tmp0_;
	_tmp1_ = signature;
	_tmp2_ = valadoc_api_symbol_get_accessibility ((ValadocApiSymbol*) self);
	_tmp3_ = _tmp2_;
	_tmp4_ = valadoc_api_symbol_accessibility_to_string (_tmp3_);
	_tmp5_ = valadoc_api_signature_builder_append_keyword (_tmp1_, _tmp4_, TRUE);
	_tmp6_ = _tmp5_;
	_valadoc_api_signature_builder_unref0 (_tmp6_);
	_tmp7_ = self->priv->_is_static;
	if (_tmp7_) {
		ValadocApiSignatureBuilder* _tmp8_;
		ValadocApiSignatureBuilder* _tmp9_;
		ValadocApiSignatureBuilder* _tmp10_;
		_tmp8_ = signature;
		_tmp9_ = valadoc_api_signature_builder_append_keyword (_tmp8_, "static", TRUE);
		_tmp10_ = _tmp9_;
		_valadoc_api_signature_builder_unref0 (_tmp10_);
	}
	_tmp11_ = self->priv->_is_volatile;
	if (_tmp11_) {
		ValadocApiSignatureBuilder* _tmp12_;
		ValadocApiSignatureBuilder* _tmp13_;
		ValadocApiSignatureBuilder* _tmp14_;
		_tmp12_ = signature;
		_tmp13_ = valadoc_api_signature_builder_append_keyword (_tmp12_, "volatile", TRUE);
		_tmp14_ = _tmp13_;
		_valadoc_api_signature_builder_unref0 (_tmp14_);
	}
	_tmp15_ = signature;
	_tmp16_ = self->priv->_field_type;
	_tmp17_ = valadoc_api_item_get_signature ((ValadocApiItem*) _tmp16_);
	_tmp18_ = _tmp17_;
	_tmp19_ = valadoc_api_signature_builder_append_content (_tmp15_, _tmp18_, TRUE);
	_tmp20_ = _tmp19_;
	_valadoc_api_signature_builder_unref0 (_tmp20_);
	_tmp21_ = signature;
	_tmp22_ = valadoc_api_signature_builder_append_symbol (_tmp21_, (ValadocApiNode*) self, TRUE);
	_tmp23_ = _tmp22_;
	_valadoc_api_signature_builder_unref0 (_tmp23_);
	_tmp24_ = signature;
	_tmp25_ = valadoc_api_signature_builder_get (_tmp24_);
	result = (ValadocContentInline*) _tmp25_;
	_valadoc_api_signature_builder_unref0 (signature);
	return result;
}


/**
 * {@inheritDoc}
 */
static void
valadoc_api_field_real_accept (ValadocApiNode* base,
                               ValadocApiVisitor* visitor)
{
	ValadocApiField * self;
	self = (ValadocApiField*) base;
	g_return_if_fail (visitor != NULL);
	valadoc_api_visitor_visit_field (visitor, self);
}


ValadocApiTypeReference*
valadoc_api_field_get_field_type (ValadocApiField* self)
{
	ValadocApiTypeReference* result;
	ValadocApiTypeReference* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_field_type;
	result = _tmp0_;
	return result;
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


void
valadoc_api_field_set_field_type (ValadocApiField* self,
                                  ValadocApiTypeReference* value)
{
	g_return_if_fail (self != NULL);
	if (valadoc_api_field_get_field_type (self) != value) {
		ValadocApiTypeReference* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_field_type);
		self->priv->_field_type = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, valadoc_api_field_properties[VALADOC_API_FIELD_FIELD_TYPE_PROPERTY]);
	}
}


gboolean
valadoc_api_field_get_is_static (ValadocApiField* self)
{
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_is_static;
	result = _tmp0_;
	return result;
}


static void
valadoc_api_field_set_is_static (ValadocApiField* self,
                                 gboolean value)
{
	g_return_if_fail (self != NULL);
	if (valadoc_api_field_get_is_static (self) != value) {
		self->priv->_is_static = value;
		g_object_notify_by_pspec ((GObject *) self, valadoc_api_field_properties[VALADOC_API_FIELD_IS_STATIC_PROPERTY]);
	}
}


gboolean
valadoc_api_field_get_is_volatile (ValadocApiField* self)
{
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_is_volatile;
	result = _tmp0_;
	return result;
}


static void
valadoc_api_field_set_is_volatile (ValadocApiField* self,
                                   gboolean value)
{
	g_return_if_fail (self != NULL);
	if (valadoc_api_field_get_is_volatile (self) != value) {
		self->priv->_is_volatile = value;
		g_object_notify_by_pspec ((GObject *) self, valadoc_api_field_properties[VALADOC_API_FIELD_IS_VOLATILE_PROPERTY]);
	}
}


static ValadocApiNodeType
valadoc_api_field_real_get_node_type (ValadocApiNode* base)
{
	ValadocApiNodeType result;
	ValadocApiField* self;
	self = (ValadocApiField*) base;
	result = VALADOC_API_NODE_TYPE_FIELD;
	return result;
}


static void
valadoc_api_field_class_init (ValadocApiFieldClass * klass)
{
	valadoc_api_field_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ValadocApiFieldPrivate));
	((ValadocApiItemClass *) klass)->build_signature = (ValadocContentInline* (*) (ValadocApiItem *)) valadoc_api_field_real_build_signature;
	((ValadocApiNodeClass *) klass)->accept = (void (*) (ValadocApiNode *, ValadocApiVisitor*)) valadoc_api_field_real_accept;
	VALADOC_API_NODE_CLASS (klass)->get_node_type = valadoc_api_field_real_get_node_type;
	G_OBJECT_CLASS (klass)->get_property = _vala_valadoc_api_field_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_valadoc_api_field_set_property;
	G_OBJECT_CLASS (klass)->finalize = valadoc_api_field_finalize;
	/**
	 * The field type.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALADOC_API_FIELD_FIELD_TYPE_PROPERTY, valadoc_api_field_properties[VALADOC_API_FIELD_FIELD_TYPE_PROPERTY] = g_param_spec_object ("field-type", "field-type", "field-type", VALADOC_API_TYPE_TYPEREFERENCE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	 * Specifies whether the field is static.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALADOC_API_FIELD_IS_STATIC_PROPERTY, valadoc_api_field_properties[VALADOC_API_FIELD_IS_STATIC_PROPERTY] = g_param_spec_boolean ("is-static", "is-static", "is-static", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	/**
	 * Specifies whether the field is volatile.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALADOC_API_FIELD_IS_VOLATILE_PROPERTY, valadoc_api_field_properties[VALADOC_API_FIELD_IS_VOLATILE_PROPERTY] = g_param_spec_boolean ("is-volatile", "is-volatile", "is-volatile", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	/**
	 * {@inheritDoc}
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALADOC_API_FIELD_NODE_TYPE_PROPERTY, valadoc_api_field_properties[VALADOC_API_FIELD_NODE_TYPE_PROPERTY] = g_param_spec_enum ("node-type", "node-type", "node-type", VALADOC_API_TYPE_NODE_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}


static void
valadoc_api_field_instance_init (ValadocApiField * self)
{
	self->priv = VALADOC_API_FIELD_GET_PRIVATE (self);
}


static void
valadoc_api_field_finalize (GObject * obj)
{
	ValadocApiField * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALADOC_API_TYPE_FIELD, ValadocApiField);
	_g_free0 (self->priv->cname);
	_g_object_unref0 (self->priv->_field_type);
	G_OBJECT_CLASS (valadoc_api_field_parent_class)->finalize (obj);
}


/**
 * Represents a field.
 */
GType
valadoc_api_field_get_type (void)
{
	static volatile gsize valadoc_api_field_type_id__volatile = 0;
	if (g_once_init_enter (&valadoc_api_field_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ValadocApiFieldClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valadoc_api_field_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValadocApiField), 0, (GInstanceInitFunc) valadoc_api_field_instance_init, NULL };
		GType valadoc_api_field_type_id;
		valadoc_api_field_type_id = g_type_register_static (VALADOC_API_TYPE_MEMBER, "ValadocApiField", &g_define_type_info, 0);
		g_once_init_leave (&valadoc_api_field_type_id__volatile, valadoc_api_field_type_id);
	}
	return valadoc_api_field_type_id__volatile;
}


static void
_vala_valadoc_api_field_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	ValadocApiField * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VALADOC_API_TYPE_FIELD, ValadocApiField);
	switch (property_id) {
		case VALADOC_API_FIELD_FIELD_TYPE_PROPERTY:
		g_value_set_object (value, valadoc_api_field_get_field_type (self));
		break;
		case VALADOC_API_FIELD_IS_STATIC_PROPERTY:
		g_value_set_boolean (value, valadoc_api_field_get_is_static (self));
		break;
		case VALADOC_API_FIELD_IS_VOLATILE_PROPERTY:
		g_value_set_boolean (value, valadoc_api_field_get_is_volatile (self));
		break;
		case VALADOC_API_FIELD_NODE_TYPE_PROPERTY:
		g_value_set_enum (value, valadoc_api_node_get_node_type ((ValadocApiNode*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_valadoc_api_field_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	ValadocApiField * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VALADOC_API_TYPE_FIELD, ValadocApiField);
	switch (property_id) {
		case VALADOC_API_FIELD_FIELD_TYPE_PROPERTY:
		valadoc_api_field_set_field_type (self, g_value_get_object (value));
		break;
		case VALADOC_API_FIELD_IS_STATIC_PROPERTY:
		valadoc_api_field_set_is_static (self, g_value_get_boolean (value));
		break;
		case VALADOC_API_FIELD_IS_VOLATILE_PROPERTY:
		valadoc_api_field_set_is_volatile (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



