/* namespace.c generated by valac, the Vala compiler
 * generated from namespace.vala, do not modify */

/* namespace.vala
 *
 * Copyright (C) 2008-2011  Florian Brosch
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Florian Brosch <flo.brosch@gmail.com>
 */


#include <glib.h>
#include <glib-object.h>
#include "valadoc.h"
#include <stdlib.h>
#include <string.h>

enum  {
	VALADOC_API_NAMESPACE_0_PROPERTY,
	VALADOC_API_NAMESPACE_NODE_TYPE_PROPERTY,
	VALADOC_API_NAMESPACE_NUM_PROPERTIES
};
static GParamSpec* valadoc_api_namespace_properties[VALADOC_API_NAMESPACE_NUM_PROPERTIES];
#define _valadoc_api_source_comment_unref0(var) ((var == NULL) ? NULL : (var = (valadoc_api_source_comment_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _valadoc_api_signature_builder_unref0(var) ((var == NULL) ? NULL : (var = (valadoc_api_signature_builder_unref (var), NULL)))

struct _ValadocApiNamespacePrivate {
	ValadocApiSourceComment* source_comment;
};


static gpointer valadoc_api_namespace_parent_class = NULL;

#define VALADOC_API_NAMESPACE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALADOC_API_TYPE_NAMESPACE, ValadocApiNamespacePrivate))
static void valadoc_api_namespace_real_parse_comments (ValadocApiItem* base,
                                                ValadocSettings* settings,
                                                ValadocDocumentationParser* parser);
G_GNUC_INTERNAL void valadoc_api_node_set_documentation (ValadocApiNode* self,
                                         ValadocContentComment* value);
G_GNUC_INTERNAL void valadoc_api_item_parse_comments (ValadocApiItem* self,
                                      ValadocSettings* settings,
                                      ValadocDocumentationParser* parser);
static void valadoc_api_namespace_real_check_comments (ValadocApiItem* base,
                                                ValadocSettings* settings,
                                                ValadocDocumentationParser* parser);
G_GNUC_INTERNAL void valadoc_api_item_check_comments (ValadocApiItem* self,
                                      ValadocSettings* settings,
                                      ValadocDocumentationParser* parser);
static ValadocContentInline* valadoc_api_namespace_real_build_signature (ValadocApiItem* base);
static void valadoc_api_namespace_real_accept (ValadocApiNode* base,
                                        ValadocApiVisitor* visitor);
static gboolean valadoc_api_namespace_real_is_browsable (ValadocApiNode* base,
                                                  ValadocSettings* settings);
static void valadoc_api_namespace_finalize (GObject * obj);
static void _vala_valadoc_api_namespace_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);


static gpointer
_valadoc_api_source_comment_ref0 (gpointer self)
{
	return self ? valadoc_api_source_comment_ref (self) : NULL;
}


ValadocApiNamespace*
valadoc_api_namespace_construct (GType object_type,
                                 ValadocApiNode* parent,
                                 ValadocApiSourceFile* file,
                                 const gchar* name,
                                 ValadocApiSourceComment* comment,
                                 void* data)
{
	ValadocApiNamespace * self = NULL;
	ValadocApiSourceComment* _tmp0_;
	g_return_val_if_fail (parent != NULL, NULL);
	g_return_val_if_fail (file != NULL, NULL);
	self = (ValadocApiNamespace*) valadoc_api_symbol_construct (object_type, parent, file, name, VALADOC_API_SYMBOL_ACCESSIBILITY_PUBLIC, data);
	_tmp0_ = _valadoc_api_source_comment_ref0 (comment);
	_valadoc_api_source_comment_unref0 (self->priv->source_comment);
	self->priv->source_comment = _tmp0_;
	return self;
}


ValadocApiNamespace*
valadoc_api_namespace_new (ValadocApiNode* parent,
                           ValadocApiSourceFile* file,
                           const gchar* name,
                           ValadocApiSourceComment* comment,
                           void* data)
{
	return valadoc_api_namespace_construct (VALADOC_API_TYPE_NAMESPACE, parent, file, name, comment, data);
}


/**
 * {@inheritDoc}
 */
static void
valadoc_api_namespace_real_parse_comments (ValadocApiItem* base,
                                           ValadocSettings* settings,
                                           ValadocDocumentationParser* parser)
{
	ValadocApiNamespace * self;
	ValadocContentComment* _tmp0_;
	ValadocContentComment* _tmp1_;
	ValadocApiSourceComment* _tmp2_;
	self = (ValadocApiNamespace*) base;
	g_return_if_fail (settings != NULL);
	g_return_if_fail (parser != NULL);
	_tmp0_ = valadoc_api_node_get_documentation ((ValadocApiNode*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ != NULL) {
		return;
	}
	_tmp2_ = self->priv->source_comment;
	if (_tmp2_ != NULL) {
		ValadocApiSourceComment* _tmp3_;
		ValadocContentComment* _tmp4_;
		ValadocContentComment* _tmp5_;
		_tmp3_ = self->priv->source_comment;
		_tmp4_ = valadoc_documentation_parser_parse (parser, (ValadocApiNode*) self, _tmp3_);
		_tmp5_ = _tmp4_;
		valadoc_api_node_set_documentation ((ValadocApiNode*) self, _tmp5_);
		_g_object_unref0 (_tmp5_);
	}
	VALADOC_API_ITEM_CLASS (valadoc_api_namespace_parent_class)->parse_comments ((ValadocApiItem*) G_TYPE_CHECK_INSTANCE_CAST (self, VALADOC_API_TYPE_SYMBOL, ValadocApiSymbol), settings, parser);
}


/**
 * {@inheritDoc}
 */
static void
valadoc_api_namespace_real_check_comments (ValadocApiItem* base,
                                           ValadocSettings* settings,
                                           ValadocDocumentationParser* parser)
{
	ValadocApiNamespace * self;
	ValadocContentComment* _tmp0_;
	ValadocContentComment* _tmp1_;
	self = (ValadocApiNamespace*) base;
	g_return_if_fail (settings != NULL);
	g_return_if_fail (parser != NULL);
	_tmp0_ = valadoc_api_node_get_documentation ((ValadocApiNode*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ != NULL) {
		ValadocContentComment* _tmp2_;
		ValadocContentComment* _tmp3_;
		_tmp2_ = valadoc_api_node_get_documentation ((ValadocApiNode*) self);
		_tmp3_ = _tmp2_;
		valadoc_documentation_parser_check (parser, (ValadocApiNode*) self, _tmp3_);
	}
	VALADOC_API_ITEM_CLASS (valadoc_api_namespace_parent_class)->check_comments ((ValadocApiItem*) G_TYPE_CHECK_INSTANCE_CAST (self, VALADOC_API_TYPE_SYMBOL, ValadocApiSymbol), settings, parser);
}


/**
 * {@inheritDoc}
 */
static ValadocContentInline*
valadoc_api_namespace_real_build_signature (ValadocApiItem* base)
{
	ValadocApiNamespace * self;
	ValadocContentInline* result = NULL;
	ValadocApiSignatureBuilder* _tmp0_;
	ValadocApiSignatureBuilder* _tmp1_;
	ValadocApiSymbolAccessibility _tmp2_;
	ValadocApiSymbolAccessibility _tmp3_;
	const gchar* _tmp4_;
	ValadocApiSignatureBuilder* _tmp5_;
	ValadocApiSignatureBuilder* _tmp6_;
	ValadocApiSignatureBuilder* _tmp7_;
	ValadocApiSignatureBuilder* _tmp8_;
	ValadocApiSignatureBuilder* _tmp9_;
	ValadocApiSignatureBuilder* _tmp10_;
	ValadocContentRun* _tmp11_;
	ValadocContentInline* _tmp12_;
	self = (ValadocApiNamespace*) base;
	_tmp0_ = valadoc_api_signature_builder_new ();
	_tmp1_ = _tmp0_;
	_tmp2_ = valadoc_api_symbol_get_accessibility ((ValadocApiSymbol*) self);
	_tmp3_ = _tmp2_;
	_tmp4_ = valadoc_api_symbol_accessibility_to_string (_tmp3_);
	_tmp5_ = valadoc_api_signature_builder_append_keyword (_tmp1_, _tmp4_, TRUE);
	_tmp6_ = _tmp5_;
	_tmp7_ = valadoc_api_signature_builder_append_keyword (_tmp6_, "namespace", TRUE);
	_tmp8_ = _tmp7_;
	_tmp9_ = valadoc_api_signature_builder_append_symbol (_tmp8_, (ValadocApiNode*) self, TRUE);
	_tmp10_ = _tmp9_;
	_tmp11_ = valadoc_api_signature_builder_get (_tmp10_);
	_tmp12_ = (ValadocContentInline*) _tmp11_;
	_valadoc_api_signature_builder_unref0 (_tmp10_);
	_valadoc_api_signature_builder_unref0 (_tmp8_);
	_valadoc_api_signature_builder_unref0 (_tmp6_);
	_valadoc_api_signature_builder_unref0 (_tmp1_);
	result = _tmp12_;
	return result;
}


/**
 * {@inheritDoc}
 */
static void
valadoc_api_namespace_real_accept (ValadocApiNode* base,
                                   ValadocApiVisitor* visitor)
{
	ValadocApiNamespace * self;
	self = (ValadocApiNamespace*) base;
	g_return_if_fail (visitor != NULL);
	valadoc_api_visitor_visit_namespace (visitor, self);
}


/**
 * {@inheritDoc}
 */
static gboolean
valadoc_api_namespace_real_is_browsable (ValadocApiNode* base,
                                         ValadocSettings* settings)
{
	ValadocApiNamespace * self;
	gboolean result = FALSE;
	self = (ValadocApiNamespace*) base;
	g_return_val_if_fail (settings != NULL, FALSE);
	result = valadoc_api_node_has_visible_children ((ValadocApiNode*) self, settings);
	return result;
}


static ValadocApiNodeType
valadoc_api_namespace_real_get_node_type (ValadocApiNode* base)
{
	ValadocApiNodeType result;
	ValadocApiNamespace* self;
	self = (ValadocApiNamespace*) base;
	result = VALADOC_API_NODE_TYPE_NAMESPACE;
	return result;
}


static void
valadoc_api_namespace_class_init (ValadocApiNamespaceClass * klass)
{
	valadoc_api_namespace_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ValadocApiNamespacePrivate));
	((ValadocApiItemClass *) klass)->parse_comments = (void (*) (ValadocApiItem *, ValadocSettings*, ValadocDocumentationParser*)) valadoc_api_namespace_real_parse_comments;
	((ValadocApiItemClass *) klass)->check_comments = (void (*) (ValadocApiItem *, ValadocSettings*, ValadocDocumentationParser*)) valadoc_api_namespace_real_check_comments;
	((ValadocApiItemClass *) klass)->build_signature = (ValadocContentInline* (*) (ValadocApiItem *)) valadoc_api_namespace_real_build_signature;
	((ValadocApiNodeClass *) klass)->accept = (void (*) (ValadocApiNode *, ValadocApiVisitor*)) valadoc_api_namespace_real_accept;
	((ValadocApiNodeClass *) klass)->is_browsable = (gboolean (*) (ValadocApiNode *, ValadocSettings*)) valadoc_api_namespace_real_is_browsable;
	VALADOC_API_NODE_CLASS (klass)->get_node_type = valadoc_api_namespace_real_get_node_type;
	G_OBJECT_CLASS (klass)->get_property = _vala_valadoc_api_namespace_get_property;
	G_OBJECT_CLASS (klass)->finalize = valadoc_api_namespace_finalize;
	/**
	 * {@inheritDoc}
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALADOC_API_NAMESPACE_NODE_TYPE_PROPERTY, valadoc_api_namespace_properties[VALADOC_API_NAMESPACE_NODE_TYPE_PROPERTY] = g_param_spec_enum ("node-type", "node-type", "node-type", VALADOC_API_TYPE_NODE_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}


static void
valadoc_api_namespace_instance_init (ValadocApiNamespace * self)
{
	self->priv = VALADOC_API_NAMESPACE_GET_PRIVATE (self);
}


static void
valadoc_api_namespace_finalize (GObject * obj)
{
	ValadocApiNamespace * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALADOC_API_TYPE_NAMESPACE, ValadocApiNamespace);
	_valadoc_api_source_comment_unref0 (self->priv->source_comment);
	G_OBJECT_CLASS (valadoc_api_namespace_parent_class)->finalize (obj);
}


/**
 * Represents a namespace declaration.
 */
GType
valadoc_api_namespace_get_type (void)
{
	static volatile gsize valadoc_api_namespace_type_id__volatile = 0;
	if (g_once_init_enter (&valadoc_api_namespace_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ValadocApiNamespaceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valadoc_api_namespace_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValadocApiNamespace), 0, (GInstanceInitFunc) valadoc_api_namespace_instance_init, NULL };
		GType valadoc_api_namespace_type_id;
		valadoc_api_namespace_type_id = g_type_register_static (VALADOC_API_TYPE_SYMBOL, "ValadocApiNamespace", &g_define_type_info, 0);
		g_once_init_leave (&valadoc_api_namespace_type_id__volatile, valadoc_api_namespace_type_id);
	}
	return valadoc_api_namespace_type_id__volatile;
}


static void
_vala_valadoc_api_namespace_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	ValadocApiNamespace * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VALADOC_API_TYPE_NAMESPACE, ValadocApiNamespace);
	switch (property_id) {
		case VALADOC_API_NAMESPACE_NODE_TYPE_PROPERTY:
		g_value_set_enum (value, valadoc_api_node_get_node_type ((ValadocApiNode*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



