/* signal.c generated by valac, the Vala compiler
 * generated from signal.vala, do not modify */

/* signal.vala
 *
 * Copyright (C) 2008-2011  Florian Brosch
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Florian Brosch <flo.brosch@gmail.com>
 */


#include <glib.h>
#include <glib-object.h>
#include "valadoc.h"
#include <stdlib.h>
#include <string.h>
#include <valagee.h>

enum  {
	VALADOC_API_SIGNAL_0_PROPERTY,
	VALADOC_API_SIGNAL_IMPLICIT_ARRAY_LENGTH_CPARAMETER_NAME_PROPERTY,
	VALADOC_API_SIGNAL_RETURN_TYPE_PROPERTY,
	VALADOC_API_SIGNAL_IS_VIRTUAL_PROPERTY,
	VALADOC_API_SIGNAL_IS_DBUS_VISIBLE_PROPERTY,
	VALADOC_API_SIGNAL_NODE_TYPE_PROPERTY,
	VALADOC_API_SIGNAL_NUM_PROPERTIES
};
static GParamSpec* valadoc_api_signal_properties[VALADOC_API_SIGNAL_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _valadoc_api_signature_builder_unref0(var) ((var == NULL) ? NULL : (var = (valadoc_api_signature_builder_unref (var), NULL)))
#define _vala_iterable_unref0(var) ((var == NULL) ? NULL : (var = (vala_iterable_unref (var), NULL)))

struct _ValadocApiSignalPrivate {
	gchar* default_impl_cname;
	gchar* dbus_name;
	gchar* cname;
	gchar* _implicit_array_length_cparameter_name;
	ValadocApiTypeReference* _return_type;
	gboolean _is_virtual;
	gboolean _is_dbus_visible;
};


static gpointer valadoc_api_signal_parent_class = NULL;
static ValadocApiCallableIface * valadoc_api_signal_valadoc_api_callable_parent_iface = NULL;

#define VALADOC_API_SIGNAL_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALADOC_API_TYPE_SIGNAL, ValadocApiSignalPrivate))
static void valadoc_api_signal_set_is_dbus_visible (ValadocApiSignal* self,
                                             gboolean value);
static void valadoc_api_signal_set_is_virtual (ValadocApiSignal* self,
                                        gboolean value);
static ValadocContentInline* valadoc_api_signal_real_build_signature (ValadocApiItem* base);
static void valadoc_api_signal_real_accept (ValadocApiNode* base,
                                     ValadocApiVisitor* visitor);
static void valadoc_api_signal_finalize (GObject * obj);
G_GNUC_INTERNAL const gchar* valadoc_api_callable_get_implicit_array_length_cparameter_name (ValadocApiCallable* self);
static void _vala_valadoc_api_signal_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
G_GNUC_INTERNAL void valadoc_api_callable_set_implicit_array_length_cparameter_name (ValadocApiCallable* self,
                                                                     const gchar* value);
static void _vala_valadoc_api_signal_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);


ValadocApiSignal*
valadoc_api_signal_construct (GType object_type,
                              ValadocApiNode* parent,
                              ValadocApiSourceFile* file,
                              const gchar* name,
                              ValadocApiSymbolAccessibility accessibility,
                              ValadocApiSourceComment* comment,
                              const gchar* cname,
                              const gchar* default_impl_cname,
                              const gchar* dbus_name,
                              gboolean is_dbus_visible,
                              gboolean is_virtual,
                              void* data)
{
	ValadocApiSignal * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	g_return_val_if_fail (parent != NULL, NULL);
	g_return_val_if_fail (file != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	self = (ValadocApiSignal*) valadoc_api_member_construct (object_type, parent, file, name, accessibility, comment, data);
	_tmp0_ = g_strdup (default_impl_cname);
	_g_free0 (self->priv->default_impl_cname);
	self->priv->default_impl_cname = _tmp0_;
	_tmp1_ = g_strdup (dbus_name);
	_g_free0 (self->priv->dbus_name);
	self->priv->dbus_name = _tmp1_;
	_tmp2_ = g_strdup (cname);
	_g_free0 (self->priv->cname);
	self->priv->cname = _tmp2_;
	valadoc_api_signal_set_is_dbus_visible (self, is_dbus_visible);
	valadoc_api_signal_set_is_virtual (self, is_virtual);
	return self;
}


ValadocApiSignal*
valadoc_api_signal_new (ValadocApiNode* parent,
                        ValadocApiSourceFile* file,
                        const gchar* name,
                        ValadocApiSymbolAccessibility accessibility,
                        ValadocApiSourceComment* comment,
                        const gchar* cname,
                        const gchar* default_impl_cname,
                        const gchar* dbus_name,
                        gboolean is_dbus_visible,
                        gboolean is_virtual,
                        void* data)
{
	return valadoc_api_signal_construct (VALADOC_API_TYPE_SIGNAL, parent, file, name, accessibility, comment, cname, default_impl_cname, dbus_name, is_dbus_visible, is_virtual, data);
}


/**
 * Returns the name of this signal as it is used in C.
 */
gchar*
valadoc_api_signal_get_cname (ValadocApiSignal* self)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->cname;
	_tmp1_ = g_strdup (_tmp0_);
	result = _tmp1_;
	return result;
}


gchar*
valadoc_api_signal_get_default_impl_cname (ValadocApiSignal* self)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->default_impl_cname;
	_tmp1_ = g_strdup (_tmp0_);
	result = _tmp1_;
	return result;
}


/**
 * Returns the dbus-name.
 */
gchar*
valadoc_api_signal_get_dbus_name (ValadocApiSignal* self)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->dbus_name;
	_tmp1_ = g_strdup (_tmp0_);
	result = _tmp1_;
	return result;
}


/**
 * {@inheritDoc}
 */
static ValadocContentInline*
valadoc_api_signal_real_build_signature (ValadocApiItem* base)
{
	ValadocApiSignal * self;
	ValadocContentInline* result = NULL;
	ValadocApiSignatureBuilder* signature = NULL;
	ValadocApiSignatureBuilder* _tmp0_;
	ValadocApiSignatureBuilder* _tmp1_;
	ValadocApiSymbolAccessibility _tmp2_;
	ValadocApiSymbolAccessibility _tmp3_;
	const gchar* _tmp4_;
	ValadocApiSignatureBuilder* _tmp5_;
	ValadocApiSignatureBuilder* _tmp6_;
	gboolean _tmp7_;
	ValadocApiSignatureBuilder* _tmp11_;
	ValadocApiSignatureBuilder* _tmp12_;
	ValadocApiSignatureBuilder* _tmp13_;
	ValadocApiSignatureBuilder* _tmp14_;
	ValadocApiTypeReference* _tmp15_;
	ValadocApiTypeReference* _tmp16_;
	ValadocContentInline* _tmp17_;
	ValadocContentInline* _tmp18_;
	ValadocApiSignatureBuilder* _tmp19_;
	ValadocApiSignatureBuilder* _tmp20_;
	ValadocApiSignatureBuilder* _tmp21_;
	ValadocApiSignatureBuilder* _tmp22_;
	ValadocApiSignatureBuilder* _tmp23_;
	ValadocApiSignatureBuilder* _tmp24_;
	ValadocApiSignatureBuilder* _tmp25_;
	ValadocApiSignatureBuilder* _tmp26_;
	gboolean first = FALSE;
	ValadocApiSignatureBuilder* _tmp48_;
	ValadocApiSignatureBuilder* _tmp49_;
	ValadocApiSignatureBuilder* _tmp50_;
	ValadocApiSignatureBuilder* _tmp51_;
	ValadocContentRun* _tmp52_;
	self = (ValadocApiSignal*) base;
	_tmp0_ = valadoc_api_signature_builder_new ();
	signature = _tmp0_;
	_tmp1_ = signature;
	_tmp2_ = valadoc_api_symbol_get_accessibility ((ValadocApiSymbol*) self);
	_tmp3_ = _tmp2_;
	_tmp4_ = valadoc_api_symbol_accessibility_to_string (_tmp3_);
	_tmp5_ = valadoc_api_signature_builder_append_keyword (_tmp1_, _tmp4_, TRUE);
	_tmp6_ = _tmp5_;
	_valadoc_api_signature_builder_unref0 (_tmp6_);
	_tmp7_ = self->priv->_is_virtual;
	if (_tmp7_) {
		ValadocApiSignatureBuilder* _tmp8_;
		ValadocApiSignatureBuilder* _tmp9_;
		ValadocApiSignatureBuilder* _tmp10_;
		_tmp8_ = signature;
		_tmp9_ = valadoc_api_signature_builder_append_keyword (_tmp8_, "virtual", TRUE);
		_tmp10_ = _tmp9_;
		_valadoc_api_signature_builder_unref0 (_tmp10_);
	}
	_tmp11_ = signature;
	_tmp12_ = valadoc_api_signature_builder_append_keyword (_tmp11_, "signal", TRUE);
	_tmp13_ = _tmp12_;
	_valadoc_api_signature_builder_unref0 (_tmp13_);
	_tmp14_ = signature;
	_tmp15_ = valadoc_api_callable_get_return_type ((ValadocApiCallable*) self);
	_tmp16_ = _tmp15_;
	_tmp17_ = valadoc_api_item_get_signature ((ValadocApiItem*) _tmp16_);
	_tmp18_ = _tmp17_;
	_tmp19_ = valadoc_api_signature_builder_append_content (_tmp14_, _tmp18_, TRUE);
	_tmp20_ = _tmp19_;
	_valadoc_api_signature_builder_unref0 (_tmp20_);
	_tmp21_ = signature;
	_tmp22_ = valadoc_api_signature_builder_append_symbol (_tmp21_, (ValadocApiNode*) self, TRUE);
	_tmp23_ = _tmp22_;
	_valadoc_api_signature_builder_unref0 (_tmp23_);
	_tmp24_ = signature;
	_tmp25_ = valadoc_api_signature_builder_append (_tmp24_, "(", TRUE);
	_tmp26_ = _tmp25_;
	_valadoc_api_signature_builder_unref0 (_tmp26_);
	first = TRUE;
	{
		ValaList* _param_list = NULL;
		ValaList* _tmp27_;
		gint _param_size = 0;
		ValaList* _tmp28_;
		gint _tmp29_;
		gint _tmp30_;
		gint _param_index = 0;
		_tmp27_ = valadoc_api_node_get_children_by_type ((ValadocApiNode*) self, VALADOC_API_NODE_TYPE_FORMAL_PARAMETER, FALSE);
		_param_list = _tmp27_;
		_tmp28_ = _param_list;
		_tmp29_ = vala_collection_get_size ((ValaCollection*) _tmp28_);
		_tmp30_ = _tmp29_;
		_param_size = _tmp30_;
		_param_index = -1;
		while (TRUE) {
			gint _tmp31_;
			gint _tmp32_;
			gint _tmp33_;
			ValadocApiNode* param = NULL;
			ValaList* _tmp34_;
			gint _tmp35_;
			gpointer _tmp36_;
			gboolean _tmp37_;
			ValadocApiSignatureBuilder* _tmp41_;
			ValadocApiNode* _tmp42_;
			ValadocContentInline* _tmp43_;
			ValadocContentInline* _tmp44_;
			gboolean _tmp45_;
			ValadocApiSignatureBuilder* _tmp46_;
			ValadocApiSignatureBuilder* _tmp47_;
			_tmp31_ = _param_index;
			_param_index = _tmp31_ + 1;
			_tmp32_ = _param_index;
			_tmp33_ = _param_size;
			if (!(_tmp32_ < _tmp33_)) {
				break;
			}
			_tmp34_ = _param_list;
			_tmp35_ = _param_index;
			_tmp36_ = vala_list_get (_tmp34_, _tmp35_);
			param = (ValadocApiNode*) _tmp36_;
			_tmp37_ = first;
			if (!_tmp37_) {
				ValadocApiSignatureBuilder* _tmp38_;
				ValadocApiSignatureBuilder* _tmp39_;
				ValadocApiSignatureBuilder* _tmp40_;
				_tmp38_ = signature;
				_tmp39_ = valadoc_api_signature_builder_append (_tmp38_, ",", FALSE);
				_tmp40_ = _tmp39_;
				_valadoc_api_signature_builder_unref0 (_tmp40_);
			}
			_tmp41_ = signature;
			_tmp42_ = param;
			_tmp43_ = valadoc_api_item_get_signature ((ValadocApiItem*) _tmp42_);
			_tmp44_ = _tmp43_;
			_tmp45_ = first;
			_tmp46_ = valadoc_api_signature_builder_append_content (_tmp41_, _tmp44_, !_tmp45_);
			_tmp47_ = _tmp46_;
			_valadoc_api_signature_builder_unref0 (_tmp47_);
			first = FALSE;
			_g_object_unref0 (param);
		}
		_vala_iterable_unref0 (_param_list);
	}
	_tmp48_ = signature;
	_tmp49_ = valadoc_api_signature_builder_append (_tmp48_, ")", FALSE);
	_tmp50_ = _tmp49_;
	_valadoc_api_signature_builder_unref0 (_tmp50_);
	_tmp51_ = signature;
	_tmp52_ = valadoc_api_signature_builder_get (_tmp51_);
	result = (ValadocContentInline*) _tmp52_;
	_valadoc_api_signature_builder_unref0 (signature);
	return result;
}


/**
 * {@inheritDoc}
 */
static void
valadoc_api_signal_real_accept (ValadocApiNode* base,
                                ValadocApiVisitor* visitor)
{
	ValadocApiSignal * self;
	self = (ValadocApiSignal*) base;
	g_return_if_fail (visitor != NULL);
	valadoc_api_visitor_visit_signal (visitor, self);
}


static const gchar*
valadoc_api_signal_real_get_implicit_array_length_cparameter_name (ValadocApiCallable* base)
{
	const gchar* result;
	ValadocApiSignal* self;
	const gchar* _tmp0_;
	self = (ValadocApiSignal*) base;
	_tmp0_ = self->priv->_implicit_array_length_cparameter_name;
	result = _tmp0_;
	return result;
}


static void
valadoc_api_signal_real_set_implicit_array_length_cparameter_name (ValadocApiCallable* base,
                                                                   const gchar* value)
{
	ValadocApiSignal* self;
	self = (ValadocApiSignal*) base;
	if (g_strcmp0 (value, valadoc_api_signal_real_get_implicit_array_length_cparameter_name (base)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_implicit_array_length_cparameter_name);
		self->priv->_implicit_array_length_cparameter_name = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, valadoc_api_signal_properties[VALADOC_API_SIGNAL_IMPLICIT_ARRAY_LENGTH_CPARAMETER_NAME_PROPERTY]);
	}
}


static ValadocApiTypeReference*
valadoc_api_signal_real_get_return_type (ValadocApiCallable* base)
{
	ValadocApiTypeReference* result;
	ValadocApiSignal* self;
	ValadocApiTypeReference* _tmp0_;
	self = (ValadocApiSignal*) base;
	_tmp0_ = self->priv->_return_type;
	result = _tmp0_;
	return result;
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static void
valadoc_api_signal_real_set_return_type (ValadocApiCallable* base,
                                         ValadocApiTypeReference* value)
{
	ValadocApiSignal* self;
	self = (ValadocApiSignal*) base;
	if (valadoc_api_signal_real_get_return_type (base) != value) {
		ValadocApiTypeReference* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_return_type);
		self->priv->_return_type = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, valadoc_api_signal_properties[VALADOC_API_SIGNAL_RETURN_TYPE_PROPERTY]);
	}
}


gboolean
valadoc_api_signal_get_is_virtual (ValadocApiSignal* self)
{
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_is_virtual;
	result = _tmp0_;
	return result;
}


static void
valadoc_api_signal_set_is_virtual (ValadocApiSignal* self,
                                   gboolean value)
{
	g_return_if_fail (self != NULL);
	if (valadoc_api_signal_get_is_virtual (self) != value) {
		self->priv->_is_virtual = value;
		g_object_notify_by_pspec ((GObject *) self, valadoc_api_signal_properties[VALADOC_API_SIGNAL_IS_VIRTUAL_PROPERTY]);
	}
}


gboolean
valadoc_api_signal_get_is_dbus_visible (ValadocApiSignal* self)
{
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_is_dbus_visible;
	result = _tmp0_;
	return result;
}


static void
valadoc_api_signal_set_is_dbus_visible (ValadocApiSignal* self,
                                        gboolean value)
{
	g_return_if_fail (self != NULL);
	if (valadoc_api_signal_get_is_dbus_visible (self) != value) {
		self->priv->_is_dbus_visible = value;
		g_object_notify_by_pspec ((GObject *) self, valadoc_api_signal_properties[VALADOC_API_SIGNAL_IS_DBUS_VISIBLE_PROPERTY]);
	}
}


static ValadocApiNodeType
valadoc_api_signal_real_get_node_type (ValadocApiNode* base)
{
	ValadocApiNodeType result;
	ValadocApiSignal* self;
	self = (ValadocApiSignal*) base;
	result = VALADOC_API_NODE_TYPE_SIGNAL;
	return result;
}


static void
valadoc_api_signal_class_init (ValadocApiSignalClass * klass)
{
	valadoc_api_signal_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ValadocApiSignalPrivate));
	((ValadocApiItemClass *) klass)->build_signature = (ValadocContentInline* (*) (ValadocApiItem *)) valadoc_api_signal_real_build_signature;
	((ValadocApiNodeClass *) klass)->accept = (void (*) (ValadocApiNode *, ValadocApiVisitor*)) valadoc_api_signal_real_accept;
	VALADOC_API_NODE_CLASS (klass)->get_node_type = valadoc_api_signal_real_get_node_type;
	G_OBJECT_CLASS (klass)->get_property = _vala_valadoc_api_signal_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_valadoc_api_signal_set_property;
	G_OBJECT_CLASS (klass)->finalize = valadoc_api_signal_finalize;
	/**
	 * {@inheritDoc}
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALADOC_API_SIGNAL_IMPLICIT_ARRAY_LENGTH_CPARAMETER_NAME_PROPERTY, valadoc_api_signal_properties[VALADOC_API_SIGNAL_IMPLICIT_ARRAY_LENGTH_CPARAMETER_NAME_PROPERTY] = g_param_spec_string ("implicit-array-length-cparameter-name", "implicit-array-length-cparameter-name", "implicit-array-length-cparameter-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	 * {@inheritDoc}
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALADOC_API_SIGNAL_RETURN_TYPE_PROPERTY, valadoc_api_signal_properties[VALADOC_API_SIGNAL_RETURN_TYPE_PROPERTY] = g_param_spec_object ("return-type", "return-type", "return-type", VALADOC_API_TYPE_TYPEREFERENCE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	 * Specifies whether this signal is virtual
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALADOC_API_SIGNAL_IS_VIRTUAL_PROPERTY, valadoc_api_signal_properties[VALADOC_API_SIGNAL_IS_VIRTUAL_PROPERTY] = g_param_spec_boolean ("is-virtual", "is-virtual", "is-virtual", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	/**
	 * Specifies whether this signal is visible for dbus
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALADOC_API_SIGNAL_IS_DBUS_VISIBLE_PROPERTY, valadoc_api_signal_properties[VALADOC_API_SIGNAL_IS_DBUS_VISIBLE_PROPERTY] = g_param_spec_boolean ("is-dbus-visible", "is-dbus-visible", "is-dbus-visible", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	/**
	 * {@inheritDoc}
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALADOC_API_SIGNAL_NODE_TYPE_PROPERTY, valadoc_api_signal_properties[VALADOC_API_SIGNAL_NODE_TYPE_PROPERTY] = g_param_spec_enum ("node-type", "node-type", "node-type", VALADOC_API_TYPE_NODE_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}


static void
valadoc_api_signal_valadoc_api_callable_interface_init (ValadocApiCallableIface * iface)
{
	valadoc_api_signal_valadoc_api_callable_parent_iface = g_type_interface_peek_parent (iface);
	iface->get_implicit_array_length_cparameter_name = valadoc_api_signal_real_get_implicit_array_length_cparameter_name;
	iface->set_implicit_array_length_cparameter_name = valadoc_api_signal_real_set_implicit_array_length_cparameter_name;
	iface->get_return_type = valadoc_api_signal_real_get_return_type;
	iface->set_return_type = valadoc_api_signal_real_set_return_type;
}


static void
valadoc_api_signal_instance_init (ValadocApiSignal * self)
{
	self->priv = VALADOC_API_SIGNAL_GET_PRIVATE (self);
}


static void
valadoc_api_signal_finalize (GObject * obj)
{
	ValadocApiSignal * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALADOC_API_TYPE_SIGNAL, ValadocApiSignal);
	_g_free0 (self->priv->default_impl_cname);
	_g_free0 (self->priv->dbus_name);
	_g_free0 (self->priv->cname);
	_g_free0 (self->priv->_implicit_array_length_cparameter_name);
	_g_object_unref0 (self->priv->_return_type);
	G_OBJECT_CLASS (valadoc_api_signal_parent_class)->finalize (obj);
}


/**
 * Represents an signal.
 */
GType
valadoc_api_signal_get_type (void)
{
	static volatile gsize valadoc_api_signal_type_id__volatile = 0;
	if (g_once_init_enter (&valadoc_api_signal_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ValadocApiSignalClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valadoc_api_signal_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValadocApiSignal), 0, (GInstanceInitFunc) valadoc_api_signal_instance_init, NULL };
		static const GInterfaceInfo valadoc_api_callable_info = { (GInterfaceInitFunc) valadoc_api_signal_valadoc_api_callable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType valadoc_api_signal_type_id;
		valadoc_api_signal_type_id = g_type_register_static (VALADOC_API_TYPE_MEMBER, "ValadocApiSignal", &g_define_type_info, 0);
		g_type_add_interface_static (valadoc_api_signal_type_id, VALADOC_API_TYPE_CALLABLE, &valadoc_api_callable_info);
		g_once_init_leave (&valadoc_api_signal_type_id__volatile, valadoc_api_signal_type_id);
	}
	return valadoc_api_signal_type_id__volatile;
}


static void
_vala_valadoc_api_signal_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	ValadocApiSignal * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VALADOC_API_TYPE_SIGNAL, ValadocApiSignal);
	switch (property_id) {
		case VALADOC_API_SIGNAL_IMPLICIT_ARRAY_LENGTH_CPARAMETER_NAME_PROPERTY:
		g_value_set_string (value, valadoc_api_callable_get_implicit_array_length_cparameter_name ((ValadocApiCallable*) self));
		break;
		case VALADOC_API_SIGNAL_RETURN_TYPE_PROPERTY:
		g_value_set_object (value, valadoc_api_callable_get_return_type ((ValadocApiCallable*) self));
		break;
		case VALADOC_API_SIGNAL_IS_VIRTUAL_PROPERTY:
		g_value_set_boolean (value, valadoc_api_signal_get_is_virtual (self));
		break;
		case VALADOC_API_SIGNAL_IS_DBUS_VISIBLE_PROPERTY:
		g_value_set_boolean (value, valadoc_api_signal_get_is_dbus_visible (self));
		break;
		case VALADOC_API_SIGNAL_NODE_TYPE_PROPERTY:
		g_value_set_enum (value, valadoc_api_node_get_node_type ((ValadocApiNode*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_valadoc_api_signal_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	ValadocApiSignal * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VALADOC_API_TYPE_SIGNAL, ValadocApiSignal);
	switch (property_id) {
		case VALADOC_API_SIGNAL_IMPLICIT_ARRAY_LENGTH_CPARAMETER_NAME_PROPERTY:
		valadoc_api_callable_set_implicit_array_length_cparameter_name ((ValadocApiCallable*) self, g_value_get_string (value));
		break;
		case VALADOC_API_SIGNAL_RETURN_TYPE_PROPERTY:
		valadoc_api_callable_set_return_type ((ValadocApiCallable*) self, g_value_get_object (value));
		break;
		case VALADOC_API_SIGNAL_IS_VIRTUAL_PROPERTY:
		valadoc_api_signal_set_is_virtual (self, g_value_get_boolean (value));
		break;
		case VALADOC_API_SIGNAL_IS_DBUS_VISIBLE_PROPERTY:
		valadoc_api_signal_set_is_dbus_visible (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



