/* typesymbol.c generated by valac, the Vala compiler
 * generated from typesymbol.vala, do not modify */

/* typesymbol.vala
 *
 * Copyright (C) 2008-2009 Florian Brosch, Didier Villevalois
 * Copyright (C) 2011      Florian Brosch
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Didier 'Ptitjes Villevalois <ptitjes@free.fr>
 */


#include <glib.h>
#include <glib-object.h>
#include "valadoc.h"
#include <stdlib.h>
#include <string.h>

enum  {
	VALADOC_API_TYPESYMBOL_0_PROPERTY,
	VALADOC_API_TYPESYMBOL_IS_BASIC_TYPE_PROPERTY,
	VALADOC_API_TYPESYMBOL_NUM_PROPERTIES
};
static GParamSpec* valadoc_api_typesymbol_properties[VALADOC_API_TYPESYMBOL_NUM_PROPERTIES];
#define _valadoc_api_source_comment_unref0(var) ((var == NULL) ? NULL : (var = (valadoc_api_source_comment_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _ValadocApiTypeSymbolPrivate {
	ValadocApiSourceComment* source_comment;
	gchar* type_macro_name;
	gchar* is_type_macro_name;
	gchar* type_cast_macro_name;
	gchar* type_function_name;
	gboolean _is_basic_type;
};


static gpointer valadoc_api_typesymbol_parent_class = NULL;

#define VALADOC_API_TYPESYMBOL_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALADOC_API_TYPE_TYPESYMBOL, ValadocApiTypeSymbolPrivate))
static void valadoc_api_typesymbol_set_is_basic_type (ValadocApiTypeSymbol* self,
                                               gboolean value);
static void valadoc_api_typesymbol_real_parse_comments (ValadocApiItem* base,
                                                 ValadocSettings* settings,
                                                 ValadocDocumentationParser* parser);
G_GNUC_INTERNAL void valadoc_api_node_set_documentation (ValadocApiNode* self,
                                         ValadocContentComment* value);
G_GNUC_INTERNAL void valadoc_api_item_parse_comments (ValadocApiItem* self,
                                      ValadocSettings* settings,
                                      ValadocDocumentationParser* parser);
static void valadoc_api_typesymbol_real_check_comments (ValadocApiItem* base,
                                                 ValadocSettings* settings,
                                                 ValadocDocumentationParser* parser);
G_GNUC_INTERNAL void valadoc_api_item_check_comments (ValadocApiItem* self,
                                      ValadocSettings* settings,
                                      ValadocDocumentationParser* parser);
static void valadoc_api_typesymbol_finalize (GObject * obj);
static void _vala_valadoc_api_typesymbol_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_valadoc_api_typesymbol_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);


static gpointer
_valadoc_api_source_comment_ref0 (gpointer self)
{
	return self ? valadoc_api_source_comment_ref (self) : NULL;
}


ValadocApiTypeSymbol*
valadoc_api_typesymbol_construct (GType object_type,
                                  ValadocApiNode* parent,
                                  ValadocApiSourceFile* file,
                                  const gchar* name,
                                  ValadocApiSymbolAccessibility accessibility,
                                  ValadocApiSourceComment* comment,
                                  const gchar* type_macro_name,
                                  const gchar* is_type_macro_name,
                                  const gchar* type_cast_macro_name,
                                  const gchar* type_function_name,
                                  gboolean is_basic_type,
                                  void* data)
{
	ValadocApiTypeSymbol * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	ValadocApiSourceComment* _tmp4_;
	g_return_val_if_fail (parent != NULL, NULL);
	g_return_val_if_fail (file != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	self = (ValadocApiTypeSymbol*) valadoc_api_symbol_construct (object_type, parent, file, name, accessibility, data);
	_tmp0_ = g_strdup (type_cast_macro_name);
	_g_free0 (self->priv->type_cast_macro_name);
	self->priv->type_cast_macro_name = _tmp0_;
	_tmp1_ = g_strdup (is_type_macro_name);
	_g_free0 (self->priv->is_type_macro_name);
	self->priv->is_type_macro_name = _tmp1_;
	_tmp2_ = g_strdup (type_function_name);
	_g_free0 (self->priv->type_function_name);
	self->priv->type_function_name = _tmp2_;
	_tmp3_ = g_strdup (type_macro_name);
	_g_free0 (self->priv->type_macro_name);
	self->priv->type_macro_name = _tmp3_;
	valadoc_api_typesymbol_set_is_basic_type (self, is_basic_type);
	_tmp4_ = _valadoc_api_source_comment_ref0 (comment);
	_valadoc_api_source_comment_unref0 (self->priv->source_comment);
	self->priv->source_comment = _tmp4_;
	return self;
}


/**
 * Gets the name of the GType macro which represents the type symbol
 */
gchar*
valadoc_api_typesymbol_get_type_macro_name (ValadocApiTypeSymbol* self)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->type_macro_name;
	_tmp1_ = g_strdup (_tmp0_);
	result = _tmp1_;
	return result;
}


/**
 * Gets the name of the GType macro which casts a type instance to the given type.
 */
gchar*
valadoc_api_typesymbol_get_type_cast_macro_name (ValadocApiTypeSymbol* self)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->type_cast_macro_name;
	_tmp1_ = g_strdup (_tmp0_);
	result = _tmp1_;
	return result;
}


/**
 * Gets the name of the GType macro which determines whether a type instance is of a given type.
 */
gchar*
valadoc_api_typesymbol_get_is_type_macro_name (ValadocApiTypeSymbol* self)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->is_type_macro_name;
	_tmp1_ = g_strdup (_tmp0_);
	result = _tmp1_;
	return result;
}


/**
 * Gets the name of the get_type() function which represents the type symbol
 */
gchar*
valadoc_api_typesymbol_get_type_function_name (ValadocApiTypeSymbol* self)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->type_function_name;
	_tmp1_ = g_strdup (_tmp0_);
	result = _tmp1_;
	return result;
}


/**
 * {@inheritDoc}
 */
static void
valadoc_api_typesymbol_real_parse_comments (ValadocApiItem* base,
                                            ValadocSettings* settings,
                                            ValadocDocumentationParser* parser)
{
	ValadocApiTypeSymbol * self;
	ValadocContentComment* _tmp0_;
	ValadocContentComment* _tmp1_;
	ValadocApiSourceComment* _tmp2_;
	self = (ValadocApiTypeSymbol*) base;
	g_return_if_fail (settings != NULL);
	g_return_if_fail (parser != NULL);
	_tmp0_ = valadoc_api_node_get_documentation ((ValadocApiNode*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ != NULL) {
		return;
	}
	_tmp2_ = self->priv->source_comment;
	if (_tmp2_ != NULL) {
		ValadocApiSourceComment* _tmp3_;
		ValadocContentComment* _tmp4_;
		ValadocContentComment* _tmp5_;
		_tmp3_ = self->priv->source_comment;
		_tmp4_ = valadoc_documentation_parser_parse (parser, (ValadocApiNode*) self, _tmp3_);
		_tmp5_ = _tmp4_;
		valadoc_api_node_set_documentation ((ValadocApiNode*) self, _tmp5_);
		_g_object_unref0 (_tmp5_);
	}
	VALADOC_API_ITEM_CLASS (valadoc_api_typesymbol_parent_class)->parse_comments ((ValadocApiItem*) G_TYPE_CHECK_INSTANCE_CAST (self, VALADOC_API_TYPE_SYMBOL, ValadocApiSymbol), settings, parser);
}


/**
 * {@inheritDoc}
 */
static void
valadoc_api_typesymbol_real_check_comments (ValadocApiItem* base,
                                            ValadocSettings* settings,
                                            ValadocDocumentationParser* parser)
{
	ValadocApiTypeSymbol * self;
	ValadocContentComment* _tmp0_;
	ValadocContentComment* _tmp1_;
	self = (ValadocApiTypeSymbol*) base;
	g_return_if_fail (settings != NULL);
	g_return_if_fail (parser != NULL);
	_tmp0_ = valadoc_api_node_get_documentation ((ValadocApiNode*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ != NULL) {
		ValadocContentComment* _tmp2_;
		ValadocContentComment* _tmp3_;
		_tmp2_ = valadoc_api_node_get_documentation ((ValadocApiNode*) self);
		_tmp3_ = _tmp2_;
		valadoc_documentation_parser_check (parser, (ValadocApiNode*) self, _tmp3_);
	}
	VALADOC_API_ITEM_CLASS (valadoc_api_typesymbol_parent_class)->check_comments ((ValadocApiItem*) G_TYPE_CHECK_INSTANCE_CAST (self, VALADOC_API_TYPE_SYMBOL, ValadocApiSymbol), settings, parser);
}


gboolean
valadoc_api_typesymbol_get_is_basic_type (ValadocApiTypeSymbol* self)
{
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_is_basic_type;
	result = _tmp0_;
	return result;
}


static void
valadoc_api_typesymbol_set_is_basic_type (ValadocApiTypeSymbol* self,
                                          gboolean value)
{
	g_return_if_fail (self != NULL);
	if (valadoc_api_typesymbol_get_is_basic_type (self) != value) {
		self->priv->_is_basic_type = value;
		g_object_notify_by_pspec ((GObject *) self, valadoc_api_typesymbol_properties[VALADOC_API_TYPESYMBOL_IS_BASIC_TYPE_PROPERTY]);
	}
}


static void
valadoc_api_typesymbol_class_init (ValadocApiTypeSymbolClass * klass)
{
	valadoc_api_typesymbol_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ValadocApiTypeSymbolPrivate));
	((ValadocApiItemClass *) klass)->parse_comments = (void (*) (ValadocApiItem *, ValadocSettings*, ValadocDocumentationParser*)) valadoc_api_typesymbol_real_parse_comments;
	((ValadocApiItemClass *) klass)->check_comments = (void (*) (ValadocApiItem *, ValadocSettings*, ValadocDocumentationParser*)) valadoc_api_typesymbol_real_check_comments;
	G_OBJECT_CLASS (klass)->get_property = _vala_valadoc_api_typesymbol_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_valadoc_api_typesymbol_set_property;
	G_OBJECT_CLASS (klass)->finalize = valadoc_api_typesymbol_finalize;
	/**
	 * Specifies whether this symbol is a basic type (string, int, char, etc)
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALADOC_API_TYPESYMBOL_IS_BASIC_TYPE_PROPERTY, valadoc_api_typesymbol_properties[VALADOC_API_TYPESYMBOL_IS_BASIC_TYPE_PROPERTY] = g_param_spec_boolean ("is-basic-type", "is-basic-type", "is-basic-type", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}


static void
valadoc_api_typesymbol_instance_init (ValadocApiTypeSymbol * self)
{
	self->priv = VALADOC_API_TYPESYMBOL_GET_PRIVATE (self);
}


static void
valadoc_api_typesymbol_finalize (GObject * obj)
{
	ValadocApiTypeSymbol * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALADOC_API_TYPE_TYPESYMBOL, ValadocApiTypeSymbol);
	_valadoc_api_source_comment_unref0 (self->priv->source_comment);
	_g_free0 (self->priv->type_macro_name);
	_g_free0 (self->priv->is_type_macro_name);
	_g_free0 (self->priv->type_cast_macro_name);
	_g_free0 (self->priv->type_function_name);
	G_OBJECT_CLASS (valadoc_api_typesymbol_parent_class)->finalize (obj);
}


/**
 * Represents a runtime data type.
 */
GType
valadoc_api_typesymbol_get_type (void)
{
	static volatile gsize valadoc_api_typesymbol_type_id__volatile = 0;
	if (g_once_init_enter (&valadoc_api_typesymbol_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ValadocApiTypeSymbolClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valadoc_api_typesymbol_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValadocApiTypeSymbol), 0, (GInstanceInitFunc) valadoc_api_typesymbol_instance_init, NULL };
		GType valadoc_api_typesymbol_type_id;
		valadoc_api_typesymbol_type_id = g_type_register_static (VALADOC_API_TYPE_SYMBOL, "ValadocApiTypeSymbol", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&valadoc_api_typesymbol_type_id__volatile, valadoc_api_typesymbol_type_id);
	}
	return valadoc_api_typesymbol_type_id__volatile;
}


static void
_vala_valadoc_api_typesymbol_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	ValadocApiTypeSymbol * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VALADOC_API_TYPE_TYPESYMBOL, ValadocApiTypeSymbol);
	switch (property_id) {
		case VALADOC_API_TYPESYMBOL_IS_BASIC_TYPE_PROPERTY:
		g_value_set_boolean (value, valadoc_api_typesymbol_get_is_basic_type (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_valadoc_api_typesymbol_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	ValadocApiTypeSymbol * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VALADOC_API_TYPE_TYPESYMBOL, ValadocApiTypeSymbol);
	switch (property_id) {
		case VALADOC_API_TYPESYMBOL_IS_BASIC_TYPE_PROPERTY:
		valadoc_api_typesymbol_set_is_basic_type (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



