/* sourcecode.c generated by valac, the Vala compiler
 * generated from sourcecode.vala, do not modify */

/* sourcecode.vala
 *
 * Copyright (C) 2008-2009 Didier Villevalois
 * Copyright (C) 2008-2012 Florian Brosch
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Didier 'Ptitjes Villevalois <ptitjes@free.fr>
 */


#include <glib.h>
#include <glib-object.h>
#include "valadoc.h"
#include <stdlib.h>
#include <string.h>
#include <glib/gstdio.h>
#include <valagee.h>

enum  {
	VALADOC_CONTENT_SOURCE_CODE_0_PROPERTY,
	VALADOC_CONTENT_SOURCE_CODE_CODE_PROPERTY,
	VALADOC_CONTENT_SOURCE_CODE_HIGHLIGHTED_CODE_PROPERTY,
	VALADOC_CONTENT_SOURCE_CODE_LANGUAGE_PROPERTY,
	VALADOC_CONTENT_SOURCE_CODE_NUM_PROPERTIES
};
static GParamSpec* valadoc_content_source_code_properties[VALADOC_CONTENT_SOURCE_CODE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _ValadocContentSourceCodePrivate {
	gchar* _code;
	ValadocContentRun* _highlighted_code;
	ValadocContentSourceCodeLanguage _language;
};


static gpointer valadoc_content_source_code_parent_class = NULL;
static ValadocContentInlineIface * valadoc_content_source_code_valadoc_content_inline_parent_iface = NULL;

#define VALADOC_CONTENT_SOURCE_CODE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALADOC_CONTENT_TYPE_SOURCE_CODE, ValadocContentSourceCodePrivate))
G_GNUC_INTERNAL ValadocContentSourceCode* valadoc_content_source_code_new (void);
G_GNUC_INTERNAL ValadocContentSourceCode* valadoc_content_source_code_construct (GType object_type);
static gchar* valadoc_content_source_code_get_path (ValadocContentSourceCode* self,
                                             const gchar* path,
                                             ValadocApiNode* container,
                                             const gchar* source_file_path,
                                             ValadocErrorReporter* reporter);
static void valadoc_content_source_code_load_source_code (ValadocContentSourceCode* self,
                                                   const gchar* _path,
                                                   ValadocApiNode* container,
                                                   const gchar* source_file_path,
                                                   ValadocErrorReporter* reporter);
static inline gboolean valadoc_content_source_code_is_empty_string (ValadocContentSourceCode* self,
                                                      const gchar* line);
static gchar* valadoc_content_source_code_strip_code (ValadocContentSourceCode* self,
                                               const gchar* code);
static void valadoc_content_source_code_real_check (ValadocContentContentElement* base,
                                             ValadocApiTree* api_root,
                                             ValadocApiNode* container,
                                             const gchar* file_path,
                                             ValadocErrorReporter* reporter,
                                             ValadocSettings* settings);
static void valadoc_content_source_code_set_highlighted_code (ValadocContentSourceCode* self,
                                                       ValadocContentRun* value);
G_GNUC_INTERNAL ValadocContentRun* valadoc_content_run_new (ValadocContentRunStyle style);
G_GNUC_INTERNAL ValadocContentRun* valadoc_content_run_construct (GType object_type,
                                                  ValadocContentRunStyle style);
G_GNUC_INTERNAL ValadocContentText* valadoc_content_text_new (const gchar* text);
G_GNUC_INTERNAL ValadocContentText* valadoc_content_text_construct (GType object_type,
                                                    const gchar* text);
static void valadoc_content_source_code_real_accept (ValadocContentContentElement* base,
                                              ValadocContentContentVisitor* visitor);
static void valadoc_content_source_code_real_accept_children (ValadocContentContentElement* base,
                                                       ValadocContentContentVisitor* visitor);
static gboolean valadoc_content_source_code_real_is_empty (ValadocContentContentElement* base);
static ValadocContentContentElement* valadoc_content_source_code_real_copy (ValadocContentContentElement* base,
                                                                     ValadocContentContentElement* new_parent);
G_GNUC_INTERNAL void valadoc_content_content_element_set_parent (ValadocContentContentElement* self,
                                                 ValadocContentContentElement* value);
static void valadoc_content_source_code_finalize (GObject * obj);
static void _vala_valadoc_content_source_code_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec);
static void _vala_valadoc_content_source_code_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static gint
string_last_index_of (const gchar* self,
                      const gchar* needle,
                      gint start_index)
{
	gint result = 0;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (needle != NULL, 0);
	_tmp0_ = g_strrstr (((gchar*) self) + start_index, (gchar*) needle);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	if (_tmp1_ != NULL) {
		gchar* _tmp2_;
		_tmp2_ = _result_;
		result = (gint) (_tmp2_ - ((gchar*) self));
		return result;
	} else {
		result = -1;
		return result;
	}
}


static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
	end = _tmp0_;
	_tmp1_ = end;
	if (_tmp1_ == NULL) {
		result = maxlen;
		return result;
	} else {
		gchar* _tmp2_;
		_tmp2_ = end;
		result = (glong) (_tmp2_ - str);
		return result;
	}
}


static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp6_;
	gchar* _tmp7_;
	g_return_val_if_fail (self != NULL, NULL);
	if (offset >= ((glong) 0)) {
		_tmp0_ = len >= ((glong) 0);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		string_length = string_strnlen ((gchar*) self, offset + len);
	} else {
		gint _tmp1_;
		gint _tmp2_;
		_tmp1_ = strlen (self);
		_tmp2_ = _tmp1_;
		string_length = (glong) _tmp2_;
	}
	if (offset < ((glong) 0)) {
		glong _tmp3_;
		_tmp3_ = string_length;
		offset = _tmp3_ + offset;
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
	} else {
		glong _tmp4_;
		_tmp4_ = string_length;
		g_return_val_if_fail (offset <= _tmp4_, NULL);
	}
	if (len < ((glong) 0)) {
		glong _tmp5_;
		_tmp5_ = string_length;
		len = _tmp5_ - offset;
	}
	_tmp6_ = string_length;
	g_return_val_if_fail ((offset + len) <= _tmp6_, NULL);
	_tmp7_ = g_strndup (((gchar*) self) + offset, (gsize) len);
	result = _tmp7_;
	return result;
}


ValadocContentSourceCodeLanguage
valadoc_content_source_code_language_from_path (const gchar* path)
{
	ValadocContentSourceCodeLanguage result = 0;
	gint pos = 0;
	gint _tmp0_;
	gchar* ext = NULL;
	gint _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	g_return_val_if_fail (path != NULL, 0);
	pos = string_last_index_of (path, ".", 0);
	_tmp0_ = pos;
	if (_tmp0_ < 0) {
		result = VALADOC_CONTENT_SOURCE_CODE_LANGUAGE_UNKNOWN;
		return result;
	}
	_tmp1_ = pos;
	_tmp2_ = string_substring (path, (glong) (_tmp1_ + 1), (glong) -1);
	ext = _tmp2_;
	_tmp3_ = ext;
	result = valadoc_content_source_code_language_from_string (_tmp3_, TRUE);
	_g_free0 (ext);
	return result;
}


ValadocContentSourceCodeLanguage
valadoc_content_source_code_language_from_string (const gchar* str,
                                                  gboolean is_extension)
{
	ValadocContentSourceCodeLanguage result = 0;
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
	static GQuark _tmp1_label0 = 0;
	static GQuark _tmp1_label1 = 0;
	static GQuark _tmp1_label2 = 0;
	static GQuark _tmp1_label3 = 0;
	static GQuark _tmp1_label4 = 0;
	static GQuark _tmp1_label5 = 0;
	g_return_val_if_fail (str != NULL, 0);
	_tmp0_ = str;
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("genie")))) {
		switch (0) {
			default:
			{
				if (is_extension) {
					result = VALADOC_CONTENT_SOURCE_CODE_LANGUAGE_UNKNOWN;
					return result;
				}
				result = VALADOC_CONTENT_SOURCE_CODE_LANGUAGE_GENIE;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("gs")))) {
		switch (0) {
			default:
			{
				result = VALADOC_CONTENT_SOURCE_CODE_LANGUAGE_GENIE;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("xml")))) {
		switch (0) {
			default:
			{
				result = VALADOC_CONTENT_SOURCE_CODE_LANGUAGE_XML;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("vala")))) {
		switch (0) {
			default:
			{
				result = VALADOC_CONTENT_SOURCE_CODE_LANGUAGE_VALA;
				return result;
			}
		}
	} else if ((_tmp2_ == ((0 != _tmp1_label4) ? _tmp1_label4 : (_tmp1_label4 = g_quark_from_static_string ("c")))) || (_tmp2_ == ((0 != _tmp1_label5) ? _tmp1_label5 : (_tmp1_label5 = g_quark_from_static_string ("h"))))) {
		switch (0) {
			default:
			{
				result = VALADOC_CONTENT_SOURCE_CODE_LANGUAGE_C;
				return result;
			}
		}
	}
	result = VALADOC_CONTENT_SOURCE_CODE_LANGUAGE_UNKNOWN;
	return result;
}


const gchar*
valadoc_content_source_code_language_to_string (ValadocContentSourceCodeLanguage self)
{
	const gchar* result = NULL;
	switch (self) {
		case VALADOC_CONTENT_SOURCE_CODE_LANGUAGE_GENIE:
		{
			result = "genie";
			return result;
		}
		case VALADOC_CONTENT_SOURCE_CODE_LANGUAGE_VALA:
		{
			result = "vala";
			return result;
		}
		case VALADOC_CONTENT_SOURCE_CODE_LANGUAGE_XML:
		{
			result = "xml";
			return result;
		}
		case VALADOC_CONTENT_SOURCE_CODE_LANGUAGE_C:
		{
			result = "c";
			return result;
		}
		default:
		break;
	}
	g_assert_not_reached ();
}


GType
valadoc_content_source_code_language_get_type (void)
{
	static volatile gsize valadoc_content_source_code_language_type_id__volatile = 0;
	if (g_once_init_enter (&valadoc_content_source_code_language_type_id__volatile)) {
		static const GEnumValue values[] = {{VALADOC_CONTENT_SOURCE_CODE_LANGUAGE_UNKNOWN, "VALADOC_CONTENT_SOURCE_CODE_LANGUAGE_UNKNOWN", "unknown"}, {VALADOC_CONTENT_SOURCE_CODE_LANGUAGE_GENIE, "VALADOC_CONTENT_SOURCE_CODE_LANGUAGE_GENIE", "genie"}, {VALADOC_CONTENT_SOURCE_CODE_LANGUAGE_VALA, "VALADOC_CONTENT_SOURCE_CODE_LANGUAGE_VALA", "vala"}, {VALADOC_CONTENT_SOURCE_CODE_LANGUAGE_XML, "VALADOC_CONTENT_SOURCE_CODE_LANGUAGE_XML", "xml"}, {VALADOC_CONTENT_SOURCE_CODE_LANGUAGE_C, "VALADOC_CONTENT_SOURCE_CODE_LANGUAGE_C", "c"}, {0, NULL, NULL}};
		GType valadoc_content_source_code_language_type_id;
		valadoc_content_source_code_language_type_id = g_enum_register_static ("ValadocContentSourceCodeLanguage", values);
		g_once_init_leave (&valadoc_content_source_code_language_type_id__volatile, valadoc_content_source_code_language_type_id);
	}
	return valadoc_content_source_code_language_type_id__volatile;
}


G_GNUC_INTERNAL ValadocContentSourceCode*
valadoc_content_source_code_construct (GType object_type)
{
	ValadocContentSourceCode * self = NULL;
	self = (ValadocContentSourceCode*) valadoc_content_content_element_construct (object_type);
	self->priv->_language = VALADOC_CONTENT_SOURCE_CODE_LANGUAGE_VALA;
	return self;
}


G_GNUC_INTERNAL ValadocContentSourceCode*
valadoc_content_source_code_new (void)
{
	return valadoc_content_source_code_construct (VALADOC_CONTENT_TYPE_SOURCE_CODE);
}


static gchar*
valadoc_content_source_code_get_path (ValadocContentSourceCode* self,
                                      const gchar* path,
                                      ValadocApiNode* container,
                                      const gchar* source_file_path,
                                      ValadocErrorReporter* reporter)
{
	gchar* result = NULL;
	gchar* _tmp18_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (path != NULL, NULL);
	g_return_val_if_fail (container != NULL, NULL);
	g_return_val_if_fail (source_file_path != NULL, NULL);
	g_return_val_if_fail (reporter != NULL, NULL);
	if (!g_path_is_absolute (path)) {
		gchar* relative_to_file = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		const gchar* _tmp4_;
		_tmp0_ = g_path_get_dirname (source_file_path);
		_tmp1_ = _tmp0_;
		_tmp2_ = g_build_path (G_DIR_SEPARATOR_S, _tmp1_, path, NULL);
		_tmp3_ = _tmp2_;
		_g_free0 (_tmp1_);
		relative_to_file = _tmp3_;
		_tmp4_ = relative_to_file;
		if (g_file_test (_tmp4_, G_FILE_TEST_EXISTS | G_FILE_TEST_IS_REGULAR)) {
			gchar* _tmp5_;
			_tmp5_ = relative_to_file;
			relative_to_file = NULL;
			result = _tmp5_;
			_g_free0 (relative_to_file);
			return result;
		}
		_g_free0 (relative_to_file);
	}
	if (!g_file_test (path, G_FILE_TEST_EXISTS | G_FILE_TEST_IS_REGULAR)) {
		gchar* _tmp6_ = NULL;
		gchar* node_segment = NULL;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		const gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		const gchar* _tmp17_;
		if (G_TYPE_CHECK_INSTANCE_TYPE (container, VALADOC_API_TYPE_PACKAGE)) {
			gchar* _tmp7_;
			_tmp7_ = g_strdup ("");
			_g_free0 (_tmp6_);
			_tmp6_ = _tmp7_;
		} else {
			gchar* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
			_tmp8_ = valadoc_api_node_get_full_name (container);
			_tmp9_ = _tmp8_;
			_tmp10_ = g_strconcat (_tmp9_, ": ", NULL);
			_g_free0 (_tmp6_);
			_tmp6_ = _tmp10_;
			_g_free0 (_tmp9_);
		}
		_tmp11_ = g_strdup (_tmp6_);
		node_segment = _tmp11_;
		_tmp12_ = g_strdup_printf ("File '%s' does not exist", path);
		_tmp13_ = _tmp12_;
		valadoc_content_source_code_set_code (self, _tmp13_);
		_g_free0 (_tmp13_);
		_tmp14_ = node_segment;
		_tmp15_ = g_strdup_printf ("%s: %s{{{", source_file_path, _tmp14_);
		_tmp16_ = _tmp15_;
		_tmp17_ = self->priv->_code;
		valadoc_error_reporter_simple_warning (reporter, _tmp16_, "%s", _tmp17_);
		_g_free0 (_tmp16_);
		result = NULL;
		_g_free0 (node_segment);
		_g_free0 (_tmp6_);
		return result;
	}
	_tmp18_ = g_strdup (path);
	result = _tmp18_;
	return result;
}


static void
valadoc_content_source_code_load_source_code (ValadocContentSourceCode* self,
                                              const gchar* _path,
                                              ValadocApiNode* container,
                                              const gchar* source_file_path,
                                              ValadocErrorReporter* reporter)
{
	gchar* path = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (_path != NULL);
	g_return_if_fail (container != NULL);
	g_return_if_fail (source_file_path != NULL);
	g_return_if_fail (reporter != NULL);
	_tmp0_ = valadoc_content_source_code_get_path (self, _path, container, source_file_path, reporter);
	path = _tmp0_;
	_tmp1_ = path;
	if (_tmp1_ == NULL) {
		_g_free0 (path);
		return;
	}
	{
		gchar* content = NULL;
		const gchar* _tmp2_;
		gchar* _tmp3_ = NULL;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		content = NULL;
		_tmp2_ = path;
		g_file_get_contents (_tmp2_, &_tmp3_, NULL, &_inner_error_);
		_g_free0 (content);
		content = _tmp3_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_free0 (content);
			if (_inner_error_->domain == G_FILE_ERROR) {
				goto __catch19_g_file_error;
			}
			_g_free0 (content);
			_g_free0 (path);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		_tmp4_ = path;
		self->priv->_language = valadoc_content_source_code_language_from_path (_tmp4_);
		_tmp5_ = content;
		content = NULL;
		_tmp6_ = _tmp5_;
		valadoc_content_source_code_set_code (self, _tmp6_);
		_g_free0 (_tmp6_);
		_g_free0 (content);
	}
	goto __finally19;
	__catch19_g_file_error:
	{
		GError* err = NULL;
		gchar* _tmp7_ = NULL;
		gchar* node_segment = NULL;
		gchar* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		const gchar* _tmp16_;
		GError* _tmp17_;
		const gchar* _tmp18_;
		err = _inner_error_;
		_inner_error_ = NULL;
		if (G_TYPE_CHECK_INSTANCE_TYPE (container, VALADOC_API_TYPE_PACKAGE)) {
			gchar* _tmp8_;
			_tmp8_ = g_strdup ("");
			_g_free0 (_tmp7_);
			_tmp7_ = _tmp8_;
		} else {
			gchar* _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
			_tmp9_ = valadoc_api_node_get_full_name (container);
			_tmp10_ = _tmp9_;
			_tmp11_ = g_strconcat (_tmp10_, ": ", NULL);
			_g_free0 (_tmp7_);
			_tmp7_ = _tmp11_;
			_g_free0 (_tmp10_);
		}
		_tmp12_ = g_strdup (_tmp7_);
		node_segment = _tmp12_;
		_tmp13_ = node_segment;
		_tmp14_ = g_strdup_printf ("%s: %s{{{", source_file_path, _tmp13_);
		_tmp15_ = _tmp14_;
		_tmp16_ = path;
		_tmp17_ = err;
		_tmp18_ = _tmp17_->message;
		valadoc_error_reporter_simple_error (reporter, _tmp15_, "Can't read file '%s': %s", _tmp16_, _tmp18_);
		_g_free0 (_tmp15_);
		_g_free0 (node_segment);
		_g_free0 (_tmp7_);
		_g_error_free0 (err);
	}
	__finally19:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_free0 (path);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_g_free0 (path);
}


static gchar
string_get (const gchar* self,
            glong index)
{
	gchar result = '\0';
	gchar _tmp0_;
	g_return_val_if_fail (self != NULL, '\0');
	_tmp0_ = ((gchar*) self)[index];
	result = _tmp0_;
	return result;
}


static inline gboolean
valadoc_content_source_code_is_empty_string (ValadocContentSourceCode* self,
                                             const gchar* line)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (line != NULL, FALSE);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_;
				gint _tmp3_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = i;
				if (!(string_get (line, (glong) _tmp2_) != '\0')) {
					break;
				}
				_tmp3_ = i;
				if (g_ascii_isspace (string_get (line, (glong) _tmp3_)) == FALSE) {
					result = FALSE;
					return result;
				}
			}
		}
	}
	result = TRUE;
	return result;
}


static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  int str_array_length1)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	if (separator == NULL) {
		separator = "";
	}
	if (str_array != NULL) {
		gboolean _tmp1_ = FALSE;
		if (str_array_length1 > 0) {
			_tmp1_ = TRUE;
		} else {
			gboolean _tmp2_ = FALSE;
			if (str_array_length1 == -1) {
				const gchar* _tmp3_;
				_tmp3_ = str_array[0];
				_tmp2_ = _tmp3_ != NULL;
			} else {
				_tmp2_ = FALSE;
			}
			_tmp1_ = _tmp2_;
		}
		_tmp0_ = _tmp1_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gint i = 0;
		gsize len = 0UL;
		gint _tmp20_;
		gint _tmp22_;
		gint _tmp23_;
		gsize _tmp24_;
		gint _tmp25_;
		gint _tmp26_;
		gint _tmp27_;
		const gchar* res = NULL;
		gsize _tmp28_;
		void* _tmp29_;
		void* ptr = NULL;
		const gchar* _tmp30_;
		const gchar* _tmp31_;
		void* _tmp32_;
		const gchar* _tmp45_;
		len = (gsize) 1;
		{
			gboolean _tmp4_ = FALSE;
			i = 0;
			_tmp4_ = TRUE;
			while (TRUE) {
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp12_ = 0;
				gint _tmp13_;
				const gchar* _tmp14_;
				gsize _tmp19_;
				if (!_tmp4_) {
					gint _tmp5_;
					_tmp5_ = i;
					i = _tmp5_ + 1;
				}
				_tmp4_ = FALSE;
				if (str_array_length1 != -1) {
					gint _tmp8_;
					_tmp8_ = i;
					_tmp7_ = _tmp8_ < str_array_length1;
				} else {
					_tmp7_ = FALSE;
				}
				if (_tmp7_) {
					_tmp6_ = TRUE;
				} else {
					gboolean _tmp9_ = FALSE;
					if (str_array_length1 == -1) {
						gint _tmp10_;
						const gchar* _tmp11_;
						_tmp10_ = i;
						_tmp11_ = str_array[_tmp10_];
						_tmp9_ = _tmp11_ != NULL;
					} else {
						_tmp9_ = FALSE;
					}
					_tmp6_ = _tmp9_;
				}
				if (!_tmp6_) {
					break;
				}
				_tmp13_ = i;
				_tmp14_ = str_array[_tmp13_];
				if (_tmp14_ != NULL) {
					gint _tmp15_;
					const gchar* _tmp16_;
					gint _tmp17_;
					gint _tmp18_;
					_tmp15_ = i;
					_tmp16_ = str_array[_tmp15_];
					_tmp17_ = strlen ((const gchar*) _tmp16_);
					_tmp18_ = _tmp17_;
					_tmp12_ = _tmp18_;
				} else {
					_tmp12_ = 0;
				}
				_tmp19_ = len;
				len = _tmp19_ + _tmp12_;
			}
		}
		_tmp20_ = i;
		if (_tmp20_ == 0) {
			gchar* _tmp21_;
			_tmp21_ = g_strdup ("");
			result = _tmp21_;
			return result;
		}
		_tmp22_ = i;
		str_array_length1 = _tmp22_;
		_tmp23_ = str_array_length1;
		_tmp24_ = len;
		_tmp25_ = strlen ((const gchar*) separator);
		_tmp26_ = _tmp25_;
		_tmp27_ = i;
		len = _tmp24_ + (_tmp26_ * (_tmp27_ - 1));
		_tmp28_ = len;
		_tmp29_ = g_malloc (_tmp28_);
		res = _tmp29_;
		_tmp30_ = res;
		_tmp31_ = str_array[0];
		_tmp32_ = g_stpcpy ((void*) _tmp30_, (const gchar*) _tmp31_);
		ptr = _tmp32_;
		{
			gboolean _tmp33_ = FALSE;
			i = 1;
			_tmp33_ = TRUE;
			while (TRUE) {
				gint _tmp35_;
				void* _tmp36_;
				void* _tmp37_;
				const gchar* _tmp38_ = NULL;
				gint _tmp39_;
				const gchar* _tmp40_;
				void* _tmp43_;
				void* _tmp44_;
				if (!_tmp33_) {
					gint _tmp34_;
					_tmp34_ = i;
					i = _tmp34_ + 1;
				}
				_tmp33_ = FALSE;
				_tmp35_ = i;
				if (!(_tmp35_ < str_array_length1)) {
					break;
				}
				_tmp36_ = ptr;
				_tmp37_ = g_stpcpy (_tmp36_, (const gchar*) separator);
				ptr = _tmp37_;
				_tmp39_ = i;
				_tmp40_ = str_array[_tmp39_];
				if (_tmp40_ != NULL) {
					gint _tmp41_;
					const gchar* _tmp42_;
					_tmp41_ = i;
					_tmp42_ = str_array[_tmp41_];
					_tmp38_ = (const gchar*) _tmp42_;
				} else {
					_tmp38_ = "";
				}
				_tmp43_ = ptr;
				_tmp44_ = g_stpcpy (_tmp43_, _tmp38_);
				ptr = _tmp44_;
			}
		}
		_tmp45_ = res;
		res = NULL;
		result = (gchar*) _tmp45_;
		return result;
	} else {
		gchar* _tmp46_;
		_tmp46_ = g_strdup ("");
		result = _tmp46_;
		return result;
	}
}


static gchar*
valadoc_content_source_code_strip_code (ValadocContentSourceCode* self,
                                        const gchar* code)
{
	gchar* result = NULL;
	gchar** lines = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint lines_length1;
	gint _lines_size_;
	const gchar** _lines = NULL;
	gchar** _tmp13_;
	gint _tmp13__length1;
	const gchar** _tmp25_;
	gchar* _tmp26_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (code != NULL, NULL);
	_tmp1_ = _tmp0_ = g_strsplit (code, "\n", 0);
	lines = _tmp1_;
	lines_length1 = _vala_array_length (_tmp0_);
	_lines_size_ = lines_length1;
	{
		gint i = 0;
		gchar** _tmp2_;
		gint _tmp2__length1;
		_tmp2_ = lines;
		_tmp2__length1 = lines_length1;
		i = _tmp2__length1 - 1;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				gboolean _tmp5_ = FALSE;
				gint _tmp6_;
				gchar** _tmp10_;
				gint _tmp10__length1;
				gint _tmp11_;
				gchar* _tmp12_;
				if (!_tmp3_) {
					gint _tmp4_;
					_tmp4_ = i;
					i = _tmp4_ - 1;
				}
				_tmp3_ = FALSE;
				_tmp6_ = i;
				if (_tmp6_ >= 0) {
					gchar** _tmp7_;
					gint _tmp7__length1;
					gint _tmp8_;
					const gchar* _tmp9_;
					_tmp7_ = lines;
					_tmp7__length1 = lines_length1;
					_tmp8_ = i;
					_tmp9_ = _tmp7_[_tmp8_];
					_tmp5_ = valadoc_content_source_code_is_empty_string (self, _tmp9_);
				} else {
					_tmp5_ = FALSE;
				}
				if (!_tmp5_) {
					break;
				}
				_tmp10_ = lines;
				_tmp10__length1 = lines_length1;
				_tmp11_ = i;
				_g_free0 (_tmp10_[_tmp11_]);
				_tmp10_[_tmp11_] = NULL;
				_tmp12_ = _tmp10_[_tmp11_];
			}
		}
	}
	_tmp13_ = lines;
	_tmp13__length1 = lines_length1;
	_lines = _tmp13_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp14_ = FALSE;
			_tmp14_ = TRUE;
			while (TRUE) {
				gboolean _tmp16_ = FALSE;
				gchar** _tmp17_;
				gint _tmp17__length1;
				gint _tmp18_;
				const gchar* _tmp19_;
				gchar** _tmp23_;
				gint _tmp23__length1;
				gint _tmp24_;
				if (!_tmp14_) {
					gint _tmp15_;
					_tmp15_ = i;
					i = _tmp15_ + 1;
				}
				_tmp14_ = FALSE;
				_tmp17_ = lines;
				_tmp17__length1 = lines_length1;
				_tmp18_ = i;
				_tmp19_ = _tmp17_[_tmp18_];
				if (_tmp19_ != NULL) {
					gchar** _tmp20_;
					gint _tmp20__length1;
					gint _tmp21_;
					const gchar* _tmp22_;
					_tmp20_ = lines;
					_tmp20__length1 = lines_length1;
					_tmp21_ = i;
					_tmp22_ = _tmp20_[_tmp21_];
					_tmp16_ = valadoc_content_source_code_is_empty_string (self, _tmp22_);
				} else {
					_tmp16_ = FALSE;
				}
				if (!_tmp16_) {
					break;
				}
				_tmp23_ = lines;
				_tmp23__length1 = lines_length1;
				_tmp24_ = i;
				_lines = &_tmp23_[_tmp24_ + 1];
			}
		}
	}
	_tmp25_ = _lines;
	_tmp26_ = _vala_g_strjoinv ("\n", (gchar**) _tmp25_, -1);
	result = _tmp26_;
	lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
	return result;
}


static gchar*
string_strip (const gchar* self)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	g_strstrip (_tmp1_);
	result = _result_;
	return result;
}


static void
valadoc_content_source_code_real_check (ValadocContentContentElement* base,
                                        ValadocApiTree* api_root,
                                        ValadocApiNode* container,
                                        const gchar* file_path,
                                        ValadocErrorReporter* reporter,
                                        ValadocSettings* settings)
{
	ValadocContentSourceCode * self;
	gchar** splitted = NULL;
	const gchar* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint splitted_length1;
	gint _splitted_size_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gboolean _tmp7_;
	const gchar* _tmp40_;
	gchar* _tmp41_;
	gchar* _tmp42_;
	ValadocContentSourceCodeLanguage _tmp43_;
	self = (ValadocContentSourceCode*) base;
	g_return_if_fail (api_root != NULL);
	g_return_if_fail (container != NULL);
	g_return_if_fail (file_path != NULL);
	g_return_if_fail (reporter != NULL);
	g_return_if_fail (settings != NULL);
	_tmp0_ = self->priv->_code;
	_tmp2_ = _tmp1_ = g_strsplit (_tmp0_, "\n", 2);
	splitted = _tmp2_;
	splitted_length1 = _vala_array_length (_tmp1_);
	_splitted_size_ = splitted_length1;
	_tmp3_ = splitted;
	_tmp3__length1 = splitted_length1;
	_tmp4_ = _tmp3_[0];
	_tmp5_ = string_strip (_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = g_strcmp0 (_tmp6_, "") == 0;
	_g_free0 (_tmp6_);
	if (_tmp7_) {
		const gchar* _tmp8_ = NULL;
		gchar** _tmp9_;
		gint _tmp9__length1;
		const gchar* _tmp10_;
		_tmp9_ = splitted;
		_tmp9__length1 = splitted_length1;
		_tmp10_ = _tmp9_[1];
		_tmp8_ = _tmp10_;
		if (_tmp8_ == NULL) {
			_tmp8_ = "";
		}
		valadoc_content_source_code_set_code (self, _tmp8_);
	} else {
		gchar** _tmp11_;
		gint _tmp11__length1;
		const gchar* _tmp12_;
		_tmp11_ = splitted;
		_tmp11__length1 = splitted_length1;
		_tmp12_ = _tmp11_[0];
		if (g_str_has_prefix (_tmp12_, "#!")) {
			const gchar* start = NULL;
			gchar** _tmp13_;
			gint _tmp13__length1;
			const gchar* _tmp14_;
			const gchar* _tmp15_;
			_tmp13_ = splitted;
			_tmp13__length1 = splitted_length1;
			_tmp14_ = _tmp13_[0];
			start = (const gchar*) (((gchar*) _tmp14_) + 2);
			_tmp15_ = start;
			if (g_str_has_prefix (_tmp15_, "include:")) {
				const gchar* _tmp16_;
				gchar* path = NULL;
				const gchar* _tmp17_;
				gchar* _tmp18_;
				const gchar* _tmp19_;
				_tmp16_ = start;
				start = (const gchar*) (((gchar*) _tmp16_) + 8);
				_tmp17_ = start;
				_tmp18_ = string_strip (_tmp17_);
				path = _tmp18_;
				_tmp19_ = path;
				valadoc_content_source_code_load_source_code (self, _tmp19_, container, file_path, reporter);
				_g_free0 (path);
			} else {
				gchar* name = NULL;
				const gchar* _tmp20_;
				const gchar* _tmp21_;
				gchar* _tmp22_;
				const gchar* _tmp23_;
				const gchar* _tmp24_ = NULL;
				gchar** _tmp25_;
				gint _tmp25__length1;
				const gchar* _tmp26_;
				gboolean _tmp27_ = FALSE;
				ValadocContentSourceCodeLanguage _tmp28_;
				_tmp20_ = start;
				_tmp21_ = g_strstrip (_tmp20_);
				_tmp22_ = g_utf8_strdown (_tmp21_, (gssize) -1);
				name = _tmp22_;
				_tmp23_ = name;
				self->priv->_language = valadoc_content_source_code_language_from_string (_tmp23_, FALSE);
				_tmp25_ = splitted;
				_tmp25__length1 = splitted_length1;
				_tmp26_ = _tmp25_[1];
				_tmp24_ = _tmp26_;
				if (_tmp24_ == NULL) {
					_tmp24_ = "";
				}
				valadoc_content_source_code_set_code (self, _tmp24_);
				_tmp28_ = self->priv->_language;
				if (_tmp28_ == VALADOC_CONTENT_SOURCE_CODE_LANGUAGE_UNKNOWN) {
					const gchar* _tmp29_;
					_tmp29_ = name;
					_tmp27_ = g_strcmp0 (_tmp29_, "none") != 0;
				} else {
					_tmp27_ = FALSE;
				}
				if (_tmp27_) {
					gchar* _tmp30_ = NULL;
					gchar* node_segment = NULL;
					gchar* _tmp35_;
					const gchar* _tmp36_;
					gchar* _tmp37_;
					gchar* _tmp38_;
					const gchar* _tmp39_;
					if (G_TYPE_CHECK_INSTANCE_TYPE (container, VALADOC_API_TYPE_PACKAGE)) {
						gchar* _tmp31_;
						_tmp31_ = g_strdup ("");
						_g_free0 (_tmp30_);
						_tmp30_ = _tmp31_;
					} else {
						gchar* _tmp32_;
						gchar* _tmp33_;
						gchar* _tmp34_;
						_tmp32_ = valadoc_api_node_get_full_name (container);
						_tmp33_ = _tmp32_;
						_tmp34_ = g_strconcat (_tmp33_, ": ", NULL);
						_g_free0 (_tmp30_);
						_tmp30_ = _tmp34_;
						_g_free0 (_tmp33_);
					}
					_tmp35_ = g_strdup (_tmp30_);
					node_segment = _tmp35_;
					_tmp36_ = node_segment;
					_tmp37_ = g_strdup_printf ("%s: %s{{{", file_path, _tmp36_);
					_tmp38_ = _tmp37_;
					_tmp39_ = name;
					valadoc_error_reporter_simple_warning (reporter, _tmp38_, "Unsupported programming language '%s'", _tmp39_);
					_g_free0 (_tmp38_);
					_g_free0 (node_segment);
					_g_free0 (_tmp30_);
				}
				_g_free0 (name);
			}
		}
	}
	_tmp40_ = self->priv->_code;
	_tmp41_ = valadoc_content_source_code_strip_code (self, _tmp40_);
	_tmp42_ = _tmp41_;
	valadoc_content_source_code_set_code (self, _tmp42_);
	_g_free0 (_tmp42_);
	_tmp43_ = self->priv->_language;
	if (_tmp43_ == VALADOC_CONTENT_SOURCE_CODE_LANGUAGE_VALA) {
		ValadocHighlighterHighlighter* _tmp44_;
		ValadocHighlighterHighlighter* _tmp45_;
		const gchar* _tmp46_;
		ValadocContentRun* _tmp47_;
		ValadocContentRun* _tmp48_;
		_tmp44_ = valadoc_api_tree_get_highlighter (api_root);
		_tmp45_ = _tmp44_;
		_tmp46_ = self->priv->_code;
		_tmp47_ = valadoc_highlighter_highlighter_highlight_vala (_tmp45_, _tmp46_);
		_tmp48_ = _tmp47_;
		valadoc_content_source_code_set_highlighted_code (self, _tmp48_);
		_g_object_unref0 (_tmp48_);
	} else {
		ValadocContentSourceCodeLanguage _tmp49_;
		_tmp49_ = self->priv->_language;
		if (_tmp49_ == VALADOC_CONTENT_SOURCE_CODE_LANGUAGE_XML) {
			ValadocHighlighterHighlighter* _tmp50_;
			ValadocHighlighterHighlighter* _tmp51_;
			const gchar* _tmp52_;
			ValadocContentRun* _tmp53_;
			ValadocContentRun* _tmp54_;
			_tmp50_ = valadoc_api_tree_get_highlighter (api_root);
			_tmp51_ = _tmp50_;
			_tmp52_ = self->priv->_code;
			_tmp53_ = valadoc_highlighter_highlighter_highlight_xml (_tmp51_, _tmp52_);
			_tmp54_ = _tmp53_;
			valadoc_content_source_code_set_highlighted_code (self, _tmp54_);
			_g_object_unref0 (_tmp54_);
		} else {
			ValadocContentSourceCodeLanguage _tmp55_;
			_tmp55_ = self->priv->_language;
			if (_tmp55_ == VALADOC_CONTENT_SOURCE_CODE_LANGUAGE_C) {
				ValadocHighlighterHighlighter* _tmp56_;
				ValadocHighlighterHighlighter* _tmp57_;
				const gchar* _tmp58_;
				ValadocContentRun* _tmp59_;
				ValadocContentRun* _tmp60_;
				_tmp56_ = valadoc_api_tree_get_highlighter (api_root);
				_tmp57_ = _tmp56_;
				_tmp58_ = self->priv->_code;
				_tmp59_ = valadoc_highlighter_highlighter_highlight_c (_tmp57_, _tmp58_);
				_tmp60_ = _tmp59_;
				valadoc_content_source_code_set_highlighted_code (self, _tmp60_);
				_g_object_unref0 (_tmp60_);
			} else {
				ValadocContentRun* _tmp61_;
				ValadocContentRun* _tmp62_;
				ValadocContentRun* _tmp63_;
				ValaList* _tmp64_;
				ValaList* _tmp65_;
				const gchar* _tmp66_;
				ValadocContentText* _tmp67_;
				ValadocContentText* _tmp68_;
				_tmp61_ = valadoc_content_run_new (VALADOC_CONTENT_RUN_STYLE_MONOSPACED);
				_tmp62_ = _tmp61_;
				valadoc_content_source_code_set_highlighted_code (self, _tmp62_);
				_g_object_unref0 (_tmp62_);
				_tmp63_ = self->priv->_highlighted_code;
				_tmp64_ = valadoc_content_inline_content_get_content ((ValadocContentInlineContent*) _tmp63_);
				_tmp65_ = _tmp64_;
				_tmp66_ = self->priv->_code;
				_tmp67_ = valadoc_content_text_new (_tmp66_);
				_tmp68_ = _tmp67_;
				vala_collection_add ((ValaCollection*) _tmp65_, (ValadocContentInline*) _tmp68_);
				_g_object_unref0 (_tmp68_);
			}
		}
	}
	splitted = (_vala_array_free (splitted, splitted_length1, (GDestroyNotify) g_free), NULL);
}


static void
valadoc_content_source_code_real_accept (ValadocContentContentElement* base,
                                         ValadocContentContentVisitor* visitor)
{
	ValadocContentSourceCode * self;
	self = (ValadocContentSourceCode*) base;
	g_return_if_fail (visitor != NULL);
	valadoc_content_content_visitor_visit_source_code (visitor, self);
}


static void
valadoc_content_source_code_real_accept_children (ValadocContentContentElement* base,
                                                  ValadocContentContentVisitor* visitor)
{
	ValadocContentSourceCode * self;
	ValadocContentRun* _tmp0_;
	self = (ValadocContentSourceCode*) base;
	g_return_if_fail (visitor != NULL);
	_tmp0_ = self->priv->_highlighted_code;
	if (_tmp0_ != NULL) {
		ValadocContentRun* _tmp1_;
		_tmp1_ = self->priv->_highlighted_code;
		valadoc_content_content_element_accept ((ValadocContentContentElement*) _tmp1_, visitor);
	}
}


static gboolean
valadoc_content_source_code_real_is_empty (ValadocContentContentElement* base)
{
	ValadocContentSourceCode * self;
	gboolean result = FALSE;
	self = (ValadocContentSourceCode*) base;
	result = FALSE;
	return result;
}


static ValadocContentContentElement*
valadoc_content_source_code_real_copy (ValadocContentContentElement* base,
                                       ValadocContentContentElement* new_parent)
{
	ValadocContentSourceCode * self;
	ValadocContentContentElement* result = NULL;
	ValadocContentSourceCode* source_code = NULL;
	ValadocContentSourceCode* _tmp0_;
	ValadocContentSourceCodeLanguage _tmp1_;
	const gchar* _tmp2_;
	self = (ValadocContentSourceCode*) base;
	_tmp0_ = valadoc_content_source_code_new ();
	source_code = _tmp0_;
	valadoc_content_content_element_set_parent ((ValadocContentContentElement*) source_code, new_parent);
	_tmp1_ = self->priv->_language;
	valadoc_content_source_code_set_language (source_code, _tmp1_);
	_tmp2_ = self->priv->_code;
	valadoc_content_source_code_set_code (source_code, _tmp2_);
	result = (ValadocContentContentElement*) source_code;
	return result;
}


const gchar*
valadoc_content_source_code_get_code (ValadocContentSourceCode* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_code;
	result = _tmp0_;
	return result;
}


void
valadoc_content_source_code_set_code (ValadocContentSourceCode* self,
                                      const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, valadoc_content_source_code_get_code (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_code);
		self->priv->_code = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, valadoc_content_source_code_properties[VALADOC_CONTENT_SOURCE_CODE_CODE_PROPERTY]);
	}
}


ValadocContentRun*
valadoc_content_source_code_get_highlighted_code (ValadocContentSourceCode* self)
{
	ValadocContentRun* result;
	ValadocContentRun* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_highlighted_code;
	result = _tmp0_;
	return result;
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static void
valadoc_content_source_code_set_highlighted_code (ValadocContentSourceCode* self,
                                                  ValadocContentRun* value)
{
	g_return_if_fail (self != NULL);
	if (valadoc_content_source_code_get_highlighted_code (self) != value) {
		ValadocContentRun* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_highlighted_code);
		self->priv->_highlighted_code = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, valadoc_content_source_code_properties[VALADOC_CONTENT_SOURCE_CODE_HIGHLIGHTED_CODE_PROPERTY]);
	}
}


ValadocContentSourceCodeLanguage
valadoc_content_source_code_get_language (ValadocContentSourceCode* self)
{
	ValadocContentSourceCodeLanguage result;
	ValadocContentSourceCodeLanguage _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_language;
	result = _tmp0_;
	return result;
}


void
valadoc_content_source_code_set_language (ValadocContentSourceCode* self,
                                          ValadocContentSourceCodeLanguage value)
{
	g_return_if_fail (self != NULL);
	if (valadoc_content_source_code_get_language (self) != value) {
		self->priv->_language = value;
		g_object_notify_by_pspec ((GObject *) self, valadoc_content_source_code_properties[VALADOC_CONTENT_SOURCE_CODE_LANGUAGE_PROPERTY]);
	}
}


static void
valadoc_content_source_code_class_init (ValadocContentSourceCodeClass * klass)
{
	valadoc_content_source_code_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ValadocContentSourceCodePrivate));
	((ValadocContentContentElementClass *) klass)->check = (void (*) (ValadocContentContentElement *, ValadocApiTree*, ValadocApiNode*, const gchar*, ValadocErrorReporter*, ValadocSettings*)) valadoc_content_source_code_real_check;
	((ValadocContentContentElementClass *) klass)->accept = (void (*) (ValadocContentContentElement *, ValadocContentContentVisitor*)) valadoc_content_source_code_real_accept;
	((ValadocContentContentElementClass *) klass)->accept_children = (void (*) (ValadocContentContentElement *, ValadocContentContentVisitor*)) valadoc_content_source_code_real_accept_children;
	((ValadocContentContentElementClass *) klass)->is_empty = (gboolean (*) (ValadocContentContentElement *)) valadoc_content_source_code_real_is_empty;
	((ValadocContentContentElementClass *) klass)->copy = (ValadocContentContentElement* (*) (ValadocContentContentElement *, ValadocContentContentElement*)) valadoc_content_source_code_real_copy;
	G_OBJECT_CLASS (klass)->get_property = _vala_valadoc_content_source_code_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_valadoc_content_source_code_set_property;
	G_OBJECT_CLASS (klass)->finalize = valadoc_content_source_code_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALADOC_CONTENT_SOURCE_CODE_CODE_PROPERTY, valadoc_content_source_code_properties[VALADOC_CONTENT_SOURCE_CODE_CODE_PROPERTY] = g_param_spec_string ("code", "code", "code", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALADOC_CONTENT_SOURCE_CODE_HIGHLIGHTED_CODE_PROPERTY, valadoc_content_source_code_properties[VALADOC_CONTENT_SOURCE_CODE_HIGHLIGHTED_CODE_PROPERTY] = g_param_spec_object ("highlighted-code", "highlighted-code", "highlighted-code", VALADOC_CONTENT_TYPE_RUN, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALADOC_CONTENT_SOURCE_CODE_LANGUAGE_PROPERTY, valadoc_content_source_code_properties[VALADOC_CONTENT_SOURCE_CODE_LANGUAGE_PROPERTY] = g_param_spec_enum ("language", "language", "language", VALADOC_CONTENT_SOURCE_CODE_TYPE_LANGUAGE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void
valadoc_content_source_code_valadoc_content_inline_interface_init (ValadocContentInlineIface * iface)
{
	valadoc_content_source_code_valadoc_content_inline_parent_iface = g_type_interface_peek_parent (iface);
}


static void
valadoc_content_source_code_instance_init (ValadocContentSourceCode * self)
{
	self->priv = VALADOC_CONTENT_SOURCE_CODE_GET_PRIVATE (self);
}


static void
valadoc_content_source_code_finalize (GObject * obj)
{
	ValadocContentSourceCode * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALADOC_CONTENT_TYPE_SOURCE_CODE, ValadocContentSourceCode);
	_g_free0 (self->priv->_code);
	_g_object_unref0 (self->priv->_highlighted_code);
	G_OBJECT_CLASS (valadoc_content_source_code_parent_class)->finalize (obj);
}


GType
valadoc_content_source_code_get_type (void)
{
	static volatile gsize valadoc_content_source_code_type_id__volatile = 0;
	if (g_once_init_enter (&valadoc_content_source_code_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ValadocContentSourceCodeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valadoc_content_source_code_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValadocContentSourceCode), 0, (GInstanceInitFunc) valadoc_content_source_code_instance_init, NULL };
		static const GInterfaceInfo valadoc_content_inline_info = { (GInterfaceInitFunc) valadoc_content_source_code_valadoc_content_inline_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType valadoc_content_source_code_type_id;
		valadoc_content_source_code_type_id = g_type_register_static (VALADOC_CONTENT_TYPE_CONTENT_ELEMENT, "ValadocContentSourceCode", &g_define_type_info, 0);
		g_type_add_interface_static (valadoc_content_source_code_type_id, VALADOC_CONTENT_TYPE_INLINE, &valadoc_content_inline_info);
		g_once_init_leave (&valadoc_content_source_code_type_id__volatile, valadoc_content_source_code_type_id);
	}
	return valadoc_content_source_code_type_id__volatile;
}


static void
_vala_valadoc_content_source_code_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec)
{
	ValadocContentSourceCode * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VALADOC_CONTENT_TYPE_SOURCE_CODE, ValadocContentSourceCode);
	switch (property_id) {
		case VALADOC_CONTENT_SOURCE_CODE_CODE_PROPERTY:
		g_value_set_string (value, valadoc_content_source_code_get_code (self));
		break;
		case VALADOC_CONTENT_SOURCE_CODE_HIGHLIGHTED_CODE_PROPERTY:
		g_value_set_object (value, valadoc_content_source_code_get_highlighted_code (self));
		break;
		case VALADOC_CONTENT_SOURCE_CODE_LANGUAGE_PROPERTY:
		g_value_set_enum (value, valadoc_content_source_code_get_language (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_valadoc_content_source_code_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec)
{
	ValadocContentSourceCode * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VALADOC_CONTENT_TYPE_SOURCE_CODE, ValadocContentSourceCode);
	switch (property_id) {
		case VALADOC_CONTENT_SOURCE_CODE_CODE_PROPERTY:
		valadoc_content_source_code_set_code (self, g_value_get_string (value));
		break;
		case VALADOC_CONTENT_SOURCE_CODE_HIGHLIGHTED_CODE_PROPERTY:
		valadoc_content_source_code_set_highlighted_code (self, g_value_get_object (value));
		break;
		case VALADOC_CONTENT_SOURCE_CODE_LANGUAGE_PROPERTY:
		valadoc_content_source_code_set_language (self, g_value_get_enum (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



