/* valaaddressofexpression.c generated by valac, the Vala compiler
 * generated from valaaddressofexpression.vala, do not modify */

/* valaaddressofexpression.vala
 *
 * Copyright (C) 2007-2010  Jürg Billeter
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Jürg Billeter <j@bitron.ch>
 */


#include <glib.h>
#include <glib-object.h>
#include "vala.h"

#define _vala_code_node_unref0(var) ((var == NULL) ? NULL : (var = (vala_code_node_unref (var), NULL)))

struct _ValaAddressofExpressionPrivate {
	ValaExpression* _inner;
};


static gpointer vala_addressof_expression_parent_class = NULL;

#define VALA_ADDRESSOF_EXPRESSION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALA_TYPE_ADDRESSOF_EXPRESSION, ValaAddressofExpressionPrivate))
static void vala_addressof_expression_real_accept (ValaCodeNode* base,
                                            ValaCodeVisitor* visitor);
static void vala_addressof_expression_real_accept_children (ValaCodeNode* base,
                                                     ValaCodeVisitor* visitor);
static void vala_addressof_expression_real_replace_expression (ValaCodeNode* base,
                                                        ValaExpression* old_node,
                                                        ValaExpression* new_node);
static gboolean vala_addressof_expression_real_is_pure (ValaExpression* base);
static gboolean vala_addressof_expression_real_is_accessible (ValaExpression* base,
                                                       ValaSymbol* sym);
static gboolean vala_addressof_expression_real_check (ValaCodeNode* base,
                                               ValaCodeContext* context);
static void vala_addressof_expression_real_emit (ValaCodeNode* base,
                                          ValaCodeGenerator* codegen);
static void vala_addressof_expression_finalize (ValaCodeNode * obj);


/**
 * Creates a new address-of expression.
 *
 * @param inner variable whose address is to be computed
 * @return      newly created address-of expression
 */
ValaAddressofExpression*
vala_addressof_expression_construct (GType object_type,
                                     ValaExpression* inner,
                                     ValaSourceReference* source_reference)
{
	ValaAddressofExpression* self = NULL;
	g_return_val_if_fail (inner != NULL, NULL);
	self = (ValaAddressofExpression*) vala_expression_construct (object_type);
	vala_code_node_set_source_reference ((ValaCodeNode*) self, source_reference);
	vala_addressof_expression_set_inner (self, inner);
	return self;
}


ValaAddressofExpression*
vala_addressof_expression_new (ValaExpression* inner,
                               ValaSourceReference* source_reference)
{
	return vala_addressof_expression_construct (VALA_TYPE_ADDRESSOF_EXPRESSION, inner, source_reference);
}


static void
vala_addressof_expression_real_accept (ValaCodeNode* base,
                                       ValaCodeVisitor* visitor)
{
	ValaAddressofExpression * self;
	self = (ValaAddressofExpression*) base;
	g_return_if_fail (visitor != NULL);
	vala_code_visitor_visit_addressof_expression (visitor, self);
	vala_code_visitor_visit_expression (visitor, (ValaExpression*) self);
}


static void
vala_addressof_expression_real_accept_children (ValaCodeNode* base,
                                                ValaCodeVisitor* visitor)
{
	ValaAddressofExpression * self;
	ValaExpression* _tmp0_;
	ValaExpression* _tmp1_;
	self = (ValaAddressofExpression*) base;
	g_return_if_fail (visitor != NULL);
	_tmp0_ = vala_addressof_expression_get_inner (self);
	_tmp1_ = _tmp0_;
	vala_code_node_accept ((ValaCodeNode*) _tmp1_, visitor);
}


static void
vala_addressof_expression_real_replace_expression (ValaCodeNode* base,
                                                   ValaExpression* old_node,
                                                   ValaExpression* new_node)
{
	ValaAddressofExpression * self;
	ValaExpression* _tmp0_;
	ValaExpression* _tmp1_;
	self = (ValaAddressofExpression*) base;
	g_return_if_fail (old_node != NULL);
	g_return_if_fail (new_node != NULL);
	_tmp0_ = vala_addressof_expression_get_inner (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ == old_node) {
		vala_addressof_expression_set_inner (self, new_node);
	}
}


static gboolean
vala_addressof_expression_real_is_pure (ValaExpression* base)
{
	ValaAddressofExpression * self;
	gboolean result = FALSE;
	ValaExpression* _tmp0_;
	ValaExpression* _tmp1_;
	self = (ValaAddressofExpression*) base;
	_tmp0_ = vala_addressof_expression_get_inner (self);
	_tmp1_ = _tmp0_;
	result = vala_expression_is_pure (_tmp1_);
	return result;
}


static gboolean
vala_addressof_expression_real_is_accessible (ValaExpression* base,
                                              ValaSymbol* sym)
{
	ValaAddressofExpression * self;
	gboolean result = FALSE;
	ValaExpression* _tmp0_;
	ValaExpression* _tmp1_;
	self = (ValaAddressofExpression*) base;
	g_return_val_if_fail (sym != NULL, FALSE);
	_tmp0_ = vala_addressof_expression_get_inner (self);
	_tmp1_ = _tmp0_;
	result = vala_expression_is_accessible (_tmp1_, sym);
	return result;
}


static gpointer
_vala_code_node_ref0 (gpointer self)
{
	return self ? vala_code_node_ref (self) : NULL;
}


static gboolean
vala_addressof_expression_real_check (ValaCodeNode* base,
                                      ValaCodeContext* context)
{
	ValaAddressofExpression * self;
	gboolean result = FALSE;
	gboolean _tmp0_;
	gboolean _tmp1_;
	ValaExpression* _tmp4_;
	ValaExpression* _tmp5_;
	ValaExpression* _tmp6_;
	ValaExpression* _tmp7_;
	ValaElementAccess* ea = NULL;
	ValaExpression* _tmp8_;
	ValaExpression* _tmp9_;
	ValaElementAccess* _tmp10_;
	gboolean _tmp11_ = FALSE;
	ValaExpression* _tmp12_;
	ValaExpression* _tmp13_;
	ValaExpression* _tmp33_;
	ValaExpression* _tmp34_;
	ValaDataType* _tmp35_;
	ValaDataType* _tmp36_;
	gboolean _tmp51_;
	gboolean _tmp52_;
	self = (ValaAddressofExpression*) base;
	g_return_val_if_fail (context != NULL, FALSE);
	_tmp0_ = vala_code_node_get_checked ((ValaCodeNode*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		gboolean _tmp2_;
		gboolean _tmp3_;
		_tmp2_ = vala_code_node_get_error ((ValaCodeNode*) self);
		_tmp3_ = _tmp2_;
		result = !_tmp3_;
		return result;
	}
	vala_code_node_set_checked ((ValaCodeNode*) self, TRUE);
	_tmp4_ = vala_addressof_expression_get_inner (self);
	_tmp5_ = _tmp4_;
	vala_expression_set_lvalue (_tmp5_, TRUE);
	_tmp6_ = vala_addressof_expression_get_inner (self);
	_tmp7_ = _tmp6_;
	if (!vala_code_node_check ((ValaCodeNode*) _tmp7_, context)) {
		vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
		result = FALSE;
		return result;
	}
	_tmp8_ = vala_addressof_expression_get_inner (self);
	_tmp9_ = _tmp8_;
	_tmp10_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp9_, VALA_TYPE_ELEMENT_ACCESS) ? ((ValaElementAccess*) _tmp9_) : NULL);
	ea = _tmp10_;
	_tmp12_ = vala_addressof_expression_get_inner (self);
	_tmp13_ = _tmp12_;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp13_, VALA_TYPE_MEMBER_ACCESS)) {
		ValaExpression* _tmp14_;
		ValaExpression* _tmp15_;
		ValaSymbol* _tmp16_;
		ValaSymbol* _tmp17_;
		_tmp14_ = vala_addressof_expression_get_inner (self);
		_tmp15_ = _tmp14_;
		_tmp16_ = vala_expression_get_symbol_reference (_tmp15_);
		_tmp17_ = _tmp16_;
		_tmp11_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp17_, VALA_TYPE_VARIABLE);
	} else {
		_tmp11_ = FALSE;
	}
	if (_tmp11_) {
	} else {
		gboolean _tmp18_ = FALSE;
		ValaElementAccess* _tmp19_;
		_tmp19_ = ea;
		if (_tmp19_ != NULL) {
			gboolean _tmp20_ = FALSE;
			ValaElementAccess* _tmp21_;
			ValaExpression* _tmp22_;
			ValaExpression* _tmp23_;
			ValaDataType* _tmp24_;
			ValaDataType* _tmp25_;
			_tmp21_ = ea;
			_tmp22_ = vala_element_access_get_container (_tmp21_);
			_tmp23_ = _tmp22_;
			_tmp24_ = vala_expression_get_value_type (_tmp23_);
			_tmp25_ = _tmp24_;
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp25_, VALA_TYPE_ARRAY_TYPE)) {
				_tmp20_ = TRUE;
			} else {
				ValaElementAccess* _tmp26_;
				ValaExpression* _tmp27_;
				ValaExpression* _tmp28_;
				ValaDataType* _tmp29_;
				ValaDataType* _tmp30_;
				_tmp26_ = ea;
				_tmp27_ = vala_element_access_get_container (_tmp26_);
				_tmp28_ = _tmp27_;
				_tmp29_ = vala_expression_get_value_type (_tmp28_);
				_tmp30_ = _tmp29_;
				_tmp20_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp30_, VALA_TYPE_POINTER_TYPE);
			}
			_tmp18_ = _tmp20_;
		} else {
			_tmp18_ = FALSE;
		}
		if (_tmp18_) {
		} else {
			ValaSourceReference* _tmp31_;
			ValaSourceReference* _tmp32_;
			vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
			_tmp31_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
			_tmp32_ = _tmp31_;
			vala_report_error (_tmp32_, "Address-of operator not supported for this expression");
			result = FALSE;
			_vala_code_node_unref0 (ea);
			return result;
		}
	}
	_tmp33_ = vala_addressof_expression_get_inner (self);
	_tmp34_ = _tmp33_;
	_tmp35_ = vala_expression_get_value_type (_tmp34_);
	_tmp36_ = _tmp35_;
	if (vala_data_type_is_reference_type_or_type_parameter (_tmp36_)) {
		ValaExpression* _tmp37_;
		ValaExpression* _tmp38_;
		ValaDataType* _tmp39_;
		ValaDataType* _tmp40_;
		ValaPointerType* _tmp41_;
		ValaPointerType* _tmp42_;
		ValaPointerType* _tmp43_;
		ValaPointerType* _tmp44_;
		_tmp37_ = vala_addressof_expression_get_inner (self);
		_tmp38_ = _tmp37_;
		_tmp39_ = vala_expression_get_value_type (_tmp38_);
		_tmp40_ = _tmp39_;
		_tmp41_ = vala_pointer_type_new (_tmp40_, NULL);
		_tmp42_ = _tmp41_;
		_tmp43_ = vala_pointer_type_new ((ValaDataType*) _tmp42_, NULL);
		_tmp44_ = _tmp43_;
		vala_expression_set_value_type ((ValaExpression*) self, (ValaDataType*) _tmp44_);
		_vala_code_node_unref0 (_tmp44_);
		_vala_code_node_unref0 (_tmp42_);
	} else {
		ValaExpression* _tmp45_;
		ValaExpression* _tmp46_;
		ValaDataType* _tmp47_;
		ValaDataType* _tmp48_;
		ValaPointerType* _tmp49_;
		ValaPointerType* _tmp50_;
		_tmp45_ = vala_addressof_expression_get_inner (self);
		_tmp46_ = _tmp45_;
		_tmp47_ = vala_expression_get_value_type (_tmp46_);
		_tmp48_ = _tmp47_;
		_tmp49_ = vala_pointer_type_new (_tmp48_, NULL);
		_tmp50_ = _tmp49_;
		vala_expression_set_value_type ((ValaExpression*) self, (ValaDataType*) _tmp50_);
		_vala_code_node_unref0 (_tmp50_);
	}
	_tmp51_ = vala_code_node_get_error ((ValaCodeNode*) self);
	_tmp52_ = _tmp51_;
	result = !_tmp52_;
	_vala_code_node_unref0 (ea);
	return result;
}


static void
vala_addressof_expression_real_emit (ValaCodeNode* base,
                                     ValaCodeGenerator* codegen)
{
	ValaAddressofExpression * self;
	ValaExpression* _tmp0_;
	ValaExpression* _tmp1_;
	self = (ValaAddressofExpression*) base;
	g_return_if_fail (codegen != NULL);
	_tmp0_ = vala_addressof_expression_get_inner (self);
	_tmp1_ = _tmp0_;
	vala_code_node_emit ((ValaCodeNode*) _tmp1_, codegen);
	vala_code_visitor_visit_addressof_expression ((ValaCodeVisitor*) codegen, self);
	vala_code_visitor_visit_expression ((ValaCodeVisitor*) codegen, (ValaExpression*) self);
}


ValaExpression*
vala_addressof_expression_get_inner (ValaAddressofExpression* self)
{
	ValaExpression* result;
	ValaExpression* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_inner;
	result = _tmp0_;
	return result;
}


void
vala_addressof_expression_set_inner (ValaAddressofExpression* self,
                                     ValaExpression* value)
{
	ValaExpression* _tmp0_;
	ValaExpression* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _vala_code_node_ref0 (value);
	_vala_code_node_unref0 (self->priv->_inner);
	self->priv->_inner = _tmp0_;
	_tmp1_ = self->priv->_inner;
	vala_code_node_set_parent_node ((ValaCodeNode*) _tmp1_, (ValaCodeNode*) self);
}


static void
vala_addressof_expression_class_init (ValaAddressofExpressionClass * klass)
{
	vala_addressof_expression_parent_class = g_type_class_peek_parent (klass);
	((ValaCodeNodeClass *) klass)->finalize = vala_addressof_expression_finalize;
	g_type_class_add_private (klass, sizeof (ValaAddressofExpressionPrivate));
	((ValaCodeNodeClass *) klass)->accept = (void (*) (ValaCodeNode *, ValaCodeVisitor*)) vala_addressof_expression_real_accept;
	((ValaCodeNodeClass *) klass)->accept_children = (void (*) (ValaCodeNode *, ValaCodeVisitor*)) vala_addressof_expression_real_accept_children;
	((ValaCodeNodeClass *) klass)->replace_expression = (void (*) (ValaCodeNode *, ValaExpression*, ValaExpression*)) vala_addressof_expression_real_replace_expression;
	((ValaExpressionClass *) klass)->is_pure = (gboolean (*) (ValaExpression *)) vala_addressof_expression_real_is_pure;
	((ValaExpressionClass *) klass)->is_accessible = (gboolean (*) (ValaExpression *, ValaSymbol*)) vala_addressof_expression_real_is_accessible;
	((ValaCodeNodeClass *) klass)->check = (gboolean (*) (ValaCodeNode *, ValaCodeContext*)) vala_addressof_expression_real_check;
	((ValaCodeNodeClass *) klass)->emit = (void (*) (ValaCodeNode *, ValaCodeGenerator*)) vala_addressof_expression_real_emit;
}


static void
vala_addressof_expression_instance_init (ValaAddressofExpression * self)
{
	self->priv = VALA_ADDRESSOF_EXPRESSION_GET_PRIVATE (self);
}


static void
vala_addressof_expression_finalize (ValaCodeNode * obj)
{
	ValaAddressofExpression * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALA_TYPE_ADDRESSOF_EXPRESSION, ValaAddressofExpression);
	_vala_code_node_unref0 (self->priv->_inner);
	VALA_CODE_NODE_CLASS (vala_addressof_expression_parent_class)->finalize (obj);
}


/**
 * Represents an address-of expression in the source code, e.g. `&foo`.
 */
GType
vala_addressof_expression_get_type (void)
{
	static volatile gsize vala_addressof_expression_type_id__volatile = 0;
	if (g_once_init_enter (&vala_addressof_expression_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ValaAddressofExpressionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_addressof_expression_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaAddressofExpression), 0, (GInstanceInitFunc) vala_addressof_expression_instance_init, NULL };
		GType vala_addressof_expression_type_id;
		vala_addressof_expression_type_id = g_type_register_static (VALA_TYPE_EXPRESSION, "ValaAddressofExpression", &g_define_type_info, 0);
		g_once_init_leave (&vala_addressof_expression_type_id__volatile, vala_addressof_expression_type_id);
	}
	return vala_addressof_expression_type_id__volatile;
}



