/* valaparameter.c generated by valac, the Vala compiler
 * generated from valaparameter.vala, do not modify */

/* valaparameter.vala
 *
 * Copyright (C) 2006-2012  Jürg Billeter
 * Copyright (C) 2006-2008  Raffaele Sandrini
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Jürg Billeter <j@bitron.ch>
 *	Raffaele Sandrini <raffaele@sandrini.ch>
 */


#include <glib.h>
#include <glib-object.h>
#include "vala.h"
#include <stdlib.h>
#include <string.h>
#include <valagee.h>

#define _vala_code_node_unref0(var) ((var == NULL) ? NULL : (var = (vala_code_node_unref (var), NULL)))
#define _vala_source_file_unref0(var) ((var == NULL) ? NULL : (var = (vala_source_file_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_iterable_unref0(var) ((var == NULL) ? NULL : (var = (vala_iterable_unref (var), NULL)))

struct _ValaParameterPrivate {
	ValaParameterDirection _direction;
	gboolean _ellipsis;
	gboolean _params_array;
	gboolean _captured;
	ValaParameter* _base_parameter;
};


static gpointer vala_parameter_parent_class = NULL;

#define VALA_PARAMETER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALA_TYPE_PARAMETER, ValaParameterPrivate))
static void vala_parameter_real_accept (ValaCodeNode* base,
                                 ValaCodeVisitor* visitor);
static void vala_parameter_real_accept_children (ValaCodeNode* base,
                                          ValaCodeVisitor* visitor);
static void vala_parameter_real_replace_type (ValaCodeNode* base,
                                       ValaDataType* old_type,
                                       ValaDataType* new_type);
static void vala_parameter_real_replace_expression (ValaCodeNode* base,
                                             ValaExpression* old_node,
                                             ValaExpression* new_node);
static gboolean vala_parameter_real_check (ValaCodeNode* base,
                                    ValaCodeContext* context);
static void vala_parameter_finalize (ValaCodeNode * obj);


/**
 * Creates a new formal parameter.
 *
 * @param name              parameter name
 * @param variable_type     parameter type
 * @param source_reference  reference to source code
 * @return                  newly created formal parameter
 */
ValaParameter*
vala_parameter_construct (GType object_type,
                          const gchar* name,
                          ValaDataType* variable_type,
                          ValaSourceReference* source_reference)
{
	ValaParameter* self = NULL;
	g_return_val_if_fail (name != NULL, NULL);
	self = (ValaParameter*) vala_variable_construct (object_type, variable_type, name, NULL, source_reference, NULL);
	vala_symbol_set_access ((ValaSymbol*) self, VALA_SYMBOL_ACCESSIBILITY_PUBLIC);
	return self;
}


ValaParameter*
vala_parameter_new (const gchar* name,
                    ValaDataType* variable_type,
                    ValaSourceReference* source_reference)
{
	return vala_parameter_construct (VALA_TYPE_PARAMETER, name, variable_type, source_reference);
}


/**
 * Creates a new ellipsis parameter representing an indefinite number of
 * parameters.
 */
ValaParameter*
vala_parameter_construct_with_ellipsis (GType object_type,
                                        ValaSourceReference* source_reference)
{
	ValaParameter* self = NULL;
	self = (ValaParameter*) vala_variable_construct (object_type, NULL, NULL, NULL, source_reference, NULL);
	vala_parameter_set_ellipsis (self, TRUE);
	vala_symbol_set_access ((ValaSymbol*) self, VALA_SYMBOL_ACCESSIBILITY_PUBLIC);
	return self;
}


ValaParameter*
vala_parameter_new_with_ellipsis (ValaSourceReference* source_reference)
{
	return vala_parameter_construct_with_ellipsis (VALA_TYPE_PARAMETER, source_reference);
}


static void
vala_parameter_real_accept (ValaCodeNode* base,
                            ValaCodeVisitor* visitor)
{
	ValaParameter * self;
	self = (ValaParameter*) base;
	g_return_if_fail (visitor != NULL);
	vala_code_visitor_visit_formal_parameter (visitor, self);
}


static void
vala_parameter_real_accept_children (ValaCodeNode* base,
                                     ValaCodeVisitor* visitor)
{
	ValaParameter * self;
	gboolean _tmp0_;
	self = (ValaParameter*) base;
	g_return_if_fail (visitor != NULL);
	_tmp0_ = self->priv->_ellipsis;
	if (!_tmp0_) {
		ValaDataType* _tmp1_;
		ValaDataType* _tmp2_;
		ValaExpression* _tmp3_;
		ValaExpression* _tmp4_;
		_tmp1_ = vala_variable_get_variable_type ((ValaVariable*) self);
		_tmp2_ = _tmp1_;
		vala_code_node_accept ((ValaCodeNode*) _tmp2_, visitor);
		_tmp3_ = vala_variable_get_initializer ((ValaVariable*) self);
		_tmp4_ = _tmp3_;
		if (_tmp4_ != NULL) {
			ValaExpression* _tmp5_;
			ValaExpression* _tmp6_;
			_tmp5_ = vala_variable_get_initializer ((ValaVariable*) self);
			_tmp6_ = _tmp5_;
			vala_code_node_accept ((ValaCodeNode*) _tmp6_, visitor);
		}
	}
}


static void
vala_parameter_real_replace_type (ValaCodeNode* base,
                                  ValaDataType* old_type,
                                  ValaDataType* new_type)
{
	ValaParameter * self;
	ValaDataType* _tmp0_;
	ValaDataType* _tmp1_;
	self = (ValaParameter*) base;
	g_return_if_fail (old_type != NULL);
	g_return_if_fail (new_type != NULL);
	_tmp0_ = vala_variable_get_variable_type ((ValaVariable*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ == old_type) {
		vala_variable_set_variable_type ((ValaVariable*) self, new_type);
	}
}


static void
vala_parameter_real_replace_expression (ValaCodeNode* base,
                                        ValaExpression* old_node,
                                        ValaExpression* new_node)
{
	ValaParameter * self;
	ValaExpression* _tmp0_;
	ValaExpression* _tmp1_;
	self = (ValaParameter*) base;
	g_return_if_fail (old_node != NULL);
	g_return_if_fail (new_node != NULL);
	_tmp0_ = vala_variable_get_initializer ((ValaVariable*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ == old_node) {
		vala_variable_set_initializer ((ValaVariable*) self, new_node);
	}
}


static gpointer
_vala_code_node_ref0 (gpointer self)
{
	return self ? vala_code_node_ref (self) : NULL;
}


ValaParameter*
vala_parameter_copy (ValaParameter* self)
{
	ValaParameter* result = NULL;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_ellipsis;
	if (!_tmp0_) {
		ValaParameter* _result_ = NULL;
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		ValaDataType* _tmp3_;
		ValaDataType* _tmp4_;
		ValaDataType* _tmp5_;
		ValaDataType* _tmp6_;
		ValaSourceReference* _tmp7_;
		ValaSourceReference* _tmp8_;
		ValaParameter* _tmp9_;
		ValaParameter* _tmp10_;
		ValaParameter* _tmp11_;
		gboolean _tmp12_;
		ValaParameter* _tmp13_;
		ValaParameterDirection _tmp14_;
		ValaParameter* _tmp15_;
		ValaExpression* _tmp16_;
		ValaExpression* _tmp17_;
		GList* _tmp18_;
		_tmp1_ = vala_symbol_get_name ((ValaSymbol*) self);
		_tmp2_ = _tmp1_;
		_tmp3_ = vala_variable_get_variable_type ((ValaVariable*) self);
		_tmp4_ = _tmp3_;
		_tmp5_ = vala_data_type_copy (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp7_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp8_ = _tmp7_;
		_tmp9_ = vala_parameter_new (_tmp2_, _tmp6_, _tmp8_);
		_tmp10_ = _tmp9_;
		_vala_code_node_unref0 (_tmp6_);
		_result_ = _tmp10_;
		_tmp11_ = _result_;
		_tmp12_ = self->priv->_params_array;
		vala_parameter_set_params_array (_tmp11_, _tmp12_);
		_tmp13_ = _result_;
		_tmp14_ = self->priv->_direction;
		vala_parameter_set_direction (_tmp13_, _tmp14_);
		_tmp15_ = _result_;
		_tmp16_ = vala_variable_get_initializer ((ValaVariable*) self);
		_tmp17_ = _tmp16_;
		vala_variable_set_initializer ((ValaVariable*) _tmp15_, _tmp17_);
		_tmp18_ = ((ValaCodeNode*) self)->attributes;
		{
			GList* a_collection = NULL;
			GList* a_it = NULL;
			a_collection = _tmp18_;
			for (a_it = a_collection; a_it != NULL; a_it = a_it->next) {
				ValaAttribute* _tmp19_;
				ValaAttribute* a = NULL;
				_tmp19_ = _vala_code_node_ref0 ((ValaAttribute*) a_it->data);
				a = _tmp19_;
				{
					ValaParameter* _tmp20_;
					ValaAttribute* _tmp21_;
					ValaAttribute* _tmp22_;
					_tmp20_ = _result_;
					_tmp21_ = a;
					_tmp22_ = _vala_code_node_ref0 (_tmp21_);
					((ValaCodeNode*) _tmp20_)->attributes = g_list_append (((ValaCodeNode*) _tmp20_)->attributes, _tmp22_);
					_vala_code_node_unref0 (a);
				}
			}
		}
		result = _result_;
		return result;
	} else {
		ValaParameter* _tmp23_;
		_tmp23_ = vala_parameter_new_with_ellipsis (NULL);
		result = _tmp23_;
		return result;
	}
}


static gpointer
_vala_source_file_ref0 (gpointer self)
{
	return self ? vala_source_file_ref (self) : NULL;
}


static gboolean
vala_parameter_real_check (ValaCodeNode* base,
                           ValaCodeContext* context)
{
	ValaParameter * self;
	gboolean result = FALSE;
	gboolean _tmp0_;
	gboolean _tmp1_;
	ValaSourceFile* old_source_file = NULL;
	ValaSemanticAnalyzer* _tmp4_;
	ValaSemanticAnalyzer* _tmp5_;
	ValaSourceFile* _tmp6_;
	ValaSourceFile* _tmp7_;
	ValaSourceFile* _tmp8_;
	ValaSymbol* old_symbol = NULL;
	ValaSemanticAnalyzer* _tmp9_;
	ValaSemanticAnalyzer* _tmp10_;
	ValaSymbol* _tmp11_;
	ValaSymbol* _tmp12_;
	ValaSymbol* _tmp13_;
	ValaSourceReference* _tmp14_;
	ValaSourceReference* _tmp15_;
	ValaSemanticAnalyzer* _tmp22_;
	ValaSemanticAnalyzer* _tmp23_;
	ValaSymbol* _tmp24_;
	ValaSymbol* _tmp25_;
	ValaDataType* _tmp26_;
	ValaDataType* _tmp27_;
	gboolean _tmp34_;
	ValaExpression* _tmp62_;
	ValaExpression* _tmp63_;
	gboolean _tmp126_;
	ValaMethod* m = NULL;
	ValaSymbol* _tmp143_;
	ValaSymbol* _tmp144_;
	ValaMethod* _tmp145_;
	ValaMethod* _tmp146_;
	ValaSemanticAnalyzer* _tmp173_;
	ValaSemanticAnalyzer* _tmp174_;
	ValaSourceFile* _tmp175_;
	ValaSemanticAnalyzer* _tmp176_;
	ValaSemanticAnalyzer* _tmp177_;
	ValaSymbol* _tmp178_;
	gboolean _tmp179_;
	gboolean _tmp180_;
	self = (ValaParameter*) base;
	g_return_val_if_fail (context != NULL, FALSE);
	_tmp0_ = vala_code_node_get_checked ((ValaCodeNode*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		gboolean _tmp2_;
		gboolean _tmp3_;
		_tmp2_ = vala_code_node_get_error ((ValaCodeNode*) self);
		_tmp3_ = _tmp2_;
		result = !_tmp3_;
		return result;
	}
	vala_code_node_set_checked ((ValaCodeNode*) self, TRUE);
	_tmp4_ = vala_code_context_get_analyzer (context);
	_tmp5_ = _tmp4_;
	_tmp6_ = vala_semantic_analyzer_get_current_source_file (_tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = _vala_source_file_ref0 (_tmp7_);
	old_source_file = _tmp8_;
	_tmp9_ = vala_code_context_get_analyzer (context);
	_tmp10_ = _tmp9_;
	_tmp11_ = vala_semantic_analyzer_get_current_symbol (_tmp10_);
	_tmp12_ = _tmp11_;
	_tmp13_ = _vala_code_node_ref0 (_tmp12_);
	old_symbol = _tmp13_;
	_tmp14_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
	_tmp15_ = _tmp14_;
	if (_tmp15_ != NULL) {
		ValaSemanticAnalyzer* _tmp16_;
		ValaSemanticAnalyzer* _tmp17_;
		ValaSourceReference* _tmp18_;
		ValaSourceReference* _tmp19_;
		ValaSourceFile* _tmp20_;
		ValaSourceFile* _tmp21_;
		_tmp16_ = vala_code_context_get_analyzer (context);
		_tmp17_ = _tmp16_;
		_tmp18_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp19_ = _tmp18_;
		_tmp20_ = vala_source_reference_get_file (_tmp19_);
		_tmp21_ = _tmp20_;
		vala_semantic_analyzer_set_current_source_file (_tmp17_, _tmp21_);
	}
	_tmp22_ = vala_code_context_get_analyzer (context);
	_tmp23_ = _tmp22_;
	_tmp24_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
	_tmp25_ = _tmp24_;
	vala_semantic_analyzer_set_current_symbol (_tmp23_, _tmp25_);
	_tmp26_ = vala_variable_get_variable_type ((ValaVariable*) self);
	_tmp27_ = _tmp26_;
	if (_tmp27_ != NULL) {
		ValaDataType* _tmp28_;
		ValaDataType* _tmp29_;
		ValaDataType* _tmp32_;
		ValaDataType* _tmp33_;
		_tmp28_ = vala_variable_get_variable_type ((ValaVariable*) self);
		_tmp29_ = _tmp28_;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp29_, VALA_TYPE_VOID_TYPE)) {
			ValaSourceReference* _tmp30_;
			ValaSourceReference* _tmp31_;
			vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
			_tmp30_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
			_tmp31_ = _tmp30_;
			vala_report_error (_tmp31_, "'void' not supported as parameter type");
			result = FALSE;
			_vala_code_node_unref0 (old_symbol);
			_vala_source_file_unref0 (old_source_file);
			return result;
		}
		_tmp32_ = vala_variable_get_variable_type ((ValaVariable*) self);
		_tmp33_ = _tmp32_;
		vala_code_node_check ((ValaCodeNode*) _tmp33_, context);
	}
	_tmp34_ = self->priv->_ellipsis;
	if (!_tmp34_) {
		ValaDataType* _tmp35_;
		ValaDataType* _tmp36_;
		gboolean _tmp37_ = FALSE;
		gboolean _tmp38_;
		gboolean _tmp43_ = FALSE;
		ValaExpression* _tmp52_;
		ValaExpression* _tmp53_;
		_tmp35_ = vala_variable_get_variable_type ((ValaVariable*) self);
		_tmp36_ = _tmp35_;
		vala_code_node_check ((ValaCodeNode*) _tmp36_, context);
		_tmp38_ = self->priv->_params_array;
		if (_tmp38_) {
			ValaDataType* _tmp39_;
			ValaDataType* _tmp40_;
			_tmp39_ = vala_variable_get_variable_type ((ValaVariable*) self);
			_tmp40_ = _tmp39_;
			_tmp37_ = !G_TYPE_CHECK_INSTANCE_TYPE (_tmp40_, VALA_TYPE_ARRAY_TYPE);
		} else {
			_tmp37_ = FALSE;
		}
		if (_tmp37_) {
			ValaSourceReference* _tmp41_;
			ValaSourceReference* _tmp42_;
			vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
			_tmp41_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
			_tmp42_ = _tmp41_;
			vala_report_error (_tmp42_, "parameter array expected");
			result = FALSE;
			_vala_code_node_unref0 (old_symbol);
			_vala_source_file_unref0 (old_source_file);
			return result;
		}
		if (vala_code_node_has_attribute_argument ((ValaCodeNode*) self, "CCode", "scope")) {
			ValaDataType* _tmp44_;
			ValaDataType* _tmp45_;
			_tmp44_ = vala_variable_get_variable_type ((ValaVariable*) self);
			_tmp45_ = _tmp44_;
			_tmp43_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp45_, VALA_TYPE_DELEGATE_TYPE);
		} else {
			_tmp43_ = FALSE;
		}
		if (_tmp43_) {
			ValaDelegateType* delegate_type = NULL;
			ValaDataType* _tmp46_;
			ValaDataType* _tmp47_;
			ValaDelegateType* _tmp48_;
			ValaDelegateType* _tmp49_;
			gchar* _tmp50_;
			gchar* _tmp51_;
			_tmp46_ = vala_variable_get_variable_type ((ValaVariable*) self);
			_tmp47_ = _tmp46_;
			_tmp48_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp47_, VALA_TYPE_DELEGATE_TYPE, ValaDelegateType));
			delegate_type = _tmp48_;
			_tmp49_ = delegate_type;
			_tmp50_ = vala_code_node_get_attribute_string ((ValaCodeNode*) self, "CCode", "scope", NULL);
			_tmp51_ = _tmp50_;
			vala_delegate_type_set_is_called_once (_tmp49_, g_strcmp0 (_tmp51_, "async") == 0);
			_g_free0 (_tmp51_);
			_vala_code_node_unref0 (delegate_type);
		}
		_tmp52_ = vala_variable_get_initializer ((ValaVariable*) self);
		_tmp53_ = _tmp52_;
		if (_tmp53_ != NULL) {
			ValaExpression* _tmp54_;
			ValaExpression* _tmp55_;
			ValaDataType* _tmp56_;
			ValaDataType* _tmp57_;
			ValaDataType* _tmp58_;
			ValaDataType* _tmp59_;
			ValaExpression* _tmp60_;
			ValaExpression* _tmp61_;
			_tmp54_ = vala_variable_get_initializer ((ValaVariable*) self);
			_tmp55_ = _tmp54_;
			_tmp56_ = vala_variable_get_variable_type ((ValaVariable*) self);
			_tmp57_ = _tmp56_;
			_tmp58_ = vala_data_type_copy (_tmp57_);
			_tmp59_ = _tmp58_;
			vala_expression_set_target_type (_tmp55_, _tmp59_);
			_vala_code_node_unref0 (_tmp59_);
			_tmp60_ = vala_variable_get_initializer ((ValaVariable*) self);
			_tmp61_ = _tmp60_;
			vala_code_node_check ((ValaCodeNode*) _tmp61_, context);
		}
	}
	_tmp62_ = vala_variable_get_initializer ((ValaVariable*) self);
	_tmp63_ = _tmp62_;
	if (_tmp63_ != NULL) {
		gboolean _tmp64_ = FALSE;
		gboolean _tmp65_ = FALSE;
		ValaExpression* _tmp66_;
		ValaExpression* _tmp67_;
		_tmp66_ = vala_variable_get_initializer ((ValaVariable*) self);
		_tmp67_ = _tmp66_;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp67_, VALA_TYPE_NULL_LITERAL)) {
			ValaDataType* _tmp68_;
			ValaDataType* _tmp69_;
			gboolean _tmp70_;
			gboolean _tmp71_;
			_tmp68_ = vala_variable_get_variable_type ((ValaVariable*) self);
			_tmp69_ = _tmp68_;
			_tmp70_ = vala_data_type_get_nullable (_tmp69_);
			_tmp71_ = _tmp70_;
			_tmp65_ = !_tmp71_;
		} else {
			_tmp65_ = FALSE;
		}
		if (_tmp65_) {
			ValaParameterDirection _tmp72_;
			_tmp72_ = self->priv->_direction;
			_tmp64_ = _tmp72_ != VALA_PARAMETER_DIRECTION_OUT;
		} else {
			_tmp64_ = FALSE;
		}
		if (_tmp64_) {
			ValaSourceReference* _tmp73_;
			ValaSourceReference* _tmp74_;
			ValaDataType* _tmp75_;
			ValaDataType* _tmp76_;
			gchar* _tmp77_;
			gchar* _tmp78_;
			gchar* _tmp79_;
			gchar* _tmp80_;
			_tmp73_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
			_tmp74_ = _tmp73_;
			_tmp75_ = vala_variable_get_variable_type ((ValaVariable*) self);
			_tmp76_ = _tmp75_;
			_tmp77_ = vala_code_node_to_string ((ValaCodeNode*) _tmp76_);
			_tmp78_ = _tmp77_;
			_tmp79_ = g_strdup_printf ("`null' incompatible with parameter type `%s`", _tmp78_);
			_tmp80_ = _tmp79_;
			vala_report_warning (_tmp74_, _tmp80_);
			_g_free0 (_tmp80_);
			_g_free0 (_tmp78_);
		} else {
			gboolean _tmp81_ = FALSE;
			ValaExpression* _tmp82_;
			ValaExpression* _tmp83_;
			_tmp82_ = vala_variable_get_initializer ((ValaVariable*) self);
			_tmp83_ = _tmp82_;
			if (!G_TYPE_CHECK_INSTANCE_TYPE (_tmp83_, VALA_TYPE_NULL_LITERAL)) {
				ValaParameterDirection _tmp84_;
				_tmp84_ = self->priv->_direction;
				_tmp81_ = _tmp84_ == VALA_PARAMETER_DIRECTION_OUT;
			} else {
				_tmp81_ = FALSE;
			}
			if (_tmp81_) {
				ValaSourceReference* _tmp85_;
				ValaSourceReference* _tmp86_;
				_tmp85_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp86_ = _tmp85_;
				vala_report_error (_tmp86_, "only `null' is allowed as default value for out parameters");
			} else {
				gboolean _tmp87_ = FALSE;
				ValaParameterDirection _tmp88_;
				_tmp88_ = self->priv->_direction;
				if (_tmp88_ == VALA_PARAMETER_DIRECTION_IN) {
					ValaExpression* _tmp89_;
					ValaExpression* _tmp90_;
					ValaDataType* _tmp91_;
					ValaDataType* _tmp92_;
					ValaDataType* _tmp93_;
					ValaDataType* _tmp94_;
					_tmp89_ = vala_variable_get_initializer ((ValaVariable*) self);
					_tmp90_ = _tmp89_;
					_tmp91_ = vala_expression_get_value_type (_tmp90_);
					_tmp92_ = _tmp91_;
					_tmp93_ = vala_variable_get_variable_type ((ValaVariable*) self);
					_tmp94_ = _tmp93_;
					_tmp87_ = !vala_data_type_compatible (_tmp92_, _tmp94_);
				} else {
					_tmp87_ = FALSE;
				}
				if (_tmp87_) {
					ValaExpression* _tmp95_;
					ValaExpression* _tmp96_;
					ValaSourceReference* _tmp97_;
					ValaSourceReference* _tmp98_;
					ValaExpression* _tmp99_;
					ValaExpression* _tmp100_;
					ValaDataType* _tmp101_;
					ValaDataType* _tmp102_;
					gchar* _tmp103_;
					gchar* _tmp104_;
					ValaDataType* _tmp105_;
					ValaDataType* _tmp106_;
					gchar* _tmp107_;
					gchar* _tmp108_;
					gchar* _tmp109_;
					gchar* _tmp110_;
					_tmp95_ = vala_variable_get_initializer ((ValaVariable*) self);
					_tmp96_ = _tmp95_;
					_tmp97_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp96_);
					_tmp98_ = _tmp97_;
					_tmp99_ = vala_variable_get_initializer ((ValaVariable*) self);
					_tmp100_ = _tmp99_;
					_tmp101_ = vala_expression_get_value_type (_tmp100_);
					_tmp102_ = _tmp101_;
					_tmp103_ = vala_code_node_to_string ((ValaCodeNode*) _tmp102_);
					_tmp104_ = _tmp103_;
					_tmp105_ = vala_variable_get_variable_type ((ValaVariable*) self);
					_tmp106_ = _tmp105_;
					_tmp107_ = vala_code_node_to_string ((ValaCodeNode*) _tmp106_);
					_tmp108_ = _tmp107_;
					_tmp109_ = g_strdup_printf ("Cannot convert from `%s' to `%s'", _tmp104_, _tmp108_);
					_tmp110_ = _tmp109_;
					vala_report_error (_tmp98_, _tmp110_);
					_g_free0 (_tmp110_);
					_g_free0 (_tmp108_);
					_g_free0 (_tmp104_);
				} else {
					ValaParameterDirection _tmp111_;
					_tmp111_ = self->priv->_direction;
					if (_tmp111_ == VALA_PARAMETER_DIRECTION_REF) {
						ValaSourceReference* _tmp112_;
						ValaSourceReference* _tmp113_;
						_tmp112_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
						_tmp113_ = _tmp112_;
						vala_report_error (_tmp113_, "default value not allowed for ref parameter");
					} else {
						ValaExpression* _tmp114_;
						ValaExpression* _tmp115_;
						_tmp114_ = vala_variable_get_initializer ((ValaVariable*) self);
						_tmp115_ = _tmp114_;
						if (!vala_expression_is_accessible (_tmp115_, (ValaSymbol*) self)) {
							ValaExpression* _tmp116_;
							ValaExpression* _tmp117_;
							ValaSourceReference* _tmp118_;
							ValaSourceReference* _tmp119_;
							ValaSymbol* _tmp120_;
							ValaSymbol* _tmp121_;
							gchar* _tmp122_;
							gchar* _tmp123_;
							gchar* _tmp124_;
							gchar* _tmp125_;
							_tmp116_ = vala_variable_get_initializer ((ValaVariable*) self);
							_tmp117_ = _tmp116_;
							_tmp118_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp117_);
							_tmp119_ = _tmp118_;
							_tmp120_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
							_tmp121_ = _tmp120_;
							_tmp122_ = vala_symbol_get_full_name (_tmp121_);
							_tmp123_ = _tmp122_;
							_tmp124_ = g_strdup_printf ("default value is less accessible than method `%s'", _tmp123_);
							_tmp125_ = _tmp124_;
							vala_report_error (_tmp119_, _tmp125_);
							_g_free0 (_tmp125_);
							_g_free0 (_tmp123_);
						}
					}
				}
			}
		}
	}
	_tmp126_ = self->priv->_ellipsis;
	if (!_tmp126_) {
		ValaSemanticAnalyzer* _tmp127_;
		ValaSemanticAnalyzer* _tmp128_;
		ValaDataType* _tmp129_;
		ValaDataType* _tmp130_;
		_tmp127_ = vala_code_context_get_analyzer (context);
		_tmp128_ = _tmp127_;
		_tmp129_ = vala_variable_get_variable_type ((ValaVariable*) self);
		_tmp130_ = _tmp129_;
		if (!vala_semantic_analyzer_is_type_accessible (_tmp128_, (ValaSymbol*) self, _tmp130_)) {
			ValaSourceReference* _tmp131_;
			ValaSourceReference* _tmp132_;
			ValaDataType* _tmp133_;
			ValaDataType* _tmp134_;
			gchar* _tmp135_;
			gchar* _tmp136_;
			ValaSymbol* _tmp137_;
			ValaSymbol* _tmp138_;
			gchar* _tmp139_;
			gchar* _tmp140_;
			gchar* _tmp141_;
			gchar* _tmp142_;
			vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
			_tmp131_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
			_tmp132_ = _tmp131_;
			_tmp133_ = vala_variable_get_variable_type ((ValaVariable*) self);
			_tmp134_ = _tmp133_;
			_tmp135_ = vala_code_node_to_string ((ValaCodeNode*) _tmp134_);
			_tmp136_ = _tmp135_;
			_tmp137_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
			_tmp138_ = _tmp137_;
			_tmp139_ = vala_symbol_get_full_name (_tmp138_);
			_tmp140_ = _tmp139_;
			_tmp141_ = g_strdup_printf ("parameter type `%s` is less accessible than method `%s`", _tmp136_, _tmp140_);
			_tmp142_ = _tmp141_;
			vala_report_error (_tmp132_, _tmp142_);
			_g_free0 (_tmp142_);
			_g_free0 (_tmp140_);
			_g_free0 (_tmp136_);
		}
	}
	_tmp143_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
	_tmp144_ = _tmp143_;
	_tmp145_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp144_, VALA_TYPE_METHOD) ? ((ValaMethod*) _tmp144_) : NULL);
	m = _tmp145_;
	_tmp146_ = m;
	if (_tmp146_ != NULL) {
		ValaMethod* _tmp147_ = NULL;
		ValaMethod* _tmp148_;
		ValaMethod* _tmp149_;
		ValaMethod* _tmp150_;
		ValaMethod* base_method = NULL;
		ValaMethod* _tmp157_;
		gboolean _tmp158_ = FALSE;
		ValaMethod* _tmp159_;
		_tmp148_ = m;
		_tmp149_ = vala_method_get_base_method (_tmp148_);
		_tmp150_ = _tmp149_;
		if (_tmp150_ != NULL) {
			ValaMethod* _tmp151_;
			ValaMethod* _tmp152_;
			ValaMethod* _tmp153_;
			_tmp151_ = m;
			_tmp152_ = vala_method_get_base_method (_tmp151_);
			_tmp153_ = _tmp152_;
			_tmp147_ = _tmp153_;
		} else {
			ValaMethod* _tmp154_;
			ValaMethod* _tmp155_;
			ValaMethod* _tmp156_;
			_tmp154_ = m;
			_tmp155_ = vala_method_get_base_interface_method (_tmp154_);
			_tmp156_ = _tmp155_;
			_tmp147_ = _tmp156_;
		}
		_tmp157_ = _vala_code_node_ref0 (_tmp147_);
		base_method = _tmp157_;
		_tmp159_ = base_method;
		if (_tmp159_ != NULL) {
			ValaMethod* _tmp160_;
			ValaMethod* _tmp161_;
			_tmp160_ = base_method;
			_tmp161_ = m;
			_tmp158_ = _tmp160_ != _tmp161_;
		} else {
			_tmp158_ = FALSE;
		}
		if (_tmp158_) {
			gint index = 0;
			ValaMethod* _tmp162_;
			ValaList* _tmp163_;
			ValaList* _tmp164_;
			gint _tmp165_;
			gint _tmp166_;
			_tmp162_ = m;
			_tmp163_ = vala_callable_get_parameters ((ValaCallable*) _tmp162_);
			_tmp164_ = _tmp163_;
			_tmp165_ = vala_list_index_of (_tmp164_, self);
			_vala_iterable_unref0 (_tmp164_);
			index = _tmp165_;
			_tmp166_ = index;
			if (_tmp166_ >= 0) {
				ValaMethod* _tmp167_;
				ValaList* _tmp168_;
				ValaList* _tmp169_;
				gint _tmp170_;
				gpointer _tmp171_;
				ValaParameter* _tmp172_;
				_tmp167_ = base_method;
				_tmp168_ = vala_callable_get_parameters ((ValaCallable*) _tmp167_);
				_tmp169_ = _tmp168_;
				_tmp170_ = index;
				_tmp171_ = vala_list_get (_tmp169_, _tmp170_);
				_tmp172_ = (ValaParameter*) _tmp171_;
				vala_parameter_set_base_parameter (self, _tmp172_);
				_vala_code_node_unref0 (_tmp172_);
				_vala_iterable_unref0 (_tmp169_);
			}
		}
		_vala_code_node_unref0 (base_method);
	}
	_tmp173_ = vala_code_context_get_analyzer (context);
	_tmp174_ = _tmp173_;
	_tmp175_ = old_source_file;
	vala_semantic_analyzer_set_current_source_file (_tmp174_, _tmp175_);
	_tmp176_ = vala_code_context_get_analyzer (context);
	_tmp177_ = _tmp176_;
	_tmp178_ = old_symbol;
	vala_semantic_analyzer_set_current_symbol (_tmp177_, _tmp178_);
	_tmp179_ = vala_code_node_get_error ((ValaCodeNode*) self);
	_tmp180_ = _tmp179_;
	result = !_tmp180_;
	_vala_code_node_unref0 (m);
	_vala_code_node_unref0 (old_symbol);
	_vala_source_file_unref0 (old_source_file);
	return result;
}


ValaParameterDirection
vala_parameter_get_direction (ValaParameter* self)
{
	ValaParameterDirection result;
	ValaParameterDirection _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_direction;
	result = _tmp0_;
	return result;
}


void
vala_parameter_set_direction (ValaParameter* self,
                              ValaParameterDirection value)
{
	g_return_if_fail (self != NULL);
	self->priv->_direction = value;
}


gboolean
vala_parameter_get_ellipsis (ValaParameter* self)
{
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_ellipsis;
	result = _tmp0_;
	return result;
}


void
vala_parameter_set_ellipsis (ValaParameter* self,
                             gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_ellipsis = value;
}


gboolean
vala_parameter_get_params_array (ValaParameter* self)
{
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_params_array;
	result = _tmp0_;
	return result;
}


void
vala_parameter_set_params_array (ValaParameter* self,
                                 gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_params_array = value;
}


gboolean
vala_parameter_get_captured (ValaParameter* self)
{
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_captured;
	result = _tmp0_;
	return result;
}


void
vala_parameter_set_captured (ValaParameter* self,
                             gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_captured = value;
}


gboolean
vala_parameter_get_format_arg (ValaParameter* self)
{
	gboolean result;
	ValaAttribute* _tmp0_;
	ValaAttribute* _tmp1_;
	gboolean _tmp2_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = vala_code_node_get_attribute ((ValaCodeNode*) self, "FormatArg");
	_tmp1_ = _tmp0_;
	_tmp2_ = _tmp1_ != NULL;
	_vala_code_node_unref0 (_tmp1_);
	result = _tmp2_;
	return result;
}


ValaParameter*
vala_parameter_get_base_parameter (ValaParameter* self)
{
	ValaParameter* result;
	ValaParameter* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_base_parameter;
	result = _tmp0_;
	return result;
}


void
vala_parameter_set_base_parameter (ValaParameter* self,
                                   ValaParameter* value)
{
	ValaParameter* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _vala_code_node_ref0 (value);
	_vala_code_node_unref0 (self->priv->_base_parameter);
	self->priv->_base_parameter = _tmp0_;
}


static void
vala_parameter_class_init (ValaParameterClass * klass)
{
	vala_parameter_parent_class = g_type_class_peek_parent (klass);
	((ValaCodeNodeClass *) klass)->finalize = vala_parameter_finalize;
	g_type_class_add_private (klass, sizeof (ValaParameterPrivate));
	((ValaCodeNodeClass *) klass)->accept = (void (*) (ValaCodeNode *, ValaCodeVisitor*)) vala_parameter_real_accept;
	((ValaCodeNodeClass *) klass)->accept_children = (void (*) (ValaCodeNode *, ValaCodeVisitor*)) vala_parameter_real_accept_children;
	((ValaCodeNodeClass *) klass)->replace_type = (void (*) (ValaCodeNode *, ValaDataType*, ValaDataType*)) vala_parameter_real_replace_type;
	((ValaCodeNodeClass *) klass)->replace_expression = (void (*) (ValaCodeNode *, ValaExpression*, ValaExpression*)) vala_parameter_real_replace_expression;
	((ValaCodeNodeClass *) klass)->check = (gboolean (*) (ValaCodeNode *, ValaCodeContext*)) vala_parameter_real_check;
}


static void
vala_parameter_instance_init (ValaParameter * self)
{
	self->priv = VALA_PARAMETER_GET_PRIVATE (self);
	self->priv->_direction = VALA_PARAMETER_DIRECTION_IN;
}


static void
vala_parameter_finalize (ValaCodeNode * obj)
{
	ValaParameter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALA_TYPE_PARAMETER, ValaParameter);
	_vala_code_node_unref0 (self->priv->_base_parameter);
	VALA_CODE_NODE_CLASS (vala_parameter_parent_class)->finalize (obj);
}


/**
 * Represents a formal parameter in method and callback signatures.
 */
GType
vala_parameter_get_type (void)
{
	static volatile gsize vala_parameter_type_id__volatile = 0;
	if (g_once_init_enter (&vala_parameter_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ValaParameterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_parameter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaParameter), 0, (GInstanceInitFunc) vala_parameter_instance_init, NULL };
		GType vala_parameter_type_id;
		vala_parameter_type_id = g_type_register_static (VALA_TYPE_VARIABLE, "ValaParameter", &g_define_type_info, 0);
		g_once_init_leave (&vala_parameter_type_id__volatile, vala_parameter_type_id);
	}
	return vala_parameter_type_id__volatile;
}


GType
vala_parameter_direction_get_type (void)
{
	static volatile gsize vala_parameter_direction_type_id__volatile = 0;
	if (g_once_init_enter (&vala_parameter_direction_type_id__volatile)) {
		static const GEnumValue values[] = {{VALA_PARAMETER_DIRECTION_IN, "VALA_PARAMETER_DIRECTION_IN", "in"}, {VALA_PARAMETER_DIRECTION_OUT, "VALA_PARAMETER_DIRECTION_OUT", "out"}, {VALA_PARAMETER_DIRECTION_REF, "VALA_PARAMETER_DIRECTION_REF", "ref"}, {0, NULL, NULL}};
		GType vala_parameter_direction_type_id;
		vala_parameter_direction_type_id = g_enum_register_static ("ValaParameterDirection", values);
		g_once_init_leave (&vala_parameter_direction_type_id__volatile, vala_parameter_direction_type_id);
	}
	return vala_parameter_direction_type_id__volatile;
}



