/* valasliceexpression.c generated by valac, the Vala compiler
 * generated from valasliceexpression.vala, do not modify */

/* valasliceexpression.vala
 *
 * Copyright (C) 2009 Robin Sonefors
 * Copyright (C) 2009-2013 Jürg Billeter
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Robin Sonefors <ozamosi@flukkost.nu>
 * 	Jürg Billeter <j@bitron.ch>
 */


#include <glib.h>
#include <glib-object.h>
#include "vala.h"
#include <valagee.h>
#include <stdlib.h>
#include <string.h>

#define _vala_code_node_unref0(var) ((var == NULL) ? NULL : (var = (vala_code_node_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _ValaSliceExpressionPrivate {
	ValaExpression* _container;
	ValaExpression* _start;
	ValaExpression* _stop;
};


static gpointer vala_slice_expression_parent_class = NULL;

#define VALA_SLICE_EXPRESSION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALA_TYPE_SLICE_EXPRESSION, ValaSliceExpressionPrivate))
static void vala_slice_expression_set_start (ValaSliceExpression* self,
                                      ValaExpression* value);
static void vala_slice_expression_set_stop (ValaSliceExpression* self,
                                     ValaExpression* value);
static void vala_slice_expression_real_accept (ValaCodeNode* base,
                                        ValaCodeVisitor* visitor);
static void vala_slice_expression_real_accept_children (ValaCodeNode* base,
                                                 ValaCodeVisitor* visitor);
static void vala_slice_expression_real_replace_expression (ValaCodeNode* base,
                                                    ValaExpression* old_node,
                                                    ValaExpression* new_node);
static gboolean vala_slice_expression_real_is_pure (ValaExpression* base);
static gboolean vala_slice_expression_real_is_accessible (ValaExpression* base,
                                                   ValaSymbol* sym);
static gboolean vala_slice_expression_real_check (ValaCodeNode* base,
                                           ValaCodeContext* context);
static void vala_slice_expression_real_emit (ValaCodeNode* base,
                                      ValaCodeGenerator* codegen);
static void vala_slice_expression_real_get_defined_variables (ValaCodeNode* base,
                                                       ValaCollection* collection);
static void vala_slice_expression_real_get_used_variables (ValaCodeNode* base,
                                                    ValaCollection* collection);
static void vala_slice_expression_finalize (ValaCodeNode * obj);


ValaSliceExpression*
vala_slice_expression_construct (GType object_type,
                                 ValaExpression* container,
                                 ValaExpression* start,
                                 ValaExpression* stop,
                                 ValaSourceReference* source_reference)
{
	ValaSliceExpression* self = NULL;
	g_return_val_if_fail (container != NULL, NULL);
	g_return_val_if_fail (start != NULL, NULL);
	g_return_val_if_fail (stop != NULL, NULL);
	self = (ValaSliceExpression*) vala_expression_construct (object_type);
	vala_slice_expression_set_container (self, container);
	vala_slice_expression_set_start (self, start);
	vala_slice_expression_set_stop (self, stop);
	vala_code_node_set_source_reference ((ValaCodeNode*) self, source_reference);
	return self;
}


ValaSliceExpression*
vala_slice_expression_new (ValaExpression* container,
                           ValaExpression* start,
                           ValaExpression* stop,
                           ValaSourceReference* source_reference)
{
	return vala_slice_expression_construct (VALA_TYPE_SLICE_EXPRESSION, container, start, stop, source_reference);
}


static void
vala_slice_expression_real_accept (ValaCodeNode* base,
                                   ValaCodeVisitor* visitor)
{
	ValaSliceExpression * self;
	self = (ValaSliceExpression*) base;
	g_return_if_fail (visitor != NULL);
	vala_code_visitor_visit_slice_expression (visitor, self);
	vala_code_visitor_visit_expression (visitor, (ValaExpression*) self);
}


static void
vala_slice_expression_real_accept_children (ValaCodeNode* base,
                                            ValaCodeVisitor* visitor)
{
	ValaSliceExpression * self;
	ValaExpression* _tmp0_;
	ValaExpression* _tmp1_;
	ValaExpression* _tmp2_;
	ValaExpression* _tmp3_;
	ValaExpression* _tmp4_;
	ValaExpression* _tmp5_;
	self = (ValaSliceExpression*) base;
	g_return_if_fail (visitor != NULL);
	_tmp0_ = vala_slice_expression_get_container (self);
	_tmp1_ = _tmp0_;
	vala_code_node_accept ((ValaCodeNode*) _tmp1_, visitor);
	_tmp2_ = vala_slice_expression_get_start (self);
	_tmp3_ = _tmp2_;
	vala_code_node_accept ((ValaCodeNode*) _tmp3_, visitor);
	_tmp4_ = vala_slice_expression_get_stop (self);
	_tmp5_ = _tmp4_;
	vala_code_node_accept ((ValaCodeNode*) _tmp5_, visitor);
}


static void
vala_slice_expression_real_replace_expression (ValaCodeNode* base,
                                               ValaExpression* old_node,
                                               ValaExpression* new_node)
{
	ValaSliceExpression * self;
	ValaExpression* _tmp0_;
	ValaExpression* _tmp1_;
	ValaExpression* _tmp2_;
	ValaExpression* _tmp3_;
	ValaExpression* _tmp4_;
	ValaExpression* _tmp5_;
	self = (ValaSliceExpression*) base;
	g_return_if_fail (old_node != NULL);
	g_return_if_fail (new_node != NULL);
	_tmp0_ = vala_slice_expression_get_container (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ == old_node) {
		vala_slice_expression_set_container (self, new_node);
	}
	_tmp2_ = vala_slice_expression_get_start (self);
	_tmp3_ = _tmp2_;
	if (_tmp3_ == old_node) {
		vala_slice_expression_set_start (self, new_node);
	}
	_tmp4_ = vala_slice_expression_get_stop (self);
	_tmp5_ = _tmp4_;
	if (_tmp5_ == old_node) {
		vala_slice_expression_set_stop (self, new_node);
	}
}


static gboolean
vala_slice_expression_real_is_pure (ValaExpression* base)
{
	ValaSliceExpression * self;
	gboolean result = FALSE;
	self = (ValaSliceExpression*) base;
	result = FALSE;
	return result;
}


static gboolean
vala_slice_expression_real_is_accessible (ValaExpression* base,
                                          ValaSymbol* sym)
{
	ValaSliceExpression * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	ValaExpression* _tmp2_;
	ValaExpression* _tmp3_;
	self = (ValaSliceExpression*) base;
	g_return_val_if_fail (sym != NULL, FALSE);
	_tmp2_ = vala_slice_expression_get_container (self);
	_tmp3_ = _tmp2_;
	if (vala_expression_is_accessible (_tmp3_, sym)) {
		ValaExpression* _tmp4_;
		ValaExpression* _tmp5_;
		_tmp4_ = vala_slice_expression_get_start (self);
		_tmp5_ = _tmp4_;
		_tmp1_ = vala_expression_is_accessible (_tmp5_, sym);
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		ValaExpression* _tmp6_;
		ValaExpression* _tmp7_;
		_tmp6_ = vala_slice_expression_get_stop (self);
		_tmp7_ = _tmp6_;
		_tmp0_ = vala_expression_is_accessible (_tmp7_, sym);
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}


static gboolean
vala_slice_expression_real_check (ValaCodeNode* base,
                                  ValaCodeContext* context)
{
	ValaSliceExpression * self;
	gboolean result = FALSE;
	gboolean _tmp0_;
	gboolean _tmp1_;
	ValaExpression* _tmp4_;
	ValaExpression* _tmp5_;
	ValaExpression* _tmp6_;
	ValaExpression* _tmp7_;
	ValaDataType* _tmp8_;
	ValaDataType* _tmp9_;
	ValaExpression* _tmp24_;
	ValaExpression* _tmp25_;
	ValaExpression* _tmp26_;
	ValaExpression* _tmp27_;
	ValaExpression* _tmp28_;
	ValaExpression* _tmp29_;
	ValaDataType* _tmp30_;
	ValaDataType* _tmp31_;
	gboolean _tmp36_;
	gboolean _tmp37_;
	ValaExpression* _tmp42_;
	ValaExpression* _tmp43_;
	ValaDataType* _tmp44_;
	ValaDataType* _tmp45_;
	gboolean _tmp116_;
	gboolean _tmp117_;
	self = (ValaSliceExpression*) base;
	g_return_val_if_fail (context != NULL, FALSE);
	_tmp0_ = vala_code_node_get_checked ((ValaCodeNode*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		gboolean _tmp2_;
		gboolean _tmp3_;
		_tmp2_ = vala_code_node_get_error ((ValaCodeNode*) self);
		_tmp3_ = _tmp2_;
		result = !_tmp3_;
		return result;
	}
	vala_code_node_set_checked ((ValaCodeNode*) self, TRUE);
	_tmp4_ = vala_slice_expression_get_container (self);
	_tmp5_ = _tmp4_;
	if (!vala_code_node_check ((ValaCodeNode*) _tmp5_, context)) {
		vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
		result = FALSE;
		return result;
	}
	_tmp6_ = vala_slice_expression_get_container (self);
	_tmp7_ = _tmp6_;
	_tmp8_ = vala_expression_get_value_type (_tmp7_);
	_tmp9_ = _tmp8_;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp9_, VALA_TYPE_ARRAY_TYPE)) {
		ValaExpression* _tmp10_;
		ValaExpression* _tmp11_;
		ValaSemanticAnalyzer* _tmp12_;
		ValaSemanticAnalyzer* _tmp13_;
		ValaDataType* _tmp14_;
		ValaDataType* _tmp15_;
		ValaDataType* _tmp16_;
		ValaExpression* _tmp17_;
		ValaExpression* _tmp18_;
		ValaSemanticAnalyzer* _tmp19_;
		ValaSemanticAnalyzer* _tmp20_;
		ValaDataType* _tmp21_;
		ValaDataType* _tmp22_;
		ValaDataType* _tmp23_;
		_tmp10_ = vala_slice_expression_get_start (self);
		_tmp11_ = _tmp10_;
		_tmp12_ = vala_code_context_get_analyzer (context);
		_tmp13_ = _tmp12_;
		_tmp14_ = _tmp13_->int_type;
		_tmp15_ = vala_data_type_copy (_tmp14_);
		_tmp16_ = _tmp15_;
		vala_expression_set_target_type (_tmp11_, _tmp16_);
		_vala_code_node_unref0 (_tmp16_);
		_tmp17_ = vala_slice_expression_get_stop (self);
		_tmp18_ = _tmp17_;
		_tmp19_ = vala_code_context_get_analyzer (context);
		_tmp20_ = _tmp19_;
		_tmp21_ = _tmp20_->int_type;
		_tmp22_ = vala_data_type_copy (_tmp21_);
		_tmp23_ = _tmp22_;
		vala_expression_set_target_type (_tmp18_, _tmp23_);
		_vala_code_node_unref0 (_tmp23_);
	}
	_tmp24_ = vala_slice_expression_get_start (self);
	_tmp25_ = _tmp24_;
	if (!vala_code_node_check ((ValaCodeNode*) _tmp25_, context)) {
		vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
		result = FALSE;
		return result;
	}
	_tmp26_ = vala_slice_expression_get_stop (self);
	_tmp27_ = _tmp26_;
	if (!vala_code_node_check ((ValaCodeNode*) _tmp27_, context)) {
		vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
		result = FALSE;
		return result;
	}
	_tmp28_ = vala_slice_expression_get_container (self);
	_tmp29_ = _tmp28_;
	_tmp30_ = vala_expression_get_value_type (_tmp29_);
	_tmp31_ = _tmp30_;
	if (_tmp31_ == NULL) {
		ValaExpression* _tmp32_;
		ValaExpression* _tmp33_;
		ValaSourceReference* _tmp34_;
		ValaSourceReference* _tmp35_;
		vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
		_tmp32_ = vala_slice_expression_get_container (self);
		_tmp33_ = _tmp32_;
		_tmp34_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp33_);
		_tmp35_ = _tmp34_;
		vala_report_error (_tmp35_, "Invalid container expression");
		result = FALSE;
		return result;
	}
	_tmp36_ = vala_expression_get_lvalue ((ValaExpression*) self);
	_tmp37_ = _tmp36_;
	if (_tmp37_) {
		ValaExpression* _tmp38_;
		ValaExpression* _tmp39_;
		ValaSourceReference* _tmp40_;
		ValaSourceReference* _tmp41_;
		vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
		_tmp38_ = vala_slice_expression_get_container (self);
		_tmp39_ = _tmp38_;
		_tmp40_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp39_);
		_tmp41_ = _tmp40_;
		vala_report_error (_tmp41_, "Slice expressions cannot be used as lvalue");
		result = FALSE;
		return result;
	}
	_tmp42_ = vala_slice_expression_get_container (self);
	_tmp43_ = _tmp42_;
	_tmp44_ = vala_expression_get_value_type (_tmp43_);
	_tmp45_ = _tmp44_;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp45_, VALA_TYPE_ARRAY_TYPE)) {
		ValaExpression* _tmp46_;
		ValaExpression* _tmp47_;
		ValaDataType* _tmp48_;
		ValaDataType* _tmp49_;
		ValaDataType* _tmp50_;
		ValaDataType* _tmp51_;
		ValaDataType* _tmp52_;
		ValaDataType* _tmp53_;
		gboolean _tmp54_ = FALSE;
		ValaExpression* _tmp55_;
		ValaExpression* _tmp56_;
		ValaDataType* _tmp57_;
		ValaDataType* _tmp58_;
		gboolean _tmp67_ = FALSE;
		ValaExpression* _tmp68_;
		ValaExpression* _tmp69_;
		ValaDataType* _tmp70_;
		ValaDataType* _tmp71_;
		_tmp46_ = vala_slice_expression_get_container (self);
		_tmp47_ = _tmp46_;
		_tmp48_ = vala_expression_get_value_type (_tmp47_);
		_tmp49_ = _tmp48_;
		_tmp50_ = vala_data_type_copy (_tmp49_);
		_tmp51_ = _tmp50_;
		vala_expression_set_value_type ((ValaExpression*) self, _tmp51_);
		_vala_code_node_unref0 (_tmp51_);
		_tmp52_ = vala_expression_get_value_type ((ValaExpression*) self);
		_tmp53_ = _tmp52_;
		vala_data_type_set_value_owned (_tmp53_, FALSE);
		_tmp55_ = vala_slice_expression_get_start (self);
		_tmp56_ = _tmp55_;
		_tmp57_ = vala_expression_get_value_type (_tmp56_);
		_tmp58_ = _tmp57_;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp58_, VALA_TYPE_INTEGER_TYPE)) {
			_tmp54_ = TRUE;
		} else {
			ValaExpression* _tmp59_;
			ValaExpression* _tmp60_;
			ValaDataType* _tmp61_;
			ValaDataType* _tmp62_;
			_tmp59_ = vala_slice_expression_get_start (self);
			_tmp60_ = _tmp59_;
			_tmp61_ = vala_expression_get_value_type (_tmp60_);
			_tmp62_ = _tmp61_;
			_tmp54_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp62_, VALA_TYPE_ENUM_VALUE_TYPE);
		}
		if (!_tmp54_) {
			ValaExpression* _tmp63_;
			ValaExpression* _tmp64_;
			ValaSourceReference* _tmp65_;
			ValaSourceReference* _tmp66_;
			vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
			_tmp63_ = vala_slice_expression_get_start (self);
			_tmp64_ = _tmp63_;
			_tmp65_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp64_);
			_tmp66_ = _tmp65_;
			vala_report_error (_tmp66_, "Expression of integer type expected");
		}
		_tmp68_ = vala_slice_expression_get_stop (self);
		_tmp69_ = _tmp68_;
		_tmp70_ = vala_expression_get_value_type (_tmp69_);
		_tmp71_ = _tmp70_;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp71_, VALA_TYPE_INTEGER_TYPE)) {
			_tmp67_ = TRUE;
		} else {
			ValaExpression* _tmp72_;
			ValaExpression* _tmp73_;
			ValaDataType* _tmp74_;
			ValaDataType* _tmp75_;
			_tmp72_ = vala_slice_expression_get_stop (self);
			_tmp73_ = _tmp72_;
			_tmp74_ = vala_expression_get_value_type (_tmp73_);
			_tmp75_ = _tmp74_;
			_tmp67_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp75_, VALA_TYPE_ENUM_VALUE_TYPE);
		}
		if (!_tmp67_) {
			ValaExpression* _tmp76_;
			ValaExpression* _tmp77_;
			ValaSourceReference* _tmp78_;
			ValaSourceReference* _tmp79_;
			vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
			_tmp76_ = vala_slice_expression_get_stop (self);
			_tmp77_ = _tmp76_;
			_tmp78_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp77_);
			_tmp79_ = _tmp78_;
			vala_report_error (_tmp79_, "Expression of integer type expected");
		}
	} else {
		ValaMethod* slice_method = NULL;
		ValaExpression* _tmp80_;
		ValaExpression* _tmp81_;
		ValaDataType* _tmp82_;
		ValaDataType* _tmp83_;
		ValaSymbol* _tmp84_;
		ValaMethod* _tmp85_;
		ValaMethod* _tmp86_;
		ValaSourceReference* _tmp106_;
		ValaSourceReference* _tmp107_;
		ValaExpression* _tmp108_;
		ValaExpression* _tmp109_;
		ValaDataType* _tmp110_;
		ValaDataType* _tmp111_;
		gchar* _tmp112_;
		gchar* _tmp113_;
		gchar* _tmp114_;
		gchar* _tmp115_;
		_tmp80_ = vala_slice_expression_get_container (self);
		_tmp81_ = _tmp80_;
		_tmp82_ = vala_expression_get_value_type (_tmp81_);
		_tmp83_ = _tmp82_;
		_tmp84_ = vala_data_type_get_member (_tmp83_, "slice");
		_tmp85_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp84_, VALA_TYPE_METHOD) ? ((ValaMethod*) _tmp84_) : NULL;
		if (_tmp85_ == NULL) {
			_vala_code_node_unref0 (_tmp84_);
		}
		slice_method = _tmp85_;
		_tmp86_ = slice_method;
		if (_tmp86_ != NULL) {
			ValaMethodCall* slice_call = NULL;
			ValaExpression* _tmp87_;
			ValaExpression* _tmp88_;
			ValaMemberAccess* _tmp89_;
			ValaMemberAccess* _tmp90_;
			ValaMethodCall* _tmp91_;
			ValaMethodCall* _tmp92_;
			ValaMethodCall* _tmp93_;
			ValaExpression* _tmp94_;
			ValaExpression* _tmp95_;
			ValaMethodCall* _tmp96_;
			ValaExpression* _tmp97_;
			ValaExpression* _tmp98_;
			ValaMethodCall* _tmp99_;
			ValaDataType* _tmp100_;
			ValaDataType* _tmp101_;
			ValaCodeNode* _tmp102_;
			ValaCodeNode* _tmp103_;
			ValaMethodCall* _tmp104_;
			ValaMethodCall* _tmp105_;
			_tmp87_ = vala_slice_expression_get_container (self);
			_tmp88_ = _tmp87_;
			_tmp89_ = vala_member_access_new (_tmp88_, "slice", NULL);
			_tmp90_ = _tmp89_;
			_tmp91_ = vala_method_call_new ((ValaExpression*) _tmp90_, NULL);
			_tmp92_ = _tmp91_;
			_vala_code_node_unref0 (_tmp90_);
			slice_call = _tmp92_;
			_tmp93_ = slice_call;
			_tmp94_ = vala_slice_expression_get_start (self);
			_tmp95_ = _tmp94_;
			vala_method_call_add_argument (_tmp93_, _tmp95_);
			_tmp96_ = slice_call;
			_tmp97_ = vala_slice_expression_get_stop (self);
			_tmp98_ = _tmp97_;
			vala_method_call_add_argument (_tmp96_, _tmp98_);
			_tmp99_ = slice_call;
			_tmp100_ = vala_expression_get_target_type ((ValaExpression*) self);
			_tmp101_ = _tmp100_;
			vala_expression_set_target_type ((ValaExpression*) _tmp99_, _tmp101_);
			_tmp102_ = vala_code_node_get_parent_node ((ValaCodeNode*) self);
			_tmp103_ = _tmp102_;
			_tmp104_ = slice_call;
			vala_code_node_replace_expression (_tmp103_, (ValaExpression*) self, (ValaExpression*) _tmp104_);
			_tmp105_ = slice_call;
			result = vala_code_node_check ((ValaCodeNode*) _tmp105_, context);
			_vala_code_node_unref0 (slice_call);
			_vala_code_node_unref0 (slice_method);
			return result;
		}
		vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
		_tmp106_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp107_ = _tmp106_;
		_tmp108_ = vala_slice_expression_get_container (self);
		_tmp109_ = _tmp108_;
		_tmp110_ = vala_expression_get_value_type (_tmp109_);
		_tmp111_ = _tmp110_;
		_tmp112_ = vala_code_node_to_string ((ValaCodeNode*) _tmp111_);
		_tmp113_ = _tmp112_;
		_tmp114_ = g_strdup_printf ("The expression `%s' does not denote an array", _tmp113_);
		_tmp115_ = _tmp114_;
		vala_report_error (_tmp107_, _tmp115_);
		_g_free0 (_tmp115_);
		_g_free0 (_tmp113_);
		_vala_code_node_unref0 (slice_method);
	}
	_tmp116_ = vala_code_node_get_error ((ValaCodeNode*) self);
	_tmp117_ = _tmp116_;
	result = !_tmp117_;
	return result;
}


static void
vala_slice_expression_real_emit (ValaCodeNode* base,
                                 ValaCodeGenerator* codegen)
{
	ValaSliceExpression * self;
	ValaExpression* _tmp0_;
	ValaExpression* _tmp1_;
	ValaExpression* _tmp2_;
	ValaExpression* _tmp3_;
	ValaExpression* _tmp4_;
	ValaExpression* _tmp5_;
	self = (ValaSliceExpression*) base;
	g_return_if_fail (codegen != NULL);
	_tmp0_ = vala_slice_expression_get_container (self);
	_tmp1_ = _tmp0_;
	vala_code_node_emit ((ValaCodeNode*) _tmp1_, codegen);
	_tmp2_ = vala_slice_expression_get_start (self);
	_tmp3_ = _tmp2_;
	vala_code_node_emit ((ValaCodeNode*) _tmp3_, codegen);
	_tmp4_ = vala_slice_expression_get_stop (self);
	_tmp5_ = _tmp4_;
	vala_code_node_emit ((ValaCodeNode*) _tmp5_, codegen);
	vala_code_visitor_visit_slice_expression ((ValaCodeVisitor*) codegen, self);
	vala_code_visitor_visit_expression ((ValaCodeVisitor*) codegen, (ValaExpression*) self);
}


static void
vala_slice_expression_real_get_defined_variables (ValaCodeNode* base,
                                                  ValaCollection* collection)
{
	ValaSliceExpression * self;
	ValaExpression* _tmp0_;
	ValaExpression* _tmp1_;
	ValaExpression* _tmp2_;
	ValaExpression* _tmp3_;
	ValaExpression* _tmp4_;
	ValaExpression* _tmp5_;
	self = (ValaSliceExpression*) base;
	g_return_if_fail (collection != NULL);
	_tmp0_ = vala_slice_expression_get_container (self);
	_tmp1_ = _tmp0_;
	vala_code_node_get_defined_variables ((ValaCodeNode*) _tmp1_, collection);
	_tmp2_ = vala_slice_expression_get_start (self);
	_tmp3_ = _tmp2_;
	vala_code_node_get_defined_variables ((ValaCodeNode*) _tmp3_, collection);
	_tmp4_ = vala_slice_expression_get_stop (self);
	_tmp5_ = _tmp4_;
	vala_code_node_get_defined_variables ((ValaCodeNode*) _tmp5_, collection);
}


static void
vala_slice_expression_real_get_used_variables (ValaCodeNode* base,
                                               ValaCollection* collection)
{
	ValaSliceExpression * self;
	ValaExpression* _tmp0_;
	ValaExpression* _tmp1_;
	ValaExpression* _tmp2_;
	ValaExpression* _tmp3_;
	ValaExpression* _tmp4_;
	ValaExpression* _tmp5_;
	self = (ValaSliceExpression*) base;
	g_return_if_fail (collection != NULL);
	_tmp0_ = vala_slice_expression_get_container (self);
	_tmp1_ = _tmp0_;
	vala_code_node_get_used_variables ((ValaCodeNode*) _tmp1_, collection);
	_tmp2_ = vala_slice_expression_get_start (self);
	_tmp3_ = _tmp2_;
	vala_code_node_get_used_variables ((ValaCodeNode*) _tmp3_, collection);
	_tmp4_ = vala_slice_expression_get_stop (self);
	_tmp5_ = _tmp4_;
	vala_code_node_get_used_variables ((ValaCodeNode*) _tmp5_, collection);
}


ValaExpression*
vala_slice_expression_get_container (ValaSliceExpression* self)
{
	ValaExpression* result;
	ValaExpression* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_container;
	result = _tmp0_;
	return result;
}


static gpointer
_vala_code_node_ref0 (gpointer self)
{
	return self ? vala_code_node_ref (self) : NULL;
}


void
vala_slice_expression_set_container (ValaSliceExpression* self,
                                     ValaExpression* value)
{
	ValaExpression* _tmp0_;
	ValaExpression* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _vala_code_node_ref0 (value);
	_vala_code_node_unref0 (self->priv->_container);
	self->priv->_container = _tmp0_;
	_tmp1_ = self->priv->_container;
	vala_code_node_set_parent_node ((ValaCodeNode*) _tmp1_, (ValaCodeNode*) self);
}


ValaExpression*
vala_slice_expression_get_start (ValaSliceExpression* self)
{
	ValaExpression* result;
	ValaExpression* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_start;
	result = _tmp0_;
	return result;
}


static void
vala_slice_expression_set_start (ValaSliceExpression* self,
                                 ValaExpression* value)
{
	ValaExpression* _tmp0_;
	ValaExpression* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _vala_code_node_ref0 (value);
	_vala_code_node_unref0 (self->priv->_start);
	self->priv->_start = _tmp0_;
	_tmp1_ = self->priv->_start;
	vala_code_node_set_parent_node ((ValaCodeNode*) _tmp1_, (ValaCodeNode*) self);
}


ValaExpression*
vala_slice_expression_get_stop (ValaSliceExpression* self)
{
	ValaExpression* result;
	ValaExpression* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_stop;
	result = _tmp0_;
	return result;
}


static void
vala_slice_expression_set_stop (ValaSliceExpression* self,
                                ValaExpression* value)
{
	ValaExpression* _tmp0_;
	ValaExpression* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _vala_code_node_ref0 (value);
	_vala_code_node_unref0 (self->priv->_stop);
	self->priv->_stop = _tmp0_;
	_tmp1_ = self->priv->_stop;
	vala_code_node_set_parent_node ((ValaCodeNode*) _tmp1_, (ValaCodeNode*) self);
}


static void
vala_slice_expression_class_init (ValaSliceExpressionClass * klass)
{
	vala_slice_expression_parent_class = g_type_class_peek_parent (klass);
	((ValaCodeNodeClass *) klass)->finalize = vala_slice_expression_finalize;
	g_type_class_add_private (klass, sizeof (ValaSliceExpressionPrivate));
	((ValaCodeNodeClass *) klass)->accept = (void (*) (ValaCodeNode *, ValaCodeVisitor*)) vala_slice_expression_real_accept;
	((ValaCodeNodeClass *) klass)->accept_children = (void (*) (ValaCodeNode *, ValaCodeVisitor*)) vala_slice_expression_real_accept_children;
	((ValaCodeNodeClass *) klass)->replace_expression = (void (*) (ValaCodeNode *, ValaExpression*, ValaExpression*)) vala_slice_expression_real_replace_expression;
	((ValaExpressionClass *) klass)->is_pure = (gboolean (*) (ValaExpression *)) vala_slice_expression_real_is_pure;
	((ValaExpressionClass *) klass)->is_accessible = (gboolean (*) (ValaExpression *, ValaSymbol*)) vala_slice_expression_real_is_accessible;
	((ValaCodeNodeClass *) klass)->check = (gboolean (*) (ValaCodeNode *, ValaCodeContext*)) vala_slice_expression_real_check;
	((ValaCodeNodeClass *) klass)->emit = (void (*) (ValaCodeNode *, ValaCodeGenerator*)) vala_slice_expression_real_emit;
	((ValaCodeNodeClass *) klass)->get_defined_variables = (void (*) (ValaCodeNode *, ValaCollection*)) vala_slice_expression_real_get_defined_variables;
	((ValaCodeNodeClass *) klass)->get_used_variables = (void (*) (ValaCodeNode *, ValaCollection*)) vala_slice_expression_real_get_used_variables;
}


static void
vala_slice_expression_instance_init (ValaSliceExpression * self)
{
	self->priv = VALA_SLICE_EXPRESSION_GET_PRIVATE (self);
}


static void
vala_slice_expression_finalize (ValaCodeNode * obj)
{
	ValaSliceExpression * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALA_TYPE_SLICE_EXPRESSION, ValaSliceExpression);
	_vala_code_node_unref0 (self->priv->_container);
	_vala_code_node_unref0 (self->priv->_start);
	_vala_code_node_unref0 (self->priv->_stop);
	VALA_CODE_NODE_CLASS (vala_slice_expression_parent_class)->finalize (obj);
}


/**
 * Represents an array slice expression e.g "a[1:5]".
 */
GType
vala_slice_expression_get_type (void)
{
	static volatile gsize vala_slice_expression_type_id__volatile = 0;
	if (g_once_init_enter (&vala_slice_expression_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ValaSliceExpressionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_slice_expression_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaSliceExpression), 0, (GInstanceInitFunc) vala_slice_expression_instance_init, NULL };
		GType vala_slice_expression_type_id;
		vala_slice_expression_type_id = g_type_register_static (VALA_TYPE_EXPRESSION, "ValaSliceExpression", &g_define_type_info, 0);
		g_once_init_leave (&vala_slice_expression_type_id__volatile, vala_slice_expression_type_id);
	}
	return vala_slice_expression_type_id__volatile;
}



