/* valasymbolresolver.c generated by valac, the Vala compiler
 * generated from valasymbolresolver.vala, do not modify */

/* valasymbolresolver.vala
 *
 * Copyright (C) 2006-2010  Jürg Billeter
 * Copyright (C) 2006-2008  Raffaele Sandrini
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Jürg Billeter <j@bitron.ch>
 * 	Raffaele Sandrini <raffaele@sandrini.ch>
 */


#include <glib.h>
#include <glib-object.h>
#include "vala.h"
#include <valagee.h>
#include <stdlib.h>
#include <string.h>

#define _vala_code_context_unref0(var) ((var == NULL) ? NULL : (var = (vala_code_context_unref (var), NULL)))
#define _vala_code_node_unref0(var) ((var == NULL) ? NULL : (var = (vala_code_node_unref (var), NULL)))
#define _vala_scope_unref0(var) ((var == NULL) ? NULL : (var = (vala_scope_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_iterable_unref0(var) ((var == NULL) ? NULL : (var = (vala_iterable_unref (var), NULL)))

struct _ValaSymbolResolverPrivate {
	ValaCodeContext* context;
	ValaSymbol* root_symbol;
	ValaScope* current_scope;
};


static gpointer vala_symbol_resolver_parent_class = NULL;

#define VALA_SYMBOL_RESOLVER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALA_TYPE_SYMBOL_RESOLVER, ValaSymbolResolverPrivate))
static void vala_symbol_resolver_real_visit_namespace (ValaCodeVisitor* base,
                                                ValaNamespace* ns);
static void vala_symbol_resolver_real_visit_class (ValaCodeVisitor* base,
                                            ValaClass* cl);
static void vala_symbol_resolver_real_visit_struct (ValaCodeVisitor* base,
                                             ValaStruct* st);
static void vala_symbol_resolver_real_visit_interface (ValaCodeVisitor* base,
                                                ValaInterface* iface);
static void vala_symbol_resolver_real_visit_enum (ValaCodeVisitor* base,
                                           ValaEnum* en);
static void vala_symbol_resolver_real_visit_error_domain (ValaCodeVisitor* base,
                                                   ValaErrorDomain* ed);
static void vala_symbol_resolver_real_visit_delegate (ValaCodeVisitor* base,
                                               ValaDelegate* cb);
static void vala_symbol_resolver_real_visit_constant (ValaCodeVisitor* base,
                                               ValaConstant* c);
static void vala_symbol_resolver_real_visit_field (ValaCodeVisitor* base,
                                            ValaField* f);
static void vala_symbol_resolver_real_visit_method (ValaCodeVisitor* base,
                                             ValaMethod* m);
static void vala_symbol_resolver_real_visit_creation_method (ValaCodeVisitor* base,
                                                      ValaCreationMethod* m);
static void vala_symbol_resolver_real_visit_formal_parameter (ValaCodeVisitor* base,
                                                       ValaParameter* p);
static void vala_symbol_resolver_real_visit_property (ValaCodeVisitor* base,
                                               ValaProperty* prop);
static void vala_symbol_resolver_real_visit_property_accessor (ValaCodeVisitor* base,
                                                        ValaPropertyAccessor* acc);
static void vala_symbol_resolver_real_visit_signal (ValaCodeVisitor* base,
                                             ValaSignal* sig);
static void vala_symbol_resolver_real_visit_constructor (ValaCodeVisitor* base,
                                                  ValaConstructor* c);
static void vala_symbol_resolver_real_visit_destructor (ValaCodeVisitor* base,
                                                 ValaDestructor* d);
static void vala_symbol_resolver_real_visit_block (ValaCodeVisitor* base,
                                            ValaBlock* b);
static void vala_symbol_resolver_real_visit_using_directive (ValaCodeVisitor* base,
                                                      ValaUsingDirective* ns);
static ValaSymbol* vala_symbol_resolver_resolve_symbol (ValaSymbolResolver* self,
                                                 ValaUnresolvedSymbol* unresolved_symbol);
static ValaDataType* vala_symbol_resolver_get_type_for_struct (ValaSymbolResolver* self,
                                                        ValaStruct* st,
                                                        ValaStruct* base_struct);
static ValaDataType* vala_symbol_resolver_resolve_type (ValaSymbolResolver* self,
                                                 ValaUnresolvedType* unresolved_type);
static void vala_symbol_resolver_real_visit_data_type (ValaCodeVisitor* base,
                                                ValaDataType* data_type);
static void vala_symbol_resolver_real_visit_declaration_statement (ValaCodeVisitor* base,
                                                            ValaDeclarationStatement* stmt);
static void vala_symbol_resolver_real_visit_local_variable (ValaCodeVisitor* base,
                                                     ValaLocalVariable* local);
static void vala_symbol_resolver_real_visit_initializer_list (ValaCodeVisitor* base,
                                                       ValaInitializerList* list);
static void vala_symbol_resolver_real_visit_expression_statement (ValaCodeVisitor* base,
                                                           ValaExpressionStatement* stmt);
static void vala_symbol_resolver_real_visit_if_statement (ValaCodeVisitor* base,
                                                   ValaIfStatement* stmt);
static void vala_symbol_resolver_real_visit_switch_statement (ValaCodeVisitor* base,
                                                       ValaSwitchStatement* stmt);
static void vala_symbol_resolver_real_visit_switch_section (ValaCodeVisitor* base,
                                                     ValaSwitchSection* section);
static void vala_symbol_resolver_real_visit_switch_label (ValaCodeVisitor* base,
                                                   ValaSwitchLabel* label);
static void vala_symbol_resolver_real_visit_loop (ValaCodeVisitor* base,
                                           ValaLoop* stmt);
static void vala_symbol_resolver_real_visit_while_statement (ValaCodeVisitor* base,
                                                      ValaWhileStatement* stmt);
static void vala_symbol_resolver_real_visit_do_statement (ValaCodeVisitor* base,
                                                   ValaDoStatement* stmt);
static void vala_symbol_resolver_real_visit_for_statement (ValaCodeVisitor* base,
                                                    ValaForStatement* stmt);
static void vala_symbol_resolver_real_visit_foreach_statement (ValaCodeVisitor* base,
                                                        ValaForeachStatement* stmt);
static void vala_symbol_resolver_real_visit_return_statement (ValaCodeVisitor* base,
                                                       ValaReturnStatement* stmt);
static void vala_symbol_resolver_real_visit_yield_statement (ValaCodeVisitor* base,
                                                      ValaYieldStatement* stmt);
static void vala_symbol_resolver_real_visit_throw_statement (ValaCodeVisitor* base,
                                                      ValaThrowStatement* stmt);
static void vala_symbol_resolver_real_visit_try_statement (ValaCodeVisitor* base,
                                                    ValaTryStatement* stmt);
static void vala_symbol_resolver_real_visit_delete_statement (ValaCodeVisitor* base,
                                                       ValaDeleteStatement* stmt);
static void vala_symbol_resolver_real_visit_catch_clause (ValaCodeVisitor* base,
                                                   ValaCatchClause* clause);
static void vala_symbol_resolver_real_visit_array_creation_expression (ValaCodeVisitor* base,
                                                                ValaArrayCreationExpression* e);
static void vala_symbol_resolver_real_visit_template (ValaCodeVisitor* base,
                                               ValaTemplate* tmpl);
static void vala_symbol_resolver_real_visit_tuple (ValaCodeVisitor* base,
                                            ValaTuple* tuple);
static void vala_symbol_resolver_real_visit_member_access (ValaCodeVisitor* base,
                                                    ValaMemberAccess* expr);
static void vala_symbol_resolver_real_visit_method_call (ValaCodeVisitor* base,
                                                  ValaMethodCall* expr);
static void vala_symbol_resolver_real_visit_element_access (ValaCodeVisitor* base,
                                                     ValaElementAccess* expr);
static void vala_symbol_resolver_real_visit_slice_expression (ValaCodeVisitor* base,
                                                       ValaSliceExpression* expr);
static void vala_symbol_resolver_real_visit_postfix_expression (ValaCodeVisitor* base,
                                                         ValaPostfixExpression* expr);
static void vala_symbol_resolver_real_visit_object_creation_expression (ValaCodeVisitor* base,
                                                                 ValaObjectCreationExpression* expr);
static void vala_symbol_resolver_real_visit_sizeof_expression (ValaCodeVisitor* base,
                                                        ValaSizeofExpression* expr);
static void vala_symbol_resolver_real_visit_typeof_expression (ValaCodeVisitor* base,
                                                        ValaTypeofExpression* expr);
static void vala_symbol_resolver_real_visit_unary_expression (ValaCodeVisitor* base,
                                                       ValaUnaryExpression* expr);
static void vala_symbol_resolver_real_visit_cast_expression (ValaCodeVisitor* base,
                                                      ValaCastExpression* expr);
static void vala_symbol_resolver_real_visit_named_argument (ValaCodeVisitor* base,
                                                     ValaNamedArgument* expr);
static void vala_symbol_resolver_real_visit_addressof_expression (ValaCodeVisitor* base,
                                                           ValaAddressofExpression* expr);
static void vala_symbol_resolver_real_visit_reference_transfer_expression (ValaCodeVisitor* base,
                                                                    ValaReferenceTransferExpression* expr);
static void vala_symbol_resolver_real_visit_binary_expression (ValaCodeVisitor* base,
                                                        ValaBinaryExpression* expr);
static void vala_symbol_resolver_real_visit_type_check (ValaCodeVisitor* base,
                                                 ValaTypeCheck* expr);
static void vala_symbol_resolver_real_visit_conditional_expression (ValaCodeVisitor* base,
                                                             ValaConditionalExpression* expr);
static void vala_symbol_resolver_real_visit_lambda_expression (ValaCodeVisitor* base,
                                                        ValaLambdaExpression* l);
static void vala_symbol_resolver_real_visit_assignment (ValaCodeVisitor* base,
                                                 ValaAssignment* a);
static void vala_symbol_resolver_finalize (ValaCodeVisitor * obj);


/**
 * Resolve symbol names in the specified code context.
 *
 * @param context a code context
 */
static gpointer
_vala_code_context_ref0 (gpointer self)
{
	return self ? vala_code_context_ref (self) : NULL;
}


static gpointer
_vala_code_node_ref0 (gpointer self)
{
	return self ? vala_code_node_ref (self) : NULL;
}


void
vala_symbol_resolver_resolve (ValaSymbolResolver* self,
                              ValaCodeContext* context)
{
	ValaCodeContext* _tmp0_;
	ValaNamespace* _tmp1_;
	ValaNamespace* _tmp2_;
	ValaSymbol* _tmp3_;
	ValaNamespace* _tmp4_;
	ValaNamespace* _tmp5_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	_tmp0_ = _vala_code_context_ref0 (context);
	_vala_code_context_unref0 (self->priv->context);
	self->priv->context = _tmp0_;
	_tmp1_ = vala_code_context_get_root (context);
	_tmp2_ = _tmp1_;
	_tmp3_ = _vala_code_node_ref0 ((ValaSymbol*) _tmp2_);
	_vala_code_node_unref0 (self->priv->root_symbol);
	self->priv->root_symbol = _tmp3_;
	_tmp4_ = vala_code_context_get_root (context);
	_tmp5_ = _tmp4_;
	vala_code_node_accept ((ValaCodeNode*) _tmp5_, (ValaCodeVisitor*) self);
	_vala_code_node_unref0 (self->priv->root_symbol);
	self->priv->root_symbol = NULL;
	_vala_code_context_unref0 (self->priv->context);
	self->priv->context = NULL;
}


static gpointer
_vala_scope_ref0 (gpointer self)
{
	return self ? vala_scope_ref (self) : NULL;
}


static void
vala_symbol_resolver_real_visit_namespace (ValaCodeVisitor* base,
                                           ValaNamespace* ns)
{
	ValaSymbolResolver * self;
	ValaScope* old_scope = NULL;
	ValaScope* _tmp0_;
	ValaScope* _tmp1_;
	ValaScope* _tmp2_;
	ValaScope* _tmp3_;
	ValaScope* _tmp4_;
	ValaScope* _tmp5_;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (ns != NULL);
	_tmp0_ = self->priv->current_scope;
	_tmp1_ = _vala_scope_ref0 (_tmp0_);
	old_scope = _tmp1_;
	_tmp2_ = vala_symbol_get_scope ((ValaSymbol*) ns);
	_tmp3_ = _tmp2_;
	_tmp4_ = _vala_scope_ref0 (_tmp3_);
	_vala_scope_unref0 (self->priv->current_scope);
	self->priv->current_scope = _tmp4_;
	vala_code_node_accept_children ((ValaCodeNode*) ns, (ValaCodeVisitor*) self);
	_tmp5_ = _vala_scope_ref0 (old_scope);
	_vala_scope_unref0 (self->priv->current_scope);
	self->priv->current_scope = _tmp5_;
	_vala_scope_unref0 (old_scope);
}


static void
vala_symbol_resolver_real_visit_class (ValaCodeVisitor* base,
                                       ValaClass* cl)
{
	ValaSymbolResolver * self;
	ValaScope* _tmp0_;
	ValaScope* _tmp1_;
	ValaScope* _tmp2_;
	ValaScope* _tmp50_;
	ValaScope* _tmp51_;
	ValaScope* _tmp52_;
	ValaScope* _tmp53_;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (cl != NULL);
	_tmp0_ = vala_symbol_get_scope ((ValaSymbol*) cl);
	_tmp1_ = _tmp0_;
	_tmp2_ = _vala_scope_ref0 (_tmp1_);
	_vala_scope_unref0 (self->priv->current_scope);
	self->priv->current_scope = _tmp2_;
	vala_code_node_accept_children ((ValaCodeNode*) cl, (ValaCodeVisitor*) self);
	vala_class_set_base_class (cl, NULL);
	{
		ValaList* _type_list = NULL;
		ValaList* _tmp3_;
		gint _type_size = 0;
		ValaList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _type_index = 0;
		_tmp3_ = vala_class_get_base_types (cl);
		_type_list = _tmp3_;
		_tmp4_ = _type_list;
		_tmp5_ = vala_collection_get_size ((ValaCollection*) _tmp4_);
		_tmp6_ = _tmp5_;
		_type_size = _tmp6_;
		_type_index = -1;
		while (TRUE) {
			gint _tmp7_;
			gint _tmp8_;
			gint _tmp9_;
			ValaDataType* type = NULL;
			ValaList* _tmp10_;
			gint _tmp11_;
			gpointer _tmp12_;
			ValaDataType* _tmp13_;
			ValaTypeSymbol* _tmp14_;
			ValaTypeSymbol* _tmp15_;
			_tmp7_ = _type_index;
			_type_index = _tmp7_ + 1;
			_tmp8_ = _type_index;
			_tmp9_ = _type_size;
			if (!(_tmp8_ < _tmp9_)) {
				break;
			}
			_tmp10_ = _type_list;
			_tmp11_ = _type_index;
			_tmp12_ = vala_list_get (_tmp10_, _tmp11_);
			type = (ValaDataType*) _tmp12_;
			_tmp13_ = type;
			_tmp14_ = vala_data_type_get_data_type (_tmp13_);
			_tmp15_ = _tmp14_;
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp15_, VALA_TYPE_CLASS)) {
				ValaClass* _tmp16_;
				ValaClass* _tmp17_;
				ValaDataType* _tmp34_;
				ValaTypeSymbol* _tmp35_;
				ValaTypeSymbol* _tmp36_;
				ValaClass* _tmp37_;
				ValaClass* _tmp38_;
				_tmp16_ = vala_class_get_base_class (cl);
				_tmp17_ = _tmp16_;
				if (_tmp17_ != NULL) {
					ValaDataType* _tmp18_;
					ValaSourceReference* _tmp19_;
					ValaSourceReference* _tmp20_;
					gchar* _tmp21_;
					gchar* _tmp22_;
					ValaClass* _tmp23_;
					ValaClass* _tmp24_;
					gchar* _tmp25_;
					gchar* _tmp26_;
					ValaDataType* _tmp27_;
					ValaTypeSymbol* _tmp28_;
					ValaTypeSymbol* _tmp29_;
					gchar* _tmp30_;
					gchar* _tmp31_;
					gchar* _tmp32_;
					gchar* _tmp33_;
					vala_code_node_set_error ((ValaCodeNode*) cl, TRUE);
					_tmp18_ = type;
					_tmp19_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp18_);
					_tmp20_ = _tmp19_;
					_tmp21_ = vala_symbol_get_full_name ((ValaSymbol*) cl);
					_tmp22_ = _tmp21_;
					_tmp23_ = vala_class_get_base_class (cl);
					_tmp24_ = _tmp23_;
					_tmp25_ = vala_symbol_get_full_name ((ValaSymbol*) _tmp24_);
					_tmp26_ = _tmp25_;
					_tmp27_ = type;
					_tmp28_ = vala_data_type_get_data_type (_tmp27_);
					_tmp29_ = _tmp28_;
					_tmp30_ = vala_symbol_get_full_name ((ValaSymbol*) _tmp29_);
					_tmp31_ = _tmp30_;
					_tmp32_ = g_strdup_printf ("%s: Classes cannot have multiple base classes (`%s' and `%s')", _tmp22_, _tmp26_, _tmp31_);
					_tmp33_ = _tmp32_;
					vala_report_error (_tmp20_, _tmp33_);
					_g_free0 (_tmp33_);
					_g_free0 (_tmp31_);
					_g_free0 (_tmp26_);
					_g_free0 (_tmp22_);
					_vala_code_node_unref0 (type);
					_vala_iterable_unref0 (_type_list);
					return;
				}
				_tmp34_ = type;
				_tmp35_ = vala_data_type_get_data_type (_tmp34_);
				_tmp36_ = _tmp35_;
				vala_class_set_base_class (cl, G_TYPE_CHECK_INSTANCE_CAST (_tmp36_, VALA_TYPE_CLASS, ValaClass));
				_tmp37_ = vala_class_get_base_class (cl);
				_tmp38_ = _tmp37_;
				if (vala_typesymbol_is_subtype_of ((ValaTypeSymbol*) _tmp38_, (ValaTypeSymbol*) cl)) {
					ValaDataType* _tmp39_;
					ValaSourceReference* _tmp40_;
					ValaSourceReference* _tmp41_;
					gchar* _tmp42_;
					gchar* _tmp43_;
					ValaClass* _tmp44_;
					ValaClass* _tmp45_;
					gchar* _tmp46_;
					gchar* _tmp47_;
					gchar* _tmp48_;
					gchar* _tmp49_;
					vala_code_node_set_error ((ValaCodeNode*) cl, TRUE);
					_tmp39_ = type;
					_tmp40_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp39_);
					_tmp41_ = _tmp40_;
					_tmp42_ = vala_symbol_get_full_name ((ValaSymbol*) cl);
					_tmp43_ = _tmp42_;
					_tmp44_ = vala_class_get_base_class (cl);
					_tmp45_ = _tmp44_;
					_tmp46_ = vala_symbol_get_full_name ((ValaSymbol*) _tmp45_);
					_tmp47_ = _tmp46_;
					_tmp48_ = g_strdup_printf ("Base class cycle (`%s' and `%s')", _tmp43_, _tmp47_);
					_tmp49_ = _tmp48_;
					vala_report_error (_tmp41_, _tmp49_);
					_g_free0 (_tmp49_);
					_g_free0 (_tmp47_);
					_g_free0 (_tmp43_);
					_vala_code_node_unref0 (type);
					_vala_iterable_unref0 (_type_list);
					return;
				}
			}
			_vala_code_node_unref0 (type);
		}
		_vala_iterable_unref0 (_type_list);
	}
	_tmp50_ = self->priv->current_scope;
	_tmp51_ = vala_scope_get_parent_scope (_tmp50_);
	_tmp52_ = _tmp51_;
	_tmp53_ = _vala_scope_ref0 (_tmp52_);
	_vala_scope_unref0 (self->priv->current_scope);
	self->priv->current_scope = _tmp53_;
}


static void
vala_symbol_resolver_real_visit_struct (ValaCodeVisitor* base,
                                        ValaStruct* st)
{
	ValaSymbolResolver * self;
	ValaScope* _tmp0_;
	ValaScope* _tmp1_;
	ValaScope* _tmp2_;
	ValaDataType* _tmp3_;
	ValaDataType* _tmp4_;
	ValaScope* _tmp20_;
	ValaScope* _tmp21_;
	ValaScope* _tmp22_;
	ValaScope* _tmp23_;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (st != NULL);
	_tmp0_ = vala_symbol_get_scope ((ValaSymbol*) st);
	_tmp1_ = _tmp0_;
	_tmp2_ = _vala_scope_ref0 (_tmp1_);
	_vala_scope_unref0 (self->priv->current_scope);
	self->priv->current_scope = _tmp2_;
	vala_code_node_accept_children ((ValaCodeNode*) st, (ValaCodeVisitor*) self);
	_tmp3_ = vala_struct_get_base_type (st);
	_tmp4_ = _tmp3_;
	if (_tmp4_ != NULL) {
		ValaStruct* base_type = NULL;
		ValaStruct* _tmp5_;
		ValaStruct* _tmp6_;
		ValaStruct* _tmp7_;
		ValaStruct* _tmp8_;
		_tmp5_ = vala_struct_get_base_struct (st);
		_tmp6_ = _tmp5_;
		_tmp7_ = _vala_code_node_ref0 (_tmp6_);
		base_type = _tmp7_;
		_tmp8_ = base_type;
		if (_tmp8_ != NULL) {
			ValaStruct* _tmp9_;
			_tmp9_ = base_type;
			if (vala_typesymbol_is_subtype_of ((ValaTypeSymbol*) _tmp9_, (ValaTypeSymbol*) st)) {
				ValaStruct* _tmp10_;
				ValaSourceReference* _tmp11_;
				ValaSourceReference* _tmp12_;
				gchar* _tmp13_;
				gchar* _tmp14_;
				ValaStruct* _tmp15_;
				gchar* _tmp16_;
				gchar* _tmp17_;
				gchar* _tmp18_;
				gchar* _tmp19_;
				vala_code_node_set_error ((ValaCodeNode*) st, TRUE);
				_tmp10_ = base_type;
				_tmp11_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp10_);
				_tmp12_ = _tmp11_;
				_tmp13_ = vala_symbol_get_full_name ((ValaSymbol*) st);
				_tmp14_ = _tmp13_;
				_tmp15_ = base_type;
				_tmp16_ = vala_symbol_get_full_name ((ValaSymbol*) _tmp15_);
				_tmp17_ = _tmp16_;
				_tmp18_ = g_strdup_printf ("Base struct cycle (`%s' and `%s')", _tmp14_, _tmp17_);
				_tmp19_ = _tmp18_;
				vala_report_error (_tmp12_, _tmp19_);
				_g_free0 (_tmp19_);
				_g_free0 (_tmp17_);
				_g_free0 (_tmp14_);
				_vala_code_node_unref0 (base_type);
				return;
			}
		}
		_vala_code_node_unref0 (base_type);
	}
	_tmp20_ = self->priv->current_scope;
	_tmp21_ = vala_scope_get_parent_scope (_tmp20_);
	_tmp22_ = _tmp21_;
	_tmp23_ = _vala_scope_ref0 (_tmp22_);
	_vala_scope_unref0 (self->priv->current_scope);
	self->priv->current_scope = _tmp23_;
}


static void
vala_symbol_resolver_real_visit_interface (ValaCodeVisitor* base,
                                           ValaInterface* iface)
{
	ValaSymbolResolver * self;
	ValaScope* _tmp0_;
	ValaScope* _tmp1_;
	ValaScope* _tmp2_;
	ValaScope* _tmp32_;
	ValaScope* _tmp33_;
	ValaScope* _tmp34_;
	ValaScope* _tmp35_;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (iface != NULL);
	_tmp0_ = vala_symbol_get_scope ((ValaSymbol*) iface);
	_tmp1_ = _tmp0_;
	_tmp2_ = _vala_scope_ref0 (_tmp1_);
	_vala_scope_unref0 (self->priv->current_scope);
	self->priv->current_scope = _tmp2_;
	vala_code_node_accept_children ((ValaCodeNode*) iface, (ValaCodeVisitor*) self);
	{
		ValaList* _type_list = NULL;
		ValaList* _tmp3_;
		gint _type_size = 0;
		ValaList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _type_index = 0;
		_tmp3_ = vala_interface_get_prerequisites (iface);
		_type_list = _tmp3_;
		_tmp4_ = _type_list;
		_tmp5_ = vala_collection_get_size ((ValaCollection*) _tmp4_);
		_tmp6_ = _tmp5_;
		_type_size = _tmp6_;
		_type_index = -1;
		while (TRUE) {
			gint _tmp7_;
			gint _tmp8_;
			gint _tmp9_;
			ValaDataType* type = NULL;
			ValaList* _tmp10_;
			gint _tmp11_;
			gpointer _tmp12_;
			gboolean _tmp13_ = FALSE;
			ValaDataType* _tmp14_;
			ValaTypeSymbol* _tmp15_;
			ValaTypeSymbol* _tmp16_;
			_tmp7_ = _type_index;
			_type_index = _tmp7_ + 1;
			_tmp8_ = _type_index;
			_tmp9_ = _type_size;
			if (!(_tmp8_ < _tmp9_)) {
				break;
			}
			_tmp10_ = _type_list;
			_tmp11_ = _type_index;
			_tmp12_ = vala_list_get (_tmp10_, _tmp11_);
			type = (ValaDataType*) _tmp12_;
			_tmp14_ = type;
			_tmp15_ = vala_data_type_get_data_type (_tmp14_);
			_tmp16_ = _tmp15_;
			if (_tmp16_ != NULL) {
				ValaDataType* _tmp17_;
				ValaTypeSymbol* _tmp18_;
				ValaTypeSymbol* _tmp19_;
				_tmp17_ = type;
				_tmp18_ = vala_data_type_get_data_type (_tmp17_);
				_tmp19_ = _tmp18_;
				_tmp13_ = vala_typesymbol_is_subtype_of (_tmp19_, (ValaTypeSymbol*) iface);
			} else {
				_tmp13_ = FALSE;
			}
			if (_tmp13_) {
				ValaDataType* _tmp20_;
				ValaSourceReference* _tmp21_;
				ValaSourceReference* _tmp22_;
				gchar* _tmp23_;
				gchar* _tmp24_;
				ValaDataType* _tmp25_;
				ValaTypeSymbol* _tmp26_;
				ValaTypeSymbol* _tmp27_;
				gchar* _tmp28_;
				gchar* _tmp29_;
				gchar* _tmp30_;
				gchar* _tmp31_;
				vala_code_node_set_error ((ValaCodeNode*) iface, TRUE);
				_tmp20_ = type;
				_tmp21_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp20_);
				_tmp22_ = _tmp21_;
				_tmp23_ = vala_symbol_get_full_name ((ValaSymbol*) iface);
				_tmp24_ = _tmp23_;
				_tmp25_ = type;
				_tmp26_ = vala_data_type_get_data_type (_tmp25_);
				_tmp27_ = _tmp26_;
				_tmp28_ = vala_symbol_get_full_name ((ValaSymbol*) _tmp27_);
				_tmp29_ = _tmp28_;
				_tmp30_ = g_strdup_printf ("Prerequisite cycle (`%s' and `%s')", _tmp24_, _tmp29_);
				_tmp31_ = _tmp30_;
				vala_report_error (_tmp22_, _tmp31_);
				_g_free0 (_tmp31_);
				_g_free0 (_tmp29_);
				_g_free0 (_tmp24_);
				_vala_code_node_unref0 (type);
				_vala_iterable_unref0 (_type_list);
				return;
			}
			_vala_code_node_unref0 (type);
		}
		_vala_iterable_unref0 (_type_list);
	}
	_tmp32_ = self->priv->current_scope;
	_tmp33_ = vala_scope_get_parent_scope (_tmp32_);
	_tmp34_ = _tmp33_;
	_tmp35_ = _vala_scope_ref0 (_tmp34_);
	_vala_scope_unref0 (self->priv->current_scope);
	self->priv->current_scope = _tmp35_;
}


static void
vala_symbol_resolver_real_visit_enum (ValaCodeVisitor* base,
                                      ValaEnum* en)
{
	ValaSymbolResolver * self;
	ValaScope* _tmp0_;
	ValaScope* _tmp1_;
	ValaScope* _tmp2_;
	ValaScope* _tmp3_;
	ValaScope* _tmp4_;
	ValaScope* _tmp5_;
	ValaScope* _tmp6_;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (en != NULL);
	_tmp0_ = vala_symbol_get_scope ((ValaSymbol*) en);
	_tmp1_ = _tmp0_;
	_tmp2_ = _vala_scope_ref0 (_tmp1_);
	_vala_scope_unref0 (self->priv->current_scope);
	self->priv->current_scope = _tmp2_;
	vala_code_node_accept_children ((ValaCodeNode*) en, (ValaCodeVisitor*) self);
	_tmp3_ = self->priv->current_scope;
	_tmp4_ = vala_scope_get_parent_scope (_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = _vala_scope_ref0 (_tmp5_);
	_vala_scope_unref0 (self->priv->current_scope);
	self->priv->current_scope = _tmp6_;
}


static void
vala_symbol_resolver_real_visit_error_domain (ValaCodeVisitor* base,
                                              ValaErrorDomain* ed)
{
	ValaSymbolResolver * self;
	ValaScope* _tmp0_;
	ValaScope* _tmp1_;
	ValaScope* _tmp2_;
	ValaScope* _tmp3_;
	ValaScope* _tmp4_;
	ValaScope* _tmp5_;
	ValaScope* _tmp6_;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (ed != NULL);
	_tmp0_ = vala_symbol_get_scope ((ValaSymbol*) ed);
	_tmp1_ = _tmp0_;
	_tmp2_ = _vala_scope_ref0 (_tmp1_);
	_vala_scope_unref0 (self->priv->current_scope);
	self->priv->current_scope = _tmp2_;
	vala_code_node_accept_children ((ValaCodeNode*) ed, (ValaCodeVisitor*) self);
	_tmp3_ = self->priv->current_scope;
	_tmp4_ = vala_scope_get_parent_scope (_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = _vala_scope_ref0 (_tmp5_);
	_vala_scope_unref0 (self->priv->current_scope);
	self->priv->current_scope = _tmp6_;
}


static void
vala_symbol_resolver_real_visit_delegate (ValaCodeVisitor* base,
                                          ValaDelegate* cb)
{
	ValaSymbolResolver * self;
	ValaScope* _tmp0_;
	ValaScope* _tmp1_;
	ValaScope* _tmp2_;
	ValaScope* _tmp3_;
	ValaScope* _tmp4_;
	ValaScope* _tmp5_;
	ValaScope* _tmp6_;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (cb != NULL);
	_tmp0_ = vala_symbol_get_scope ((ValaSymbol*) cb);
	_tmp1_ = _tmp0_;
	_tmp2_ = _vala_scope_ref0 (_tmp1_);
	_vala_scope_unref0 (self->priv->current_scope);
	self->priv->current_scope = _tmp2_;
	vala_code_node_accept_children ((ValaCodeNode*) cb, (ValaCodeVisitor*) self);
	_tmp3_ = self->priv->current_scope;
	_tmp4_ = vala_scope_get_parent_scope (_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = _vala_scope_ref0 (_tmp5_);
	_vala_scope_unref0 (self->priv->current_scope);
	self->priv->current_scope = _tmp6_;
}


static void
vala_symbol_resolver_real_visit_constant (ValaCodeVisitor* base,
                                          ValaConstant* c)
{
	ValaSymbolResolver * self;
	ValaScope* old_scope = NULL;
	ValaScope* _tmp0_;
	ValaScope* _tmp1_;
	ValaSymbol* _tmp2_;
	ValaSymbol* _tmp3_;
	ValaScope* _tmp7_;
	ValaScope* _tmp8_;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (c != NULL);
	_tmp0_ = self->priv->current_scope;
	_tmp1_ = _vala_scope_ref0 (_tmp0_);
	old_scope = _tmp1_;
	_tmp2_ = vala_symbol_get_parent_symbol ((ValaSymbol*) c);
	_tmp3_ = _tmp2_;
	if (!G_TYPE_CHECK_INSTANCE_TYPE (_tmp3_, VALA_TYPE_BLOCK)) {
		ValaScope* _tmp4_;
		ValaScope* _tmp5_;
		ValaScope* _tmp6_;
		_tmp4_ = vala_symbol_get_scope ((ValaSymbol*) c);
		_tmp5_ = _tmp4_;
		_tmp6_ = _vala_scope_ref0 (_tmp5_);
		_vala_scope_unref0 (self->priv->current_scope);
		self->priv->current_scope = _tmp6_;
	}
	vala_code_node_accept_children ((ValaCodeNode*) c, (ValaCodeVisitor*) self);
	_tmp7_ = old_scope;
	_tmp8_ = _vala_scope_ref0 (_tmp7_);
	_vala_scope_unref0 (self->priv->current_scope);
	self->priv->current_scope = _tmp8_;
	_vala_scope_unref0 (old_scope);
}


static void
vala_symbol_resolver_real_visit_field (ValaCodeVisitor* base,
                                       ValaField* f)
{
	ValaSymbolResolver * self;
	ValaScope* _tmp0_;
	ValaScope* _tmp1_;
	ValaScope* _tmp2_;
	ValaScope* _tmp3_;
	ValaScope* _tmp4_;
	ValaScope* _tmp5_;
	ValaScope* _tmp6_;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (f != NULL);
	_tmp0_ = vala_symbol_get_scope ((ValaSymbol*) f);
	_tmp1_ = _tmp0_;
	_tmp2_ = _vala_scope_ref0 (_tmp1_);
	_vala_scope_unref0 (self->priv->current_scope);
	self->priv->current_scope = _tmp2_;
	vala_code_node_accept_children ((ValaCodeNode*) f, (ValaCodeVisitor*) self);
	_tmp3_ = self->priv->current_scope;
	_tmp4_ = vala_scope_get_parent_scope (_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = _vala_scope_ref0 (_tmp5_);
	_vala_scope_unref0 (self->priv->current_scope);
	self->priv->current_scope = _tmp6_;
}


static void
vala_symbol_resolver_real_visit_method (ValaCodeVisitor* base,
                                        ValaMethod* m)
{
	ValaSymbolResolver * self;
	ValaScope* _tmp0_;
	ValaScope* _tmp1_;
	ValaScope* _tmp2_;
	ValaScope* _tmp3_;
	ValaScope* _tmp4_;
	ValaScope* _tmp5_;
	ValaScope* _tmp6_;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (m != NULL);
	_tmp0_ = vala_symbol_get_scope ((ValaSymbol*) m);
	_tmp1_ = _tmp0_;
	_tmp2_ = _vala_scope_ref0 (_tmp1_);
	_vala_scope_unref0 (self->priv->current_scope);
	self->priv->current_scope = _tmp2_;
	vala_code_node_accept_children ((ValaCodeNode*) m, (ValaCodeVisitor*) self);
	_tmp3_ = self->priv->current_scope;
	_tmp4_ = vala_scope_get_parent_scope (_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = _vala_scope_ref0 (_tmp5_);
	_vala_scope_unref0 (self->priv->current_scope);
	self->priv->current_scope = _tmp6_;
}


static void
vala_symbol_resolver_real_visit_creation_method (ValaCodeVisitor* base,
                                                 ValaCreationMethod* m)
{
	ValaSymbolResolver * self;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (m != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) m, (ValaCodeVisitor*) self);
}


static void
vala_symbol_resolver_real_visit_formal_parameter (ValaCodeVisitor* base,
                                                  ValaParameter* p)
{
	ValaSymbolResolver * self;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (p != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) p, (ValaCodeVisitor*) self);
}


static void
vala_symbol_resolver_real_visit_property (ValaCodeVisitor* base,
                                          ValaProperty* prop)
{
	ValaSymbolResolver * self;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (prop != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) prop, (ValaCodeVisitor*) self);
}


static void
vala_symbol_resolver_real_visit_property_accessor (ValaCodeVisitor* base,
                                                   ValaPropertyAccessor* acc)
{
	ValaSymbolResolver * self;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (acc != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) acc, (ValaCodeVisitor*) self);
}


static void
vala_symbol_resolver_real_visit_signal (ValaCodeVisitor* base,
                                        ValaSignal* sig)
{
	ValaSymbolResolver * self;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (sig != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) sig, (ValaCodeVisitor*) self);
}


static void
vala_symbol_resolver_real_visit_constructor (ValaCodeVisitor* base,
                                             ValaConstructor* c)
{
	ValaSymbolResolver * self;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (c != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) c, (ValaCodeVisitor*) self);
}


static void
vala_symbol_resolver_real_visit_destructor (ValaCodeVisitor* base,
                                            ValaDestructor* d)
{
	ValaSymbolResolver * self;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (d != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) d, (ValaCodeVisitor*) self);
}


static void
vala_symbol_resolver_real_visit_block (ValaCodeVisitor* base,
                                       ValaBlock* b)
{
	ValaSymbolResolver * self;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (b != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) b, (ValaCodeVisitor*) self);
}


static void
vala_symbol_resolver_real_visit_using_directive (ValaCodeVisitor* base,
                                                 ValaUsingDirective* ns)
{
	ValaSymbolResolver * self;
	ValaUnresolvedSymbol* unresolved_symbol = NULL;
	ValaSymbol* _tmp0_;
	ValaSymbol* _tmp1_;
	ValaUnresolvedSymbol* _tmp2_;
	ValaUnresolvedSymbol* _tmp3_;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (ns != NULL);
	_tmp0_ = vala_using_directive_get_namespace_symbol (ns);
	_tmp1_ = _tmp0_;
	_tmp2_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, VALA_TYPE_UNRESOLVED_SYMBOL) ? ((ValaUnresolvedSymbol*) _tmp1_) : NULL);
	unresolved_symbol = _tmp2_;
	_tmp3_ = unresolved_symbol;
	if (_tmp3_ != NULL) {
		ValaUnresolvedSymbol* _tmp4_;
		ValaSymbol* _tmp5_;
		ValaSymbol* _tmp6_;
		ValaSymbol* _tmp7_;
		ValaSymbol* _tmp8_;
		_tmp4_ = unresolved_symbol;
		_tmp5_ = vala_symbol_resolver_resolve_symbol (self, _tmp4_);
		_tmp6_ = _tmp5_;
		vala_using_directive_set_namespace_symbol (ns, _tmp6_);
		_vala_code_node_unref0 (_tmp6_);
		_tmp7_ = vala_using_directive_get_namespace_symbol (ns);
		_tmp8_ = _tmp7_;
		if (!G_TYPE_CHECK_INSTANCE_TYPE (_tmp8_, VALA_TYPE_NAMESPACE)) {
			ValaSourceReference* _tmp9_;
			ValaSourceReference* _tmp10_;
			ValaUnresolvedSymbol* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
			vala_code_node_set_error ((ValaCodeNode*) ns, TRUE);
			_tmp9_ = vala_code_node_get_source_reference ((ValaCodeNode*) ns);
			_tmp10_ = _tmp9_;
			_tmp11_ = unresolved_symbol;
			_tmp12_ = vala_code_node_to_string ((ValaCodeNode*) _tmp11_);
			_tmp13_ = _tmp12_;
			_tmp14_ = g_strdup_printf ("The namespace name `%s' could not be found", _tmp13_);
			_tmp15_ = _tmp14_;
			vala_report_error (_tmp10_, _tmp15_);
			_g_free0 (_tmp15_);
			_g_free0 (_tmp13_);
			_vala_code_node_unref0 (unresolved_symbol);
			return;
		}
	}
	_vala_code_node_unref0 (unresolved_symbol);
}


static gpointer
_vala_iterable_ref0 (gpointer self)
{
	return self ? vala_iterable_ref (self) : NULL;
}


static ValaSymbol*
vala_symbol_resolver_resolve_symbol (ValaSymbolResolver* self,
                                     ValaUnresolvedSymbol* unresolved_symbol)
{
	ValaSymbol* result = NULL;
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (unresolved_symbol != NULL, NULL);
	_tmp0_ = vala_unresolved_symbol_get_qualified (unresolved_symbol);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		ValaSymbol* _tmp2_;
		ValaScope* _tmp3_;
		ValaScope* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		ValaSymbol* _tmp7_;
		_tmp2_ = self->priv->root_symbol;
		_tmp3_ = vala_symbol_get_scope (_tmp2_);
		_tmp4_ = _tmp3_;
		_tmp5_ = vala_symbol_get_name ((ValaSymbol*) unresolved_symbol);
		_tmp6_ = _tmp5_;
		_tmp7_ = vala_scope_lookup (_tmp4_, _tmp6_);
		result = _tmp7_;
		return result;
	} else {
		ValaUnresolvedSymbol* _tmp8_;
		ValaUnresolvedSymbol* _tmp9_;
		_tmp8_ = vala_unresolved_symbol_get_inner (unresolved_symbol);
		_tmp9_ = _tmp8_;
		if (_tmp9_ == NULL) {
			ValaSymbol* sym = NULL;
			ValaScope* scope = NULL;
			ValaScope* _tmp10_;
			ValaScope* _tmp11_;
			gboolean _tmp28_ = FALSE;
			ValaSymbol* _tmp29_;
			sym = NULL;
			_tmp10_ = self->priv->current_scope;
			_tmp11_ = _vala_scope_ref0 (_tmp10_);
			scope = _tmp11_;
			while (TRUE) {
				gboolean _tmp12_ = FALSE;
				ValaSymbol* _tmp13_;
				ValaScope* _tmp15_;
				const gchar* _tmp16_;
				const gchar* _tmp17_;
				ValaSymbol* _tmp18_;
				gboolean _tmp19_ = FALSE;
				gboolean _tmp20_ = FALSE;
				ValaSymbol* _tmp21_;
				ValaScope* _tmp24_;
				ValaScope* _tmp25_;
				ValaScope* _tmp26_;
				ValaScope* _tmp27_;
				_tmp13_ = sym;
				if (_tmp13_ == NULL) {
					ValaScope* _tmp14_;
					_tmp14_ = scope;
					_tmp12_ = _tmp14_ != NULL;
				} else {
					_tmp12_ = FALSE;
				}
				if (!_tmp12_) {
					break;
				}
				_tmp15_ = scope;
				_tmp16_ = vala_symbol_get_name ((ValaSymbol*) unresolved_symbol);
				_tmp17_ = _tmp16_;
				_tmp18_ = vala_scope_lookup (_tmp15_, _tmp17_);
				_vala_code_node_unref0 (sym);
				sym = _tmp18_;
				_tmp21_ = sym;
				if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp21_, VALA_TYPE_NAMESPACE)) {
					_tmp20_ = TRUE;
				} else {
					ValaSymbol* _tmp22_;
					_tmp22_ = sym;
					_tmp20_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp22_, VALA_TYPE_TYPESYMBOL);
				}
				if (_tmp20_) {
					_tmp19_ = TRUE;
				} else {
					ValaSymbol* _tmp23_;
					_tmp23_ = sym;
					_tmp19_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp23_, VALA_TYPE_TYPEPARAMETER);
				}
				if (!_tmp19_) {
					_vala_code_node_unref0 (sym);
					sym = NULL;
				}
				_tmp24_ = scope;
				_tmp25_ = vala_scope_get_parent_scope (_tmp24_);
				_tmp26_ = _tmp25_;
				_tmp27_ = _vala_scope_ref0 (_tmp26_);
				_vala_scope_unref0 (scope);
				scope = _tmp27_;
			}
			_tmp29_ = sym;
			if (_tmp29_ == NULL) {
				ValaSourceReference* _tmp30_;
				ValaSourceReference* _tmp31_;
				_tmp30_ = vala_code_node_get_source_reference ((ValaCodeNode*) unresolved_symbol);
				_tmp31_ = _tmp30_;
				_tmp28_ = _tmp31_ != NULL;
			} else {
				_tmp28_ = FALSE;
			}
			if (_tmp28_) {
				{
					ValaList* _ns_list = NULL;
					ValaSourceReference* _tmp32_;
					ValaSourceReference* _tmp33_;
					ValaList* _tmp34_;
					ValaList* _tmp35_;
					ValaList* _tmp36_;
					gint _ns_size = 0;
					ValaList* _tmp37_;
					gint _tmp38_;
					gint _tmp39_;
					gint _ns_index = 0;
					_tmp32_ = vala_code_node_get_source_reference ((ValaCodeNode*) unresolved_symbol);
					_tmp33_ = _tmp32_;
					_tmp34_ = vala_source_reference_get_using_directives (_tmp33_);
					_tmp35_ = _tmp34_;
					_tmp36_ = _vala_iterable_ref0 (_tmp35_);
					_ns_list = _tmp36_;
					_tmp37_ = _ns_list;
					_tmp38_ = vala_collection_get_size ((ValaCollection*) _tmp37_);
					_tmp39_ = _tmp38_;
					_ns_size = _tmp39_;
					_ns_index = -1;
					while (TRUE) {
						gint _tmp40_;
						gint _tmp41_;
						gint _tmp42_;
						ValaUsingDirective* ns = NULL;
						ValaList* _tmp43_;
						gint _tmp44_;
						gpointer _tmp45_;
						gboolean _tmp46_ = FALSE;
						ValaUsingDirective* _tmp47_;
						gboolean _tmp48_;
						gboolean _tmp49_;
						ValaSymbol* local_sym = NULL;
						ValaUsingDirective* _tmp53_;
						ValaSymbol* _tmp54_;
						ValaSymbol* _tmp55_;
						ValaScope* _tmp56_;
						ValaScope* _tmp57_;
						const gchar* _tmp58_;
						const gchar* _tmp59_;
						ValaSymbol* _tmp60_;
						gboolean _tmp61_ = FALSE;
						gboolean _tmp62_ = FALSE;
						ValaSymbol* _tmp63_;
						ValaSymbol* _tmp66_;
						_tmp40_ = _ns_index;
						_ns_index = _tmp40_ + 1;
						_tmp41_ = _ns_index;
						_tmp42_ = _ns_size;
						if (!(_tmp41_ < _tmp42_)) {
							break;
						}
						_tmp43_ = _ns_list;
						_tmp44_ = _ns_index;
						_tmp45_ = vala_list_get (_tmp43_, _tmp44_);
						ns = (ValaUsingDirective*) _tmp45_;
						_tmp47_ = ns;
						_tmp48_ = vala_code_node_get_error ((ValaCodeNode*) _tmp47_);
						_tmp49_ = _tmp48_;
						if (_tmp49_) {
							_tmp46_ = TRUE;
						} else {
							ValaUsingDirective* _tmp50_;
							ValaSymbol* _tmp51_;
							ValaSymbol* _tmp52_;
							_tmp50_ = ns;
							_tmp51_ = vala_using_directive_get_namespace_symbol (_tmp50_);
							_tmp52_ = _tmp51_;
							_tmp46_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp52_, VALA_TYPE_UNRESOLVED_SYMBOL);
						}
						if (_tmp46_) {
							_vala_code_node_unref0 (ns);
							continue;
						}
						_tmp53_ = ns;
						_tmp54_ = vala_using_directive_get_namespace_symbol (_tmp53_);
						_tmp55_ = _tmp54_;
						_tmp56_ = vala_symbol_get_scope (_tmp55_);
						_tmp57_ = _tmp56_;
						_tmp58_ = vala_symbol_get_name ((ValaSymbol*) unresolved_symbol);
						_tmp59_ = _tmp58_;
						_tmp60_ = vala_scope_lookup (_tmp57_, _tmp59_);
						local_sym = _tmp60_;
						_tmp63_ = local_sym;
						if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp63_, VALA_TYPE_NAMESPACE)) {
							_tmp62_ = TRUE;
						} else {
							ValaSymbol* _tmp64_;
							_tmp64_ = local_sym;
							_tmp62_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp64_, VALA_TYPE_TYPESYMBOL);
						}
						if (_tmp62_) {
							_tmp61_ = TRUE;
						} else {
							ValaSymbol* _tmp65_;
							_tmp65_ = sym;
							_tmp61_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp65_, VALA_TYPE_TYPEPARAMETER);
						}
						if (!_tmp61_) {
							_vala_code_node_unref0 (local_sym);
							local_sym = NULL;
						}
						_tmp66_ = local_sym;
						if (_tmp66_ != NULL) {
							gboolean _tmp67_ = FALSE;
							ValaSymbol* _tmp68_;
							ValaSymbol* _tmp83_;
							ValaSymbol* _tmp84_;
							_tmp68_ = sym;
							if (_tmp68_ != NULL) {
								ValaSymbol* _tmp69_;
								ValaSymbol* _tmp70_;
								_tmp69_ = sym;
								_tmp70_ = local_sym;
								_tmp67_ = _tmp69_ != _tmp70_;
							} else {
								_tmp67_ = FALSE;
							}
							if (_tmp67_) {
								ValaSourceReference* _tmp71_;
								ValaSourceReference* _tmp72_;
								const gchar* _tmp73_;
								const gchar* _tmp74_;
								ValaSymbol* _tmp75_;
								gchar* _tmp76_;
								gchar* _tmp77_;
								ValaSymbol* _tmp78_;
								gchar* _tmp79_;
								gchar* _tmp80_;
								gchar* _tmp81_;
								gchar* _tmp82_;
								vala_code_node_set_error ((ValaCodeNode*) unresolved_symbol, TRUE);
								_tmp71_ = vala_code_node_get_source_reference ((ValaCodeNode*) unresolved_symbol);
								_tmp72_ = _tmp71_;
								_tmp73_ = vala_symbol_get_name ((ValaSymbol*) unresolved_symbol);
								_tmp74_ = _tmp73_;
								_tmp75_ = sym;
								_tmp76_ = vala_symbol_get_full_name (_tmp75_);
								_tmp77_ = _tmp76_;
								_tmp78_ = local_sym;
								_tmp79_ = vala_symbol_get_full_name (_tmp78_);
								_tmp80_ = _tmp79_;
								_tmp81_ = g_strdup_printf ("`%s' is an ambiguous reference between `%s' and `%s'", _tmp74_, _tmp77_, _tmp80_);
								_tmp82_ = _tmp81_;
								vala_report_error (_tmp72_, _tmp82_);
								_g_free0 (_tmp82_);
								_g_free0 (_tmp80_);
								_g_free0 (_tmp77_);
								result = NULL;
								_vala_code_node_unref0 (local_sym);
								_vala_code_node_unref0 (ns);
								_vala_iterable_unref0 (_ns_list);
								_vala_scope_unref0 (scope);
								_vala_code_node_unref0 (sym);
								return result;
							}
							_tmp83_ = local_sym;
							_tmp84_ = _vala_code_node_ref0 (_tmp83_);
							_vala_code_node_unref0 (sym);
							sym = _tmp84_;
						}
						_vala_code_node_unref0 (local_sym);
						_vala_code_node_unref0 (ns);
					}
					_vala_iterable_unref0 (_ns_list);
				}
			}
			result = sym;
			_vala_scope_unref0 (scope);
			return result;
		} else {
			ValaSymbol* parent_symbol = NULL;
			ValaUnresolvedSymbol* _tmp85_;
			ValaUnresolvedSymbol* _tmp86_;
			ValaSymbol* _tmp87_;
			ValaSymbol* _tmp88_;
			ValaSymbol* _tmp99_;
			ValaSymbol* _tmp100_;
			ValaScope* _tmp101_;
			ValaScope* _tmp102_;
			const gchar* _tmp103_;
			const gchar* _tmp104_;
			ValaSymbol* _tmp105_;
			_tmp85_ = vala_unresolved_symbol_get_inner (unresolved_symbol);
			_tmp86_ = _tmp85_;
			_tmp87_ = vala_symbol_resolver_resolve_symbol (self, _tmp86_);
			parent_symbol = _tmp87_;
			_tmp88_ = parent_symbol;
			if (_tmp88_ == NULL) {
				ValaUnresolvedSymbol* _tmp89_;
				ValaUnresolvedSymbol* _tmp90_;
				ValaSourceReference* _tmp91_;
				ValaSourceReference* _tmp92_;
				ValaUnresolvedSymbol* _tmp93_;
				ValaUnresolvedSymbol* _tmp94_;
				const gchar* _tmp95_;
				const gchar* _tmp96_;
				gchar* _tmp97_;
				gchar* _tmp98_;
				vala_code_node_set_error ((ValaCodeNode*) unresolved_symbol, TRUE);
				_tmp89_ = vala_unresolved_symbol_get_inner (unresolved_symbol);
				_tmp90_ = _tmp89_;
				_tmp91_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp90_);
				_tmp92_ = _tmp91_;
				_tmp93_ = vala_unresolved_symbol_get_inner (unresolved_symbol);
				_tmp94_ = _tmp93_;
				_tmp95_ = vala_symbol_get_name ((ValaSymbol*) _tmp94_);
				_tmp96_ = _tmp95_;
				_tmp97_ = g_strdup_printf ("The symbol `%s' could not be found", _tmp96_);
				_tmp98_ = _tmp97_;
				vala_report_error (_tmp92_, _tmp98_);
				_g_free0 (_tmp98_);
				result = NULL;
				_vala_code_node_unref0 (parent_symbol);
				return result;
			}
			_tmp99_ = parent_symbol;
			vala_symbol_set_used (_tmp99_, TRUE);
			_tmp100_ = parent_symbol;
			_tmp101_ = vala_symbol_get_scope (_tmp100_);
			_tmp102_ = _tmp101_;
			_tmp103_ = vala_symbol_get_name ((ValaSymbol*) unresolved_symbol);
			_tmp104_ = _tmp103_;
			_tmp105_ = vala_scope_lookup (_tmp102_, _tmp104_);
			result = _tmp105_;
			_vala_code_node_unref0 (parent_symbol);
			return result;
		}
	}
}


static ValaDataType*
vala_symbol_resolver_get_type_for_struct (ValaSymbolResolver* self,
                                          ValaStruct* st,
                                          ValaStruct* base_struct)
{
	ValaDataType* result = NULL;
	ValaDataType* _tmp0_;
	ValaDataType* _tmp1_;
	ValaStruct* _tmp15_;
	ValaStruct* _tmp16_;
	ValaAttribute* _tmp20_;
	ValaAttribute* _tmp21_;
	gboolean _tmp22_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (st != NULL, NULL);
	g_return_val_if_fail (base_struct != NULL, NULL);
	_tmp0_ = vala_struct_get_base_type (st);
	_tmp1_ = _tmp0_;
	if (_tmp1_ != NULL) {
		ValaScope* _tmp2_;
		ValaScope* _tmp3_;
		ValaScope* _tmp4_;
		ValaScope* old_scope = NULL;
		ValaScope* _tmp6_;
		ValaScope* _tmp7_;
		ValaScope* _tmp8_;
		ValaScope* _tmp9_;
		ValaScope* _tmp10_;
		ValaDataType* _tmp11_;
		ValaDataType* _tmp12_;
		ValaScope* _tmp13_;
		ValaScope* _tmp14_;
		_tmp2_ = self->priv->current_scope;
		_tmp3_ = vala_symbol_get_scope ((ValaSymbol*) st);
		_tmp4_ = _tmp3_;
		if (_tmp2_ == _tmp4_) {
			ValaStructValueType* _tmp5_;
			_tmp5_ = vala_struct_value_type_new (st);
			result = (ValaDataType*) _tmp5_;
			return result;
		}
		_tmp6_ = self->priv->current_scope;
		_tmp7_ = _vala_scope_ref0 (_tmp6_);
		old_scope = _tmp7_;
		_tmp8_ = vala_symbol_get_scope ((ValaSymbol*) st);
		_tmp9_ = _tmp8_;
		_tmp10_ = _vala_scope_ref0 (_tmp9_);
		_vala_scope_unref0 (self->priv->current_scope);
		self->priv->current_scope = _tmp10_;
		_tmp11_ = vala_struct_get_base_type (st);
		_tmp12_ = _tmp11_;
		vala_code_node_accept ((ValaCodeNode*) _tmp12_, (ValaCodeVisitor*) self);
		_tmp13_ = old_scope;
		_tmp14_ = _vala_scope_ref0 (_tmp13_);
		_vala_scope_unref0 (self->priv->current_scope);
		self->priv->current_scope = _tmp14_;
		_vala_scope_unref0 (old_scope);
	}
	_tmp15_ = vala_struct_get_base_struct (base_struct);
	_tmp16_ = _tmp15_;
	if (_tmp16_ != NULL) {
		ValaStruct* _tmp17_;
		ValaStruct* _tmp18_;
		ValaDataType* _tmp19_;
		_tmp17_ = vala_struct_get_base_struct (base_struct);
		_tmp18_ = _tmp17_;
		_tmp19_ = vala_symbol_resolver_get_type_for_struct (self, st, _tmp18_);
		result = _tmp19_;
		return result;
	}
	_tmp20_ = vala_code_node_get_attribute ((ValaCodeNode*) base_struct, "BooleanType");
	_tmp21_ = _tmp20_;
	_tmp22_ = _tmp21_ != NULL;
	_vala_code_node_unref0 (_tmp21_);
	if (_tmp22_) {
		ValaBooleanType* _tmp23_;
		_tmp23_ = vala_boolean_type_new (st);
		result = (ValaDataType*) _tmp23_;
		return result;
	} else {
		ValaAttribute* _tmp24_;
		ValaAttribute* _tmp25_;
		gboolean _tmp26_;
		_tmp24_ = vala_code_node_get_attribute ((ValaCodeNode*) base_struct, "IntegerType");
		_tmp25_ = _tmp24_;
		_tmp26_ = _tmp25_ != NULL;
		_vala_code_node_unref0 (_tmp25_);
		if (_tmp26_) {
			ValaIntegerType* _tmp27_;
			_tmp27_ = vala_integer_type_new (st, NULL, NULL);
			result = (ValaDataType*) _tmp27_;
			return result;
		} else {
			ValaAttribute* _tmp28_;
			ValaAttribute* _tmp29_;
			gboolean _tmp30_;
			_tmp28_ = vala_code_node_get_attribute ((ValaCodeNode*) base_struct, "FloatingType");
			_tmp29_ = _tmp28_;
			_tmp30_ = _tmp29_ != NULL;
			_vala_code_node_unref0 (_tmp29_);
			if (_tmp30_) {
				ValaFloatingType* _tmp31_;
				_tmp31_ = vala_floating_type_new (st);
				result = (ValaDataType*) _tmp31_;
				return result;
			} else {
				ValaStructValueType* _tmp32_;
				_tmp32_ = vala_struct_value_type_new (st);
				result = (ValaDataType*) _tmp32_;
				return result;
			}
		}
	}
}


static ValaDataType*
vala_symbol_resolver_resolve_type (ValaSymbolResolver* self,
                                   ValaUnresolvedType* unresolved_type)
{
	ValaDataType* result = NULL;
	ValaDataType* type = NULL;
	ValaUnresolvedSymbol* _tmp0_;
	ValaUnresolvedSymbol* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	ValaSymbol* sym = NULL;
	ValaUnresolvedSymbol* _tmp5_;
	ValaUnresolvedSymbol* _tmp6_;
	ValaSymbol* _tmp7_;
	ValaSymbol* _tmp8_;
	ValaSymbol* _tmp22_;
	ValaDataType* _tmp79_;
	ValaSourceReference* _tmp80_;
	ValaSourceReference* _tmp81_;
	ValaDataType* _tmp82_;
	gboolean _tmp83_;
	gboolean _tmp84_;
	ValaSymbol* _tmp85_;
	ValaDataType* _tmp86_;
	ValaDataType* _tmp91_;
	gboolean _tmp92_;
	gboolean _tmp93_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (unresolved_type != NULL, NULL);
	type = NULL;
	_tmp0_ = vala_unresolved_type_get_unresolved_symbol (unresolved_type);
	_tmp1_ = _tmp0_;
	_tmp2_ = vala_symbol_get_name ((ValaSymbol*) _tmp1_);
	_tmp3_ = _tmp2_;
	if (g_strcmp0 (_tmp3_, "void") == 0) {
		ValaVoidType* _tmp4_;
		_tmp4_ = vala_void_type_new (NULL);
		result = (ValaDataType*) _tmp4_;
		_vala_code_node_unref0 (type);
		return result;
	}
	_tmp5_ = vala_unresolved_type_get_unresolved_symbol (unresolved_type);
	_tmp6_ = _tmp5_;
	_tmp7_ = vala_symbol_resolver_resolve_symbol (self, _tmp6_);
	sym = _tmp7_;
	_tmp8_ = sym;
	if (_tmp8_ == NULL) {
		ValaUnresolvedSymbol* _tmp9_;
		ValaUnresolvedSymbol* _tmp10_;
		gboolean _tmp11_;
		gboolean _tmp12_;
		ValaInvalidType* _tmp21_;
		_tmp9_ = vala_unresolved_type_get_unresolved_symbol (unresolved_type);
		_tmp10_ = _tmp9_;
		_tmp11_ = vala_code_node_get_error ((ValaCodeNode*) _tmp10_);
		_tmp12_ = _tmp11_;
		if (!_tmp12_) {
			ValaSourceReference* _tmp13_;
			ValaSourceReference* _tmp14_;
			ValaUnresolvedSymbol* _tmp15_;
			ValaUnresolvedSymbol* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
			gchar* _tmp20_;
			_tmp13_ = vala_code_node_get_source_reference ((ValaCodeNode*) unresolved_type);
			_tmp14_ = _tmp13_;
			_tmp15_ = vala_unresolved_type_get_unresolved_symbol (unresolved_type);
			_tmp16_ = _tmp15_;
			_tmp17_ = vala_code_node_to_string ((ValaCodeNode*) _tmp16_);
			_tmp18_ = _tmp17_;
			_tmp19_ = g_strdup_printf ("The type name `%s' could not be found", _tmp18_);
			_tmp20_ = _tmp19_;
			vala_report_error (_tmp14_, _tmp20_);
			_g_free0 (_tmp20_);
			_g_free0 (_tmp18_);
		}
		_tmp21_ = vala_invalid_type_new ();
		result = (ValaDataType*) _tmp21_;
		_vala_code_node_unref0 (sym);
		_vala_code_node_unref0 (type);
		return result;
	}
	_tmp22_ = sym;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp22_, VALA_TYPE_TYPEPARAMETER)) {
		ValaSymbol* _tmp23_;
		ValaGenericType* _tmp24_;
		_tmp23_ = sym;
		_tmp24_ = vala_generic_type_new (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, VALA_TYPE_TYPEPARAMETER, ValaTypeParameter));
		_vala_code_node_unref0 (type);
		type = (ValaDataType*) _tmp24_;
	} else {
		ValaSymbol* _tmp25_;
		_tmp25_ = sym;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp25_, VALA_TYPE_TYPESYMBOL)) {
			ValaSymbol* _tmp26_;
			_tmp26_ = sym;
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp26_, VALA_TYPE_DELEGATE)) {
				ValaSymbol* _tmp27_;
				ValaDelegateType* _tmp28_;
				_tmp27_ = sym;
				_tmp28_ = vala_delegate_type_new (G_TYPE_CHECK_INSTANCE_CAST (_tmp27_, VALA_TYPE_DELEGATE, ValaDelegate));
				_vala_code_node_unref0 (type);
				type = (ValaDataType*) _tmp28_;
			} else {
				ValaSymbol* _tmp29_;
				_tmp29_ = sym;
				if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp29_, VALA_TYPE_CLASS)) {
					ValaClass* cl = NULL;
					ValaSymbol* _tmp30_;
					ValaClass* _tmp31_;
					ValaClass* _tmp32_;
					gboolean _tmp33_;
					gboolean _tmp34_;
					_tmp30_ = sym;
					_tmp31_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, VALA_TYPE_CLASS, ValaClass));
					cl = _tmp31_;
					_tmp32_ = cl;
					_tmp33_ = vala_class_get_is_error_base (_tmp32_);
					_tmp34_ = _tmp33_;
					if (_tmp34_) {
						ValaSourceReference* _tmp35_;
						ValaSourceReference* _tmp36_;
						ValaErrorType* _tmp37_;
						_tmp35_ = vala_code_node_get_source_reference ((ValaCodeNode*) unresolved_type);
						_tmp36_ = _tmp35_;
						_tmp37_ = vala_error_type_new (NULL, NULL, _tmp36_);
						_vala_code_node_unref0 (type);
						type = (ValaDataType*) _tmp37_;
					} else {
						ValaClass* _tmp38_;
						ValaObjectType* _tmp39_;
						_tmp38_ = cl;
						_tmp39_ = vala_object_type_new ((ValaObjectTypeSymbol*) _tmp38_);
						_vala_code_node_unref0 (type);
						type = (ValaDataType*) _tmp39_;
					}
					_vala_code_node_unref0 (cl);
				} else {
					ValaSymbol* _tmp40_;
					_tmp40_ = sym;
					if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp40_, VALA_TYPE_INTERFACE)) {
						ValaSymbol* _tmp41_;
						ValaObjectType* _tmp42_;
						_tmp41_ = sym;
						_tmp42_ = vala_object_type_new ((ValaObjectTypeSymbol*) G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, VALA_TYPE_INTERFACE, ValaInterface));
						_vala_code_node_unref0 (type);
						type = (ValaDataType*) _tmp42_;
					} else {
						ValaSymbol* _tmp43_;
						_tmp43_ = sym;
						if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp43_, VALA_TYPE_STRUCT)) {
							ValaSymbol* _tmp44_;
							ValaSymbol* _tmp45_;
							ValaDataType* _tmp46_;
							_tmp44_ = sym;
							_tmp45_ = sym;
							_tmp46_ = vala_symbol_resolver_get_type_for_struct (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp44_, VALA_TYPE_STRUCT, ValaStruct), G_TYPE_CHECK_INSTANCE_CAST (_tmp45_, VALA_TYPE_STRUCT, ValaStruct));
							_vala_code_node_unref0 (type);
							type = _tmp46_;
						} else {
							ValaSymbol* _tmp47_;
							_tmp47_ = sym;
							if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp47_, VALA_TYPE_ENUM)) {
								ValaSymbol* _tmp48_;
								ValaEnumValueType* _tmp49_;
								_tmp48_ = sym;
								_tmp49_ = vala_enum_value_type_new (G_TYPE_CHECK_INSTANCE_CAST (_tmp48_, VALA_TYPE_ENUM, ValaEnum));
								_vala_code_node_unref0 (type);
								type = (ValaDataType*) _tmp49_;
							} else {
								ValaSymbol* _tmp50_;
								_tmp50_ = sym;
								if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp50_, VALA_TYPE_ERROR_DOMAIN)) {
									ValaSymbol* _tmp51_;
									ValaSourceReference* _tmp52_;
									ValaSourceReference* _tmp53_;
									ValaErrorType* _tmp54_;
									_tmp51_ = sym;
									_tmp52_ = vala_code_node_get_source_reference ((ValaCodeNode*) unresolved_type);
									_tmp53_ = _tmp52_;
									_tmp54_ = vala_error_type_new (G_TYPE_CHECK_INSTANCE_CAST (_tmp51_, VALA_TYPE_ERROR_DOMAIN, ValaErrorDomain), NULL, _tmp53_);
									_vala_code_node_unref0 (type);
									type = (ValaDataType*) _tmp54_;
								} else {
									ValaSymbol* _tmp55_;
									_tmp55_ = sym;
									if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp55_, VALA_TYPE_ERROR_CODE)) {
										ValaSymbol* _tmp56_;
										ValaSymbol* _tmp57_;
										ValaSymbol* _tmp58_;
										ValaSymbol* _tmp59_;
										ValaSourceReference* _tmp60_;
										ValaSourceReference* _tmp61_;
										ValaErrorType* _tmp62_;
										_tmp56_ = sym;
										_tmp57_ = vala_symbol_get_parent_symbol (_tmp56_);
										_tmp58_ = _tmp57_;
										_tmp59_ = sym;
										_tmp60_ = vala_code_node_get_source_reference ((ValaCodeNode*) unresolved_type);
										_tmp61_ = _tmp60_;
										_tmp62_ = vala_error_type_new (G_TYPE_CHECK_INSTANCE_CAST (_tmp58_, VALA_TYPE_ERROR_DOMAIN, ValaErrorDomain), G_TYPE_CHECK_INSTANCE_CAST (_tmp59_, VALA_TYPE_ERROR_CODE, ValaErrorCode), _tmp61_);
										_vala_code_node_unref0 (type);
										type = (ValaDataType*) _tmp62_;
									} else {
										ValaSourceReference* _tmp63_;
										ValaSourceReference* _tmp64_;
										ValaSymbol* _tmp65_;
										gchar* _tmp66_;
										gchar* _tmp67_;
										gchar* _tmp68_;
										gchar* _tmp69_;
										ValaInvalidType* _tmp70_;
										_tmp63_ = vala_code_node_get_source_reference ((ValaCodeNode*) unresolved_type);
										_tmp64_ = _tmp63_;
										_tmp65_ = sym;
										_tmp66_ = vala_symbol_get_full_name (_tmp65_);
										_tmp67_ = _tmp66_;
										_tmp68_ = g_strdup_printf ("internal error: `%s' is not a supported type", _tmp67_);
										_tmp69_ = _tmp68_;
										vala_report_error (_tmp64_, _tmp69_);
										_g_free0 (_tmp69_);
										_g_free0 (_tmp67_);
										_tmp70_ = vala_invalid_type_new ();
										result = (ValaDataType*) _tmp70_;
										_vala_code_node_unref0 (sym);
										_vala_code_node_unref0 (type);
										return result;
									}
								}
							}
						}
					}
				}
			}
		} else {
			ValaSourceReference* _tmp71_;
			ValaSourceReference* _tmp72_;
			ValaSymbol* _tmp73_;
			gchar* _tmp74_;
			gchar* _tmp75_;
			gchar* _tmp76_;
			gchar* _tmp77_;
			ValaInvalidType* _tmp78_;
			_tmp71_ = vala_code_node_get_source_reference ((ValaCodeNode*) unresolved_type);
			_tmp72_ = _tmp71_;
			_tmp73_ = sym;
			_tmp74_ = vala_symbol_get_full_name (_tmp73_);
			_tmp75_ = _tmp74_;
			_tmp76_ = g_strdup_printf ("`%s' is not a type", _tmp75_);
			_tmp77_ = _tmp76_;
			vala_report_error (_tmp72_, _tmp77_);
			_g_free0 (_tmp77_);
			_g_free0 (_tmp75_);
			_tmp78_ = vala_invalid_type_new ();
			result = (ValaDataType*) _tmp78_;
			_vala_code_node_unref0 (sym);
			_vala_code_node_unref0 (type);
			return result;
		}
	}
	_tmp79_ = type;
	_tmp80_ = vala_code_node_get_source_reference ((ValaCodeNode*) unresolved_type);
	_tmp81_ = _tmp80_;
	vala_code_node_set_source_reference ((ValaCodeNode*) _tmp79_, _tmp81_);
	_tmp82_ = type;
	_tmp83_ = vala_data_type_get_value_owned ((ValaDataType*) unresolved_type);
	_tmp84_ = _tmp83_;
	vala_data_type_set_value_owned (_tmp82_, _tmp84_);
	_tmp85_ = sym;
	vala_symbol_set_used (_tmp85_, TRUE);
	_tmp86_ = type;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp86_, VALA_TYPE_GENERIC_TYPE)) {
		ValaDataType* _tmp87_;
		_tmp87_ = type;
		vala_data_type_set_nullable (_tmp87_, TRUE);
	} else {
		ValaDataType* _tmp88_;
		gboolean _tmp89_;
		gboolean _tmp90_;
		_tmp88_ = type;
		_tmp89_ = vala_data_type_get_nullable ((ValaDataType*) unresolved_type);
		_tmp90_ = _tmp89_;
		vala_data_type_set_nullable (_tmp88_, _tmp90_);
	}
	_tmp91_ = type;
	_tmp92_ = vala_data_type_get_is_dynamic ((ValaDataType*) unresolved_type);
	_tmp93_ = _tmp92_;
	vala_data_type_set_is_dynamic (_tmp91_, _tmp93_);
	{
		ValaList* _type_arg_list = NULL;
		ValaList* _tmp94_;
		gint _type_arg_size = 0;
		ValaList* _tmp95_;
		gint _tmp96_;
		gint _tmp97_;
		gint _type_arg_index = 0;
		_tmp94_ = vala_data_type_get_type_arguments ((ValaDataType*) unresolved_type);
		_type_arg_list = _tmp94_;
		_tmp95_ = _type_arg_list;
		_tmp96_ = vala_collection_get_size ((ValaCollection*) _tmp95_);
		_tmp97_ = _tmp96_;
		_type_arg_size = _tmp97_;
		_type_arg_index = -1;
		while (TRUE) {
			gint _tmp98_;
			gint _tmp99_;
			gint _tmp100_;
			ValaDataType* type_arg = NULL;
			ValaList* _tmp101_;
			gint _tmp102_;
			gpointer _tmp103_;
			ValaDataType* _tmp104_;
			ValaDataType* _tmp105_;
			_tmp98_ = _type_arg_index;
			_type_arg_index = _tmp98_ + 1;
			_tmp99_ = _type_arg_index;
			_tmp100_ = _type_arg_size;
			if (!(_tmp99_ < _tmp100_)) {
				break;
			}
			_tmp101_ = _type_arg_list;
			_tmp102_ = _type_arg_index;
			_tmp103_ = vala_list_get (_tmp101_, _tmp102_);
			type_arg = (ValaDataType*) _tmp103_;
			_tmp104_ = type;
			_tmp105_ = type_arg;
			vala_data_type_add_type_argument (_tmp104_, _tmp105_);
			_vala_code_node_unref0 (type_arg);
		}
		_vala_iterable_unref0 (_type_arg_list);
	}
	result = type;
	_vala_code_node_unref0 (sym);
	return result;
}


static void
vala_symbol_resolver_real_visit_data_type (ValaCodeVisitor* base,
                                           ValaDataType* data_type)
{
	ValaSymbolResolver * self;
	ValaUnresolvedType* unresolved_type = NULL;
	ValaUnresolvedType* _tmp0_;
	ValaUnresolvedType* _tmp1_;
	ValaCodeNode* _tmp2_;
	ValaCodeNode* _tmp3_;
	ValaUnresolvedType* _tmp4_;
	ValaUnresolvedType* _tmp5_;
	ValaDataType* _tmp6_;
	ValaDataType* _tmp7_;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (data_type != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) data_type, (ValaCodeVisitor*) self);
	if (!G_TYPE_CHECK_INSTANCE_TYPE (data_type, VALA_TYPE_UNRESOLVED_TYPE)) {
		return;
	}
	_tmp0_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (data_type, VALA_TYPE_UNRESOLVED_TYPE, ValaUnresolvedType));
	unresolved_type = _tmp0_;
	_tmp1_ = unresolved_type;
	_tmp2_ = vala_code_node_get_parent_node ((ValaCodeNode*) _tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = unresolved_type;
	_tmp5_ = unresolved_type;
	_tmp6_ = vala_symbol_resolver_resolve_type (self, _tmp5_);
	_tmp7_ = _tmp6_;
	vala_code_node_replace_type (_tmp3_, (ValaDataType*) _tmp4_, _tmp7_);
	_vala_code_node_unref0 (_tmp7_);
	_vala_code_node_unref0 (unresolved_type);
}


static void
vala_symbol_resolver_real_visit_declaration_statement (ValaCodeVisitor* base,
                                                       ValaDeclarationStatement* stmt)
{
	ValaSymbolResolver * self;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}


static void
vala_symbol_resolver_real_visit_local_variable (ValaCodeVisitor* base,
                                                ValaLocalVariable* local)
{
	ValaSymbolResolver * self;
	ValaCodeContext* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (local != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) local, (ValaCodeVisitor*) self);
	_tmp0_ = self->priv->context;
	_tmp1_ = vala_code_context_get_experimental_non_null (_tmp0_);
	_tmp2_ = _tmp1_;
	if (!_tmp2_) {
		ValaDataType* _tmp3_;
		ValaDataType* _tmp4_;
		_tmp3_ = vala_variable_get_variable_type ((ValaVariable*) local);
		_tmp4_ = _tmp3_;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp4_, VALA_TYPE_REFERENCE_TYPE)) {
			ValaArrayType* array_type = NULL;
			ValaDataType* _tmp5_;
			ValaDataType* _tmp6_;
			ValaArrayType* _tmp7_;
			gboolean _tmp8_ = FALSE;
			ValaArrayType* _tmp9_;
			_tmp5_ = vala_variable_get_variable_type ((ValaVariable*) local);
			_tmp6_ = _tmp5_;
			_tmp7_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp6_, VALA_TYPE_ARRAY_TYPE) ? ((ValaArrayType*) _tmp6_) : NULL);
			array_type = _tmp7_;
			_tmp9_ = array_type;
			if (_tmp9_ != NULL) {
				ValaArrayType* _tmp10_;
				gboolean _tmp11_;
				gboolean _tmp12_;
				_tmp10_ = array_type;
				_tmp11_ = vala_array_type_get_fixed_length (_tmp10_);
				_tmp12_ = _tmp11_;
				_tmp8_ = _tmp12_;
			} else {
				_tmp8_ = FALSE;
			}
			if (_tmp8_) {
			} else {
				ValaDataType* _tmp13_;
				ValaDataType* _tmp14_;
				_tmp13_ = vala_variable_get_variable_type ((ValaVariable*) local);
				_tmp14_ = _tmp13_;
				vala_data_type_set_nullable (_tmp14_, TRUE);
			}
			_vala_code_node_unref0 (array_type);
		}
	}
}


static void
vala_symbol_resolver_real_visit_initializer_list (ValaCodeVisitor* base,
                                                  ValaInitializerList* list)
{
	ValaSymbolResolver * self;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (list != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) list, (ValaCodeVisitor*) self);
}


static void
vala_symbol_resolver_real_visit_expression_statement (ValaCodeVisitor* base,
                                                      ValaExpressionStatement* stmt)
{
	ValaSymbolResolver * self;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}


static void
vala_symbol_resolver_real_visit_if_statement (ValaCodeVisitor* base,
                                              ValaIfStatement* stmt)
{
	ValaSymbolResolver * self;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}


static void
vala_symbol_resolver_real_visit_switch_statement (ValaCodeVisitor* base,
                                                  ValaSwitchStatement* stmt)
{
	ValaSymbolResolver * self;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}


static void
vala_symbol_resolver_real_visit_switch_section (ValaCodeVisitor* base,
                                                ValaSwitchSection* section)
{
	ValaSymbolResolver * self;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (section != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) section, (ValaCodeVisitor*) self);
}


static void
vala_symbol_resolver_real_visit_switch_label (ValaCodeVisitor* base,
                                              ValaSwitchLabel* label)
{
	ValaSymbolResolver * self;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (label != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) label, (ValaCodeVisitor*) self);
}


static void
vala_symbol_resolver_real_visit_loop (ValaCodeVisitor* base,
                                      ValaLoop* stmt)
{
	ValaSymbolResolver * self;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}


static void
vala_symbol_resolver_real_visit_while_statement (ValaCodeVisitor* base,
                                                 ValaWhileStatement* stmt)
{
	ValaSymbolResolver * self;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}


static void
vala_symbol_resolver_real_visit_do_statement (ValaCodeVisitor* base,
                                              ValaDoStatement* stmt)
{
	ValaSymbolResolver * self;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}


static void
vala_symbol_resolver_real_visit_for_statement (ValaCodeVisitor* base,
                                               ValaForStatement* stmt)
{
	ValaSymbolResolver * self;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}


static void
vala_symbol_resolver_real_visit_foreach_statement (ValaCodeVisitor* base,
                                                   ValaForeachStatement* stmt)
{
	ValaSymbolResolver * self;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}


static void
vala_symbol_resolver_real_visit_return_statement (ValaCodeVisitor* base,
                                                  ValaReturnStatement* stmt)
{
	ValaSymbolResolver * self;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}


static void
vala_symbol_resolver_real_visit_yield_statement (ValaCodeVisitor* base,
                                                 ValaYieldStatement* stmt)
{
	ValaSymbolResolver * self;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}


static void
vala_symbol_resolver_real_visit_throw_statement (ValaCodeVisitor* base,
                                                 ValaThrowStatement* stmt)
{
	ValaSymbolResolver * self;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}


static void
vala_symbol_resolver_real_visit_try_statement (ValaCodeVisitor* base,
                                               ValaTryStatement* stmt)
{
	ValaSymbolResolver * self;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}


static void
vala_symbol_resolver_real_visit_delete_statement (ValaCodeVisitor* base,
                                                  ValaDeleteStatement* stmt)
{
	ValaSymbolResolver * self;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}


static void
vala_symbol_resolver_real_visit_catch_clause (ValaCodeVisitor* base,
                                              ValaCatchClause* clause)
{
	ValaSymbolResolver * self;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (clause != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) clause, (ValaCodeVisitor*) self);
}


static void
vala_symbol_resolver_real_visit_array_creation_expression (ValaCodeVisitor* base,
                                                           ValaArrayCreationExpression* e)
{
	ValaSymbolResolver * self;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (e != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) e, (ValaCodeVisitor*) self);
}


static void
vala_symbol_resolver_real_visit_template (ValaCodeVisitor* base,
                                          ValaTemplate* tmpl)
{
	ValaSymbolResolver * self;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (tmpl != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) tmpl, (ValaCodeVisitor*) self);
}


static void
vala_symbol_resolver_real_visit_tuple (ValaCodeVisitor* base,
                                       ValaTuple* tuple)
{
	ValaSymbolResolver * self;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (tuple != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) tuple, (ValaCodeVisitor*) self);
}


static void
vala_symbol_resolver_real_visit_member_access (ValaCodeVisitor* base,
                                               ValaMemberAccess* expr)
{
	ValaSymbolResolver * self;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (expr != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}


static void
vala_symbol_resolver_real_visit_method_call (ValaCodeVisitor* base,
                                             ValaMethodCall* expr)
{
	ValaSymbolResolver * self;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (expr != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}


static void
vala_symbol_resolver_real_visit_element_access (ValaCodeVisitor* base,
                                                ValaElementAccess* expr)
{
	ValaSymbolResolver * self;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (expr != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}


static void
vala_symbol_resolver_real_visit_slice_expression (ValaCodeVisitor* base,
                                                  ValaSliceExpression* expr)
{
	ValaSymbolResolver * self;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (expr != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}


static void
vala_symbol_resolver_real_visit_postfix_expression (ValaCodeVisitor* base,
                                                    ValaPostfixExpression* expr)
{
	ValaSymbolResolver * self;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (expr != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}


static void
vala_symbol_resolver_real_visit_object_creation_expression (ValaCodeVisitor* base,
                                                            ValaObjectCreationExpression* expr)
{
	ValaSymbolResolver * self;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (expr != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}


static void
vala_symbol_resolver_real_visit_sizeof_expression (ValaCodeVisitor* base,
                                                   ValaSizeofExpression* expr)
{
	ValaSymbolResolver * self;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (expr != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}


static void
vala_symbol_resolver_real_visit_typeof_expression (ValaCodeVisitor* base,
                                                   ValaTypeofExpression* expr)
{
	ValaSymbolResolver * self;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (expr != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}


static void
vala_symbol_resolver_real_visit_unary_expression (ValaCodeVisitor* base,
                                                  ValaUnaryExpression* expr)
{
	ValaSymbolResolver * self;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (expr != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}


static void
vala_symbol_resolver_real_visit_cast_expression (ValaCodeVisitor* base,
                                                 ValaCastExpression* expr)
{
	ValaSymbolResolver * self;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (expr != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}


static void
vala_symbol_resolver_real_visit_named_argument (ValaCodeVisitor* base,
                                                ValaNamedArgument* expr)
{
	ValaSymbolResolver * self;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (expr != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}


static void
vala_symbol_resolver_real_visit_addressof_expression (ValaCodeVisitor* base,
                                                      ValaAddressofExpression* expr)
{
	ValaSymbolResolver * self;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (expr != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}


static void
vala_symbol_resolver_real_visit_reference_transfer_expression (ValaCodeVisitor* base,
                                                               ValaReferenceTransferExpression* expr)
{
	ValaSymbolResolver * self;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (expr != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}


static void
vala_symbol_resolver_real_visit_binary_expression (ValaCodeVisitor* base,
                                                   ValaBinaryExpression* expr)
{
	ValaSymbolResolver * self;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (expr != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}


static void
vala_symbol_resolver_real_visit_type_check (ValaCodeVisitor* base,
                                            ValaTypeCheck* expr)
{
	ValaSymbolResolver * self;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (expr != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}


static void
vala_symbol_resolver_real_visit_conditional_expression (ValaCodeVisitor* base,
                                                        ValaConditionalExpression* expr)
{
	ValaSymbolResolver * self;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (expr != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}


static void
vala_symbol_resolver_real_visit_lambda_expression (ValaCodeVisitor* base,
                                                   ValaLambdaExpression* l)
{
	ValaSymbolResolver * self;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (l != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) l, (ValaCodeVisitor*) self);
}


static void
vala_symbol_resolver_real_visit_assignment (ValaCodeVisitor* base,
                                            ValaAssignment* a)
{
	ValaSymbolResolver * self;
	self = (ValaSymbolResolver*) base;
	g_return_if_fail (a != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) a, (ValaCodeVisitor*) self);
}


ValaSymbolResolver*
vala_symbol_resolver_construct (GType object_type)
{
	ValaSymbolResolver* self = NULL;
	self = (ValaSymbolResolver*) vala_code_visitor_construct (object_type);
	return self;
}


ValaSymbolResolver*
vala_symbol_resolver_new (void)
{
	return vala_symbol_resolver_construct (VALA_TYPE_SYMBOL_RESOLVER);
}


static void
vala_symbol_resolver_class_init (ValaSymbolResolverClass * klass)
{
	vala_symbol_resolver_parent_class = g_type_class_peek_parent (klass);
	((ValaCodeVisitorClass *) klass)->finalize = vala_symbol_resolver_finalize;
	g_type_class_add_private (klass, sizeof (ValaSymbolResolverPrivate));
	((ValaCodeVisitorClass *) klass)->visit_namespace = (void (*) (ValaCodeVisitor *, ValaNamespace*)) vala_symbol_resolver_real_visit_namespace;
	((ValaCodeVisitorClass *) klass)->visit_class = (void (*) (ValaCodeVisitor *, ValaClass*)) vala_symbol_resolver_real_visit_class;
	((ValaCodeVisitorClass *) klass)->visit_struct = (void (*) (ValaCodeVisitor *, ValaStruct*)) vala_symbol_resolver_real_visit_struct;
	((ValaCodeVisitorClass *) klass)->visit_interface = (void (*) (ValaCodeVisitor *, ValaInterface*)) vala_symbol_resolver_real_visit_interface;
	((ValaCodeVisitorClass *) klass)->visit_enum = (void (*) (ValaCodeVisitor *, ValaEnum*)) vala_symbol_resolver_real_visit_enum;
	((ValaCodeVisitorClass *) klass)->visit_error_domain = (void (*) (ValaCodeVisitor *, ValaErrorDomain*)) vala_symbol_resolver_real_visit_error_domain;
	((ValaCodeVisitorClass *) klass)->visit_delegate = (void (*) (ValaCodeVisitor *, ValaDelegate*)) vala_symbol_resolver_real_visit_delegate;
	((ValaCodeVisitorClass *) klass)->visit_constant = (void (*) (ValaCodeVisitor *, ValaConstant*)) vala_symbol_resolver_real_visit_constant;
	((ValaCodeVisitorClass *) klass)->visit_field = (void (*) (ValaCodeVisitor *, ValaField*)) vala_symbol_resolver_real_visit_field;
	((ValaCodeVisitorClass *) klass)->visit_method = (void (*) (ValaCodeVisitor *, ValaMethod*)) vala_symbol_resolver_real_visit_method;
	((ValaCodeVisitorClass *) klass)->visit_creation_method = (void (*) (ValaCodeVisitor *, ValaCreationMethod*)) vala_symbol_resolver_real_visit_creation_method;
	((ValaCodeVisitorClass *) klass)->visit_formal_parameter = (void (*) (ValaCodeVisitor *, ValaParameter*)) vala_symbol_resolver_real_visit_formal_parameter;
	((ValaCodeVisitorClass *) klass)->visit_property = (void (*) (ValaCodeVisitor *, ValaProperty*)) vala_symbol_resolver_real_visit_property;
	((ValaCodeVisitorClass *) klass)->visit_property_accessor = (void (*) (ValaCodeVisitor *, ValaPropertyAccessor*)) vala_symbol_resolver_real_visit_property_accessor;
	((ValaCodeVisitorClass *) klass)->visit_signal = (void (*) (ValaCodeVisitor *, ValaSignal*)) vala_symbol_resolver_real_visit_signal;
	((ValaCodeVisitorClass *) klass)->visit_constructor = (void (*) (ValaCodeVisitor *, ValaConstructor*)) vala_symbol_resolver_real_visit_constructor;
	((ValaCodeVisitorClass *) klass)->visit_destructor = (void (*) (ValaCodeVisitor *, ValaDestructor*)) vala_symbol_resolver_real_visit_destructor;
	((ValaCodeVisitorClass *) klass)->visit_block = (void (*) (ValaCodeVisitor *, ValaBlock*)) vala_symbol_resolver_real_visit_block;
	((ValaCodeVisitorClass *) klass)->visit_using_directive = (void (*) (ValaCodeVisitor *, ValaUsingDirective*)) vala_symbol_resolver_real_visit_using_directive;
	((ValaCodeVisitorClass *) klass)->visit_data_type = (void (*) (ValaCodeVisitor *, ValaDataType*)) vala_symbol_resolver_real_visit_data_type;
	((ValaCodeVisitorClass *) klass)->visit_declaration_statement = (void (*) (ValaCodeVisitor *, ValaDeclarationStatement*)) vala_symbol_resolver_real_visit_declaration_statement;
	((ValaCodeVisitorClass *) klass)->visit_local_variable = (void (*) (ValaCodeVisitor *, ValaLocalVariable*)) vala_symbol_resolver_real_visit_local_variable;
	((ValaCodeVisitorClass *) klass)->visit_initializer_list = (void (*) (ValaCodeVisitor *, ValaInitializerList*)) vala_symbol_resolver_real_visit_initializer_list;
	((ValaCodeVisitorClass *) klass)->visit_expression_statement = (void (*) (ValaCodeVisitor *, ValaExpressionStatement*)) vala_symbol_resolver_real_visit_expression_statement;
	((ValaCodeVisitorClass *) klass)->visit_if_statement = (void (*) (ValaCodeVisitor *, ValaIfStatement*)) vala_symbol_resolver_real_visit_if_statement;
	((ValaCodeVisitorClass *) klass)->visit_switch_statement = (void (*) (ValaCodeVisitor *, ValaSwitchStatement*)) vala_symbol_resolver_real_visit_switch_statement;
	((ValaCodeVisitorClass *) klass)->visit_switch_section = (void (*) (ValaCodeVisitor *, ValaSwitchSection*)) vala_symbol_resolver_real_visit_switch_section;
	((ValaCodeVisitorClass *) klass)->visit_switch_label = (void (*) (ValaCodeVisitor *, ValaSwitchLabel*)) vala_symbol_resolver_real_visit_switch_label;
	((ValaCodeVisitorClass *) klass)->visit_loop = (void (*) (ValaCodeVisitor *, ValaLoop*)) vala_symbol_resolver_real_visit_loop;
	((ValaCodeVisitorClass *) klass)->visit_while_statement = (void (*) (ValaCodeVisitor *, ValaWhileStatement*)) vala_symbol_resolver_real_visit_while_statement;
	((ValaCodeVisitorClass *) klass)->visit_do_statement = (void (*) (ValaCodeVisitor *, ValaDoStatement*)) vala_symbol_resolver_real_visit_do_statement;
	((ValaCodeVisitorClass *) klass)->visit_for_statement = (void (*) (ValaCodeVisitor *, ValaForStatement*)) vala_symbol_resolver_real_visit_for_statement;
	((ValaCodeVisitorClass *) klass)->visit_foreach_statement = (void (*) (ValaCodeVisitor *, ValaForeachStatement*)) vala_symbol_resolver_real_visit_foreach_statement;
	((ValaCodeVisitorClass *) klass)->visit_return_statement = (void (*) (ValaCodeVisitor *, ValaReturnStatement*)) vala_symbol_resolver_real_visit_return_statement;
	((ValaCodeVisitorClass *) klass)->visit_yield_statement = (void (*) (ValaCodeVisitor *, ValaYieldStatement*)) vala_symbol_resolver_real_visit_yield_statement;
	((ValaCodeVisitorClass *) klass)->visit_throw_statement = (void (*) (ValaCodeVisitor *, ValaThrowStatement*)) vala_symbol_resolver_real_visit_throw_statement;
	((ValaCodeVisitorClass *) klass)->visit_try_statement = (void (*) (ValaCodeVisitor *, ValaTryStatement*)) vala_symbol_resolver_real_visit_try_statement;
	((ValaCodeVisitorClass *) klass)->visit_delete_statement = (void (*) (ValaCodeVisitor *, ValaDeleteStatement*)) vala_symbol_resolver_real_visit_delete_statement;
	((ValaCodeVisitorClass *) klass)->visit_catch_clause = (void (*) (ValaCodeVisitor *, ValaCatchClause*)) vala_symbol_resolver_real_visit_catch_clause;
	((ValaCodeVisitorClass *) klass)->visit_array_creation_expression = (void (*) (ValaCodeVisitor *, ValaArrayCreationExpression*)) vala_symbol_resolver_real_visit_array_creation_expression;
	((ValaCodeVisitorClass *) klass)->visit_template = (void (*) (ValaCodeVisitor *, ValaTemplate*)) vala_symbol_resolver_real_visit_template;
	((ValaCodeVisitorClass *) klass)->visit_tuple = (void (*) (ValaCodeVisitor *, ValaTuple*)) vala_symbol_resolver_real_visit_tuple;
	((ValaCodeVisitorClass *) klass)->visit_member_access = (void (*) (ValaCodeVisitor *, ValaMemberAccess*)) vala_symbol_resolver_real_visit_member_access;
	((ValaCodeVisitorClass *) klass)->visit_method_call = (void (*) (ValaCodeVisitor *, ValaMethodCall*)) vala_symbol_resolver_real_visit_method_call;
	((ValaCodeVisitorClass *) klass)->visit_element_access = (void (*) (ValaCodeVisitor *, ValaElementAccess*)) vala_symbol_resolver_real_visit_element_access;
	((ValaCodeVisitorClass *) klass)->visit_slice_expression = (void (*) (ValaCodeVisitor *, ValaSliceExpression*)) vala_symbol_resolver_real_visit_slice_expression;
	((ValaCodeVisitorClass *) klass)->visit_postfix_expression = (void (*) (ValaCodeVisitor *, ValaPostfixExpression*)) vala_symbol_resolver_real_visit_postfix_expression;
	((ValaCodeVisitorClass *) klass)->visit_object_creation_expression = (void (*) (ValaCodeVisitor *, ValaObjectCreationExpression*)) vala_symbol_resolver_real_visit_object_creation_expression;
	((ValaCodeVisitorClass *) klass)->visit_sizeof_expression = (void (*) (ValaCodeVisitor *, ValaSizeofExpression*)) vala_symbol_resolver_real_visit_sizeof_expression;
	((ValaCodeVisitorClass *) klass)->visit_typeof_expression = (void (*) (ValaCodeVisitor *, ValaTypeofExpression*)) vala_symbol_resolver_real_visit_typeof_expression;
	((ValaCodeVisitorClass *) klass)->visit_unary_expression = (void (*) (ValaCodeVisitor *, ValaUnaryExpression*)) vala_symbol_resolver_real_visit_unary_expression;
	((ValaCodeVisitorClass *) klass)->visit_cast_expression = (void (*) (ValaCodeVisitor *, ValaCastExpression*)) vala_symbol_resolver_real_visit_cast_expression;
	((ValaCodeVisitorClass *) klass)->visit_named_argument = (void (*) (ValaCodeVisitor *, ValaNamedArgument*)) vala_symbol_resolver_real_visit_named_argument;
	((ValaCodeVisitorClass *) klass)->visit_addressof_expression = (void (*) (ValaCodeVisitor *, ValaAddressofExpression*)) vala_symbol_resolver_real_visit_addressof_expression;
	((ValaCodeVisitorClass *) klass)->visit_reference_transfer_expression = (void (*) (ValaCodeVisitor *, ValaReferenceTransferExpression*)) vala_symbol_resolver_real_visit_reference_transfer_expression;
	((ValaCodeVisitorClass *) klass)->visit_binary_expression = (void (*) (ValaCodeVisitor *, ValaBinaryExpression*)) vala_symbol_resolver_real_visit_binary_expression;
	((ValaCodeVisitorClass *) klass)->visit_type_check = (void (*) (ValaCodeVisitor *, ValaTypeCheck*)) vala_symbol_resolver_real_visit_type_check;
	((ValaCodeVisitorClass *) klass)->visit_conditional_expression = (void (*) (ValaCodeVisitor *, ValaConditionalExpression*)) vala_symbol_resolver_real_visit_conditional_expression;
	((ValaCodeVisitorClass *) klass)->visit_lambda_expression = (void (*) (ValaCodeVisitor *, ValaLambdaExpression*)) vala_symbol_resolver_real_visit_lambda_expression;
	((ValaCodeVisitorClass *) klass)->visit_assignment = (void (*) (ValaCodeVisitor *, ValaAssignment*)) vala_symbol_resolver_real_visit_assignment;
}


static void
vala_symbol_resolver_instance_init (ValaSymbolResolver * self)
{
	self->priv = VALA_SYMBOL_RESOLVER_GET_PRIVATE (self);
}


static void
vala_symbol_resolver_finalize (ValaCodeVisitor * obj)
{
	ValaSymbolResolver * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALA_TYPE_SYMBOL_RESOLVER, ValaSymbolResolver);
	_vala_code_context_unref0 (self->priv->context);
	_vala_code_node_unref0 (self->priv->root_symbol);
	_vala_scope_unref0 (self->priv->current_scope);
	VALA_CODE_VISITOR_CLASS (vala_symbol_resolver_parent_class)->finalize (obj);
}


/**
 * Code visitor resolving symbol names.
 */
GType
vala_symbol_resolver_get_type (void)
{
	static volatile gsize vala_symbol_resolver_type_id__volatile = 0;
	if (g_once_init_enter (&vala_symbol_resolver_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ValaSymbolResolverClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_symbol_resolver_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaSymbolResolver), 0, (GInstanceInitFunc) vala_symbol_resolver_instance_init, NULL };
		GType vala_symbol_resolver_type_id;
		vala_symbol_resolver_type_id = g_type_register_static (VALA_TYPE_CODE_VISITOR, "ValaSymbolResolver", &g_define_type_info, 0);
		g_once_init_leave (&vala_symbol_resolver_type_id__volatile, vala_symbol_resolver_type_id);
	}
	return vala_symbol_resolver_type_id__volatile;
}



