/* valavaluetype.c generated by valac, the Vala compiler
 * generated from valavaluetype.vala, do not modify */

/* valavaluetype.vala
 *
 * Copyright (C) 2007-2009  Jürg Billeter
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Jürg Billeter <j@bitron.ch>
 */


#include <glib.h>
#include <glib-object.h>
#include "vala.h"

#define _vala_code_node_unref0(var) ((var == NULL) ? NULL : (var = (vala_code_node_unref (var), NULL)))

struct _ValaValueTypePrivate {
	ValaTypeSymbol* _type_symbol;
};


static gpointer vala_value_type_parent_class = NULL;

#define VALA_VALUE_TYPE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALA_TYPE_VALUE_TYPE, ValaValueTypePrivate))
static gboolean vala_value_type_real_is_disposable (ValaDataType* base);
static gboolean vala_value_type_real_check (ValaCodeNode* base,
                                     ValaCodeContext* context);
static void vala_value_type_finalize (ValaCodeNode * obj);


ValaValueType*
vala_value_type_construct (GType object_type,
                           ValaTypeSymbol* type_symbol)
{
	ValaValueType* self = NULL;
	g_return_val_if_fail (type_symbol != NULL, NULL);
	self = (ValaValueType*) vala_data_type_construct (object_type);
	vala_value_type_set_type_symbol (self, type_symbol);
	vala_data_type_set_data_type ((ValaDataType*) self, type_symbol);
	return self;
}


static gpointer
_vala_code_node_ref0 (gpointer self)
{
	return self ? vala_code_node_ref (self) : NULL;
}


static gboolean
vala_value_type_real_is_disposable (ValaDataType* base)
{
	ValaValueType * self;
	gboolean result = FALSE;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	ValaStruct* st = NULL;
	ValaTypeSymbol* _tmp4_;
	ValaStruct* _tmp5_;
	ValaStruct* _tmp6_;
	self = (ValaValueType*) base;
	_tmp0_ = vala_data_type_get_value_owned ((ValaDataType*) self);
	_tmp1_ = _tmp0_;
	if (!_tmp1_) {
		result = FALSE;
		return result;
	}
	_tmp2_ = vala_data_type_get_nullable ((ValaDataType*) self);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		result = TRUE;
		return result;
	}
	_tmp4_ = self->priv->_type_symbol;
	_tmp5_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp4_, VALA_TYPE_STRUCT) ? ((ValaStruct*) _tmp4_) : NULL);
	st = _tmp5_;
	_tmp6_ = st;
	if (_tmp6_ != NULL) {
		ValaStruct* _tmp7_;
		_tmp7_ = st;
		result = vala_struct_is_disposable (_tmp7_);
		_vala_code_node_unref0 (st);
		return result;
	}
	result = FALSE;
	_vala_code_node_unref0 (st);
	return result;
}


static gboolean
vala_value_type_real_check (ValaCodeNode* base,
                            ValaCodeContext* context)
{
	ValaValueType * self;
	gboolean result = FALSE;
	ValaTypeSymbol* _tmp0_;
	self = (ValaValueType*) base;
	g_return_val_if_fail (context != NULL, FALSE);
	_tmp0_ = self->priv->_type_symbol;
	result = vala_code_node_check ((ValaCodeNode*) _tmp0_, context);
	return result;
}


ValaTypeSymbol*
vala_value_type_get_type_symbol (ValaValueType* self)
{
	ValaTypeSymbol* result;
	ValaTypeSymbol* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_type_symbol;
	result = _tmp0_;
	return result;
}


void
vala_value_type_set_type_symbol (ValaValueType* self,
                                 ValaTypeSymbol* value)
{
	g_return_if_fail (self != NULL);
	self->priv->_type_symbol = value;
}


static void
vala_value_type_class_init (ValaValueTypeClass * klass)
{
	vala_value_type_parent_class = g_type_class_peek_parent (klass);
	((ValaCodeNodeClass *) klass)->finalize = vala_value_type_finalize;
	g_type_class_add_private (klass, sizeof (ValaValueTypePrivate));
	((ValaDataTypeClass *) klass)->is_disposable = (gboolean (*) (ValaDataType *)) vala_value_type_real_is_disposable;
	((ValaCodeNodeClass *) klass)->check = (gboolean (*) (ValaCodeNode *, ValaCodeContext*)) vala_value_type_real_check;
}


static void
vala_value_type_instance_init (ValaValueType * self)
{
	self->priv = VALA_VALUE_TYPE_GET_PRIVATE (self);
}


static void
vala_value_type_finalize (ValaCodeNode * obj)
{
	ValaValueType * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALA_TYPE_VALUE_TYPE, ValaValueType);
	VALA_CODE_NODE_CLASS (vala_value_type_parent_class)->finalize (obj);
}


/**
 * A value type, i.e. a struct or an enum type.
 */
GType
vala_value_type_get_type (void)
{
	static volatile gsize vala_value_type_type_id__volatile = 0;
	if (g_once_init_enter (&vala_value_type_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ValaValueTypeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_value_type_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaValueType), 0, (GInstanceInitFunc) vala_value_type_instance_init, NULL };
		GType vala_value_type_type_id;
		vala_value_type_type_id = g_type_register_static (VALA_TYPE_DATA_TYPE, "ValaValueType", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&vala_value_type_type_id__volatile, vala_value_type_type_id);
	}
	return vala_value_type_type_id__volatile;
}



